# This is an automatically generated R code. Don't edit.
# Generated by 
# /home/sokol/.local/bin/ftbl2optR.py --tblimit 0 --ropts "TIMEIT=TRUE" e_coli_growth.ftbl
# at Fri Jul 24 11:03:04 2020.

# Copyright 2011-2020, INRAE, France.

# working dir
dirw="/home/sokol/insa/sysbio/dev/ftbl2sys/influx_si/test/tmp"

# installation dir (where influx_si/R/*.R live)
dirr="/home/sokol/.local/lib/python3.7/site-packages/influx_si/R"
# short base name of the FTBL (withount '.ftbl')
baseshort="e_coli_growth"

fcerr=file(file.path(dirw, sprintf("%s.err", baseshort)), "ab")
fclog=file(file.path(dirw, sprintf("%s.log", baseshort)), "ab")

options(warn=1)
options(digits.secs=2)

case_i=F

if (length(find("bitwAnd"))==0L) {
   suppressPackageStartupMessages(library(bitops))
   bitwAnd=bitAnd
}
source(file.path(dirr, "libs.R"))

# define matprod for simple_triplet_matrix
`%stm%` = slam::matprod_simple_triplet_matrix

# default options
version=FALSE
noopt=FALSE
noscale=FALSE
meth="nlsic"
fullsys=FALSE
emu=FALSE
irand=FALSE
sens=""
cupx=0.999
cupn=1.e3
cupp=1.e5
clownr=0
cinout=0
clowp=1.e-8
np=0
ln=FALSE
tikhreg=FALSE
sln=FALSE
lim=FALSE
zc=-.Machine$double.xmax
ffguess=FALSE
fdfit=FALSE
addnoise=FALSE
fseries=""
iseries=""
seed=-.Machine$integer.max
excl_outliers=FALSE
TIMEIT=FALSE
prof=FALSE
time_order="1"

# get runtime arguments
TIMEIT=TRUE

# synonymous
myver=version
optimize=!noopt
methods=trimws(strsplit(meth, ",")[[1L]])
sensitive=sens
least_norm=ln
initrand=irand

vernum="5.3.0"

# sanity check for command line parameters
if (substring(sensitive, 1, 3)=="mc=") {
   # read the mc iteration number
   nmc=as.integer(substring(sensitive, 4))
   sensitive="mc"
} else if (sensitive=="mc") {
   nmc=10
}
# cupx==0 means no upper limit => cupx=1
cupx=ifelse(cupx, cupx, 1)
if (cupx < 0 || cupx > 1) {
   stop_mes(paste("Option '--cupx N' must have N in the interval [0,1]
",
      "Instead, the value ", cupx, " si given.", sep=""), file=fcerr)
}
if (cinout < 0) {
   stop_mes(paste("Option '--cinout N' must have N non negative
",
      "Instead, the value ", cinout, " is given.", sep=""), file=fcerr)
}
# minimization method
validmethods=c("BFGS", "Nelder-Mead", "SANN", "ipopt", "nlsic", "pso")
if (! all(igood <- (methods %in% validmethods))) {
   cat(paste("Warning: optimization methods ", paste0(methods[!igood], collapse=", "), " are not implemented. 'nlsic' is used instead."), "\n", sep="", file=fcerr)
   methods[!igood]="nlsic"
}
if ("ipopt" %in% methods) {
   installed=suppressPackageStartupMessages(library(ipoptr, logical.return=TRUE))
   if (!installed) {
      stop_mes("An optimization method ipopt is requested but not available in this R installation", file=fcerr)
   }
}
if (least_norm && sln) {
   stop_mes("Options --ln and --sln cannot be activated simultaniously.", file=fcerr)
}

avaco=try(detectCores(), silent=TRUE)
if (inherits(avaco, "try-error")) {
   avaco=NULL
}
if (np > 0L && np < 1L) {
   np=round(avaco*np)
} else if (np >= 1L) {
   np=round(np)
} else {
   np=avaco
}
if (is.null(np) || np <= 0L) {
   np=1L
}
if (sensitive=="mc") {
   np=min(np, nmc)
}
options(mc.cores=np)

if (least_norm+tikhreg+lim > 1) {
   stop_mes("Options --ln, --lim and --tikhreg cannot be activated simultaneously. Use only one of them at a time.", file=fcerr)
}
lsi_fun=lsi
if (least_norm || sln) {
   lsi_fun=lsi_ln
} else if (tikhreg) {
   lsi_fun=lsi_reg
} else if (lim) {
   suppressPackageStartupMessages(library(limSolve));
   lsi_fun=lsi_lim
}
if (zc==-.Machine$double.xmax) {
   # no zero scrossing to apply
   zerocross=F
} else {
   if (zc < 0.) {
      stop_mes(paste("Zero crossing value ZC must be non negative, instead ", zc, " is given.", sep=""), file=fcerr)
   }
   zerocross=T
}
if (seed==-.Machine$integer.max) {
   # no seed to apply
   set_seed=F
} else {
   set_seed=T
   set.seed(seed)
}
time_order=gsub("\\s", "", time_order) # remove spaces if any
if (!(time_order %in% c("1", "2", "1,2"))) {
   stop_mes(sprintf("time_order must be '1', '2' or '1,2'. Instead got '%s'"))
}
opts=commandArgs()
# end command line argument proceeding

# get some cumomer tools
source(file.path(dirr, "opt_cumo_tools.R"))
#loadcmp(file.path(dirr, "opt_cumo_tools.Rc"))

lab_resid=cumo_resid
lab_sim=param2fl_x
jx_f=new.env()

if (TIMEIT) {
   cat("rinit   : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

# R profiling
if (prof) {
   Rprof(sprintf("%s.Rprof", baseshort))
}

nm_list=list()
nb_f=list()

if (TIMEIT) {
   cat("r_flux  : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

# fwd-rev flux names
nm_fwrv=c("fwd.CO2upt", "fwd.Cit_gr", "fwd.Fru6P_gr", "fwd.FruBP_gr", "fwd.Glc6P_gr", "fwd.Glucupt", "fwd.Glucupt_1", "fwd.Glucupt_U", "fwd.Gnt6P_gr", "fwd.HR1", "fwd.HR2", "fwd.HR3", "fwd.HR4", "fwd.HR5", "fwd.Mal_gr", "fwd.PEP_gr", "fwd.PGA_gr", "fwd.Rib5P_gr", "fwd.Rub5P_gr", "fwd.Suc_gr", "fwd.Xul5P_gr", "fwd.akgdh", "fwd.ald", "fwd.bs_DHAP", "fwd.bs_accoa", "fwd.bs_akg", "fwd.bs_e4p", "fwd.bs_fru6P", "fwd.bs_glc6P", "fwd.bs_oaa", "fwd.bs_pep", "fwd.bs_pga", "fwd.bs_pyr", "fwd.bs_rib5P", "fwd.citsynth", "fwd.edd", "fwd.eno", "fwd.fum_a", "fwd.fum_b", "fwd.gnd", "fwd.idh", "fwd.maldh", "fwd.out_Ac", "fwd.out_co2", "fwd.pdh", "fwd.pfk", "fwd.pgi", "fwd.pgk", "fwd.ppc", "fwd.pyk", "fwd.rib", "fwd.xul", "fwd.zwf", "rev.CO2upt", "rev.Cit_gr", "rev.Fru6P_gr", "rev.FruBP_gr", "rev.Glc6P_gr", "rev.Glucupt", "rev.Glucupt_1", "rev.Glucupt_U", "rev.Gnt6P_gr", "rev.HR1", "rev.HR2", "rev.HR3", "rev.HR4", "rev.HR5", "rev.Mal_gr", "rev.PEP_gr", "rev.PGA_gr", "rev.Rib5P_gr", "rev.Rub5P_gr", "rev.Suc_gr", "rev.Xul5P_gr", "rev.akgdh", "rev.ald", "rev.bs_DHAP", "rev.bs_accoa", "rev.bs_akg", "rev.bs_e4p", "rev.bs_fru6P", "rev.bs_glc6P", "rev.bs_oaa", "rev.bs_pep", "rev.bs_pga", "rev.bs_pyr", "rev.bs_rib5P", "rev.citsynth", "rev.edd", "rev.eno", "rev.fum_a", "rev.fum_b", "rev.gnd", "rev.idh", "rev.maldh", "rev.out_Ac", "rev.out_co2", "rev.pdh", "rev.pfk", "rev.pgi", "rev.pgk", "rev.ppc", "rev.pyk", "rev.rib", "rev.xul", "rev.zwf")

# edge to netflux name translator
edge2fl=c("f.n.Glucupt_1", "d.n.Glucupt_U", "d.n.Glucupt", "c.n.CO2upt", "f.n.pgi", "d.n.pfk", "d.n.ald", "d.n.ald", "d.n.ald", "d.n.pgk", "d.n.eno", "d.n.pyk", "d.n.zwf", "d.n.gnd", "d.n.gnd", "d.n.gnd", "d.n.rib", "d.n.xul", "f.n.edd", "f.n.edd", "f.n.edd", "d.n.HR1", "d.n.HR1", "d.n.HR1", "d.n.HR2", "d.n.HR2", "d.n.HR2", "d.n.HR3", "d.n.HR3", "d.n.HR3", "d.n.HR4", "d.n.HR4", "d.n.HR4", "d.n.HR5", "d.n.HR5", "d.n.HR5", "d.n.pdh", "d.n.pdh", "d.n.pdh", "d.n.citsynth", "d.n.citsynth", "d.n.citsynth", "d.n.idh", "d.n.idh", "d.n.idh", "d.n.akgdh", "d.n.akgdh", "d.n.akgdh", "d.n.fum_a", "d.n.fum_b", "d.n.maldh", "d.n.ppc", "d.n.ppc", "d.n.ppc", "c.n.bs_glc6P", "c.n.bs_fru6P", "c.n.bs_pga", "c.n.bs_DHAP", "c.n.bs_pyr", "c.n.bs_e4p", "c.n.bs_rib5P", "c.n.bs_pep", "c.n.bs_accoa", "c.n.bs_akg", "c.n.bs_oaa", "d.n.out_co2", "f.n.out_Ac", "g.n.Suc_gr", "g.n.Mal_gr", "g.n.PEP_gr", "g.n.PGA_gr", "g.n.Cit_gr", "g.n.Gnt6P_gr", "g.n.FruBP_gr", "g.n.Fru6P_gr", "g.n.Glc6P_gr", "g.n.Rub5P_gr", "c.n.Rib5P_gr", "g.n.Xul5P_gr")
names(edge2fl)=c("Gluc_1 (Glucupt_1) Glc", "Gluc_U (Glucupt_U) Glc", "Glc (Glucupt) Glc6P", "CO2_ext (CO2upt) CO2", "Glc6P (pgi) Fru6P", "Fru6P (pfk) FruBP", "FruBP (ald) ald", "ald (ald1) GA3P", "ald (ald2) GA3P", "GA3P (pgk) PGA", "PGA (eno) PEP", "PEP (pyk) Pyr", "Glc6P (zwf) Gnt6P", "Gnt6P (gnd) gnd", "gnd (gnd) CO2", "gnd (gnd) Rub5P", "Rub5P (rib) Rib5P", "Rub5P (xul) Xul5P", "Gnt6P (edd) edd", "edd (edd) Pyr", "edd (edd) GA3P", "GA3P (HR1) HR1", "E2 (HR1) HR1", "HR1 (HR1) Xul5P", "Fru6P (HR2) HR2", "HR2 (HR2) Ery4P", "HR2 (HR2) E2", "Fru6P (HR3) HR3", "HR3 (HR3) GA3P", "HR3 (HR3) E3", "Sed7P (HR4) HR4", "HR4 (HR4) Rib5P", "HR4 (HR4) E2", "Ery4P (HR5) HR5", "E3 (HR5) HR5", "HR5 (HR5) Sed7P", "Pyr (pdh) pdh", "pdh (pdh) AcCoA", "pdh (pdh) CO2", "AcCoA (citsynth) citsynth", "OAA (citsynth) citsynth", "citsynth (citsynth) Cit", "Cit (idh) idh", "idh (idh) AKG", "idh (idh) CO2", "AKG (akgdh) akgdh", "akgdh (akgdh) Suc", "akgdh (akgdh) CO2", "Suc (fum_a) Mal", "Suc (fum_b) Mal", "Mal (maldh) OAA", "PEP (ppc) ppc", "CO2 (ppc) ppc", "ppc (ppc) OAA", "Glc6P (bs_glc6P) BM_Glc6P", "Fru6P (bs_fru6P) BM_Fru6P", "PGA (bs_pga) BM_PGA", "GA3P (bs_DHAP) Glp", "Pyr (bs_pyr) BM_Pyr", "Ery4P (bs_e4p) BM_Ery4P", "Rib5P (bs_rib5P) BM_Rib5P", "PEP (bs_pep) BM_PEP", "AcCoA (bs_accoa) BM_AcCoA", "AKG (bs_akg) BM_AKG", "OAA (bs_oaa) BM_OAA", "CO2 (out_co2) CO2_out", "AcCoA (out_Ac) Acetate", "Suc (Suc_gr) Suc_gr", "Mal (Mal_gr) Mal_gr", "PEP (PEP_gr) PEP_gr", "PGA (PGA_gr) PGA_gr", "Cit (Cit_gr) Cit_gr", "Gnt6P (Gnt6P_gr) Gnt6P_gr", "FruBP (FruBP_gr) FruBP_gr", "Fru6P (Fru6P_gr) Fru6P_gr", "Glc6P (Glc6P_gr) Glc6P_gr", "Rub5P (Rub5P_gr) Rub5P_gr", "Rib5P (Rib5P_gr) Rib5P_gr", "Xul5P (Xul5P_gr) Xul5P_gr")

# initialize the linear system Afl*flnx=bfl (0-weight cumomers)
# unknown net flux names
nm_fln=c("d.n.Glucupt", "d.n.Glucupt_U", "d.n.HR1", "d.n.HR2", "d.n.HR3", "d.n.HR4", "d.n.HR5", "d.n.akgdh", "d.n.ald", "d.n.citsynth", "d.n.eno", "d.n.fum_a", "d.n.fum_b", "d.n.gnd", "d.n.idh", "d.n.maldh", "d.n.out_co2", "d.n.pdh", "d.n.pfk", "d.n.pgk", "d.n.ppc", "d.n.pyk", "d.n.rib", "d.n.xul", "d.n.zwf")
nb_fln=length(nm_fln)
fln=c(0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1, 0.0, 0.0, 0.1, 0.0, 1.21144, 0.0, 0.0, 0.4)
names(fln)=nm_fln
# unknown xch flux names
nm_flx=c("d.x.fum_b")
nb_flx=length(nm_flx)
flx=c(0.0)
names(flx)=nm_flx
nm_fl=c(nm_fln, nm_flx)
nb_fl=nb_fln+nb_flx
fl=c(fln, flx)
# gather flux names in a list
nm_list$flnx=nm_fl
nm_list$fwrv=nm_fwrv

# carbon length of metabolites
clen=c(6,6,6,6,1,1,6,6,3,3,3,3,6,5,5,5,2,4,3,7,2,4,6,5,4,4,6,6,3,3,3,4,5,3,2,5,4,1,2)
names(clen)=c("Gluc_1","Glc","Gluc_U","Glc6P","CO2_ext","CO2","Fru6P","FruBP","GA3P","PGA","PEP","Pyr","Gnt6P","Rub5P","Rib5P","Xul5P","E2","Ery4P","E3","Sed7P","AcCoA","OAA","Cit","AKG","Suc","Mal","BM_Glc6P","BM_Fru6P","BM_PGA","Glp","BM_Pyr","BM_Ery4P","BM_Rib5P","BM_PEP","BM_AcCoA","BM_AKG","BM_OAA","CO2_out","Acetate")

# metabolite pools are : all (poolall) which is divided in free (poolf) and
# constrained (poolc)

# constrained pool
poolc=c(1e-07)
nm_poolc=c("pc:Rib5P")
if (length(nm_poolc)) {
   names(nm_poolc)=substring(nm_poolc, 4)
}
names(poolc)=nm_poolc

# starting values for free pool (the same number and the same alphabetic order than free growth fluxes, if present)
poolf=c(0.001630397300073748, 0.00010006707551232429, 0.0004927839907571225, 0.0004905098655004916, 0.00014480899018442714, 0.0006054470296805187, 5.501298486110693e-05, 0.0005008619523631337, 5.172415742935172e-05, 0.0014849826568155515, 0.0002068966297174069)
nm_poolf=c("pf:Cit", "pf:Fru6P", "pf:FruBP", "pf:Glc6P", "pf:Gnt6P", "pf:Mal", "pf:PEP", "pf:PGA", "pf:Rub5P", "pf:Suc", "pf:Xul5P")
if (length(nm_poolf)) {
   names(nm_poolf)=substring(nm_poolf, 4)
}
names(poolf)=nm_poolf
nb_poolf=length(poolf)
nb_f$nb_poolf=nb_poolf

nm_poolall=c(nm_poolf, nm_poolc)
poolall=as.numeric(c(poolf, poolc))
names(poolall)=nm_poolall
pool=poolall
nm_list$poolf=nm_poolf
nm_list$poolc=nm_poolc
nm_list$poolall=nm_poolall

# flux matrix
nb_flr=26
if (nb_fl) {
   Afl=matrix(0, nrow=nb_flr, ncol=nb_fl)
   Afl[1, c(1, 2)]=c(-1.0, 1.0)
   Afl[2, c(1, 25)]=c(1.0, -1.0)
   Afl[3, c(8, 14, 15, 17, 18, 21)]=c(1.0, 1.0, 1.0, -1.0, 1.0, -1.0)
   Afl[4, c(4, 5, 19)]=c(-1.0, -1.0, -1.0)
   Afl[5, c(9, 19)]=c(-1.0, 1.0)
   Afl[6, c(3, 5, 9, 20)]=c(-1.0, 1.0, 2.0, -1.0)
   Afl[7, c(11, 20)]=c(-1.0, 1.0)
   Afl[8, c(11, 21, 22)]=c(1.0, -1.0, -1.0)
   Afl[9, c(18, 22)]=c(-1.0, 1.0)
   Afl[10, c(14, 25)]=c(-1.0, 1.0)
   Afl[11, c(14, 23, 24)]=c(1.0, -1.0, -1.0)
   Afl[12, c(6, 23)]=c(1.0, 1.0)
   Afl[13, c(3, 24)]=c(1.0, 1.0)
   Afl[14, c(3, 4, 6)]=c(-1.0, 1.0, 1.0)
   Afl[15, c(4, 7)]=c(1.0, -1.0)
   Afl[16, c(5, 7)]=c(1.0, -1.0)
   Afl[17, c(6, 7)]=c(-1.0, 1.0)
   Afl[18, c(10, 18)]=c(-1.0, 1.0)
   Afl[19, c(10, 16, 21)]=c(-1.0, 1.0, 1.0)
   Afl[20, c(10, 15)]=c(1.0, -1.0)
   Afl[21, c(8, 15)]=c(-1.0, 1.0)
   Afl[22, c(8, 12, 13)]=c(1.0, -1.0, -1.0)
   Afl[23, c(12, 13, 16)]=c(1.0, 1.0, -1.0)
   Afl[24, c(12, 13)]=c(1.0, -1.0)
   Afl[25, c(2)]=c(1.0)
   Afl[26, c(26)]=c(-1.0)
} else {
   Afl=matrix(0., nb_fl, nb_fl)
}
dimnames(Afl)=list(c("Glc", "Glc6P", "CO2", "Fru6P", "FruBP", "GA3P", "PGA", "PEP", "Pyr", "Gnt6P", "Rub5P", "Rib5P", "Xul5P", "E2", "Ery4P", "E3", "Sed7P", "AcCoA", "OAA", "Cit", "AKG", "Suc", "Mal", "eq net: fum_a-fum_b=0: 624", "eq net: Glucupt_1+Glucupt_U=1: 625", "eq xch: fum_a-fum_b=0: 633"), nm_fl)
#browser()
# prepare param (\Theta) vector
# order: free flux net, free flux xch, scale label, scale mass, scale peak
param=numeric(0)
nm_par=c()
# free net fluxes
nb_ffn=4
nm_ffn=c("f.n.Glucupt_1", "f.n.edd", "f.n.out_Ac", "f.n.pgi")
# starting values for iterations
param=c(param, c(0.8128, 0.1, 0.48, 0.1))
if (nb_ffn) {
   nm_par=c(nm_par, nm_ffn)
}
# free xch fluxes
nb_ffx=11
nm_ffx=c("f.x.HR2", "f.x.HR3", "f.x.HR5", "f.x.ald", "f.x.eno", "f.x.pfk", "f.x.pgi", "f.x.pgk", "f.x.ppc", "f.x.pyk", "f.x.xul")
# starting values for iterations
param=c(param, c(0.0151117, 0.14, 0.02, 0.4, 0.99, 0.01, 0.4, 0.99, 0.2, 0.4, 0.0))
if (nb_ffx) {
   nm_par=c(nm_par, nm_ffx)
}
names(param)=nm_par
ff=param
nm_ff=c(nm_ffn, nm_ffx)
nm_list$ff=nm_ff
nb_param=length(param)
# scaling factors are added to param later

nb_ff=nb_ffn+nb_ffx

# constrained fluxes
# net
nb_fcn=13
nm_fcn=c("c.n.CO2upt", "c.n.Rib5P_gr", "c.n.bs_DHAP", "c.n.bs_accoa", "c.n.bs_akg", "c.n.bs_e4p", "c.n.bs_fru6P", "c.n.bs_glc6P", "c.n.bs_oaa", "c.n.bs_pep", "c.n.bs_pga", "c.n.bs_pyr", "c.n.bs_rib5P")
fcn=c(0.77, 8e-08, 0.0083, 0.1895, 0.0692, 0.0247, 0.0045, 0.0132, 0.1146, 0.0461, 0.0958, 0.1818, 0.0576)
# xch
nb_fcx=30
nm_fcx=c("c.x.CO2upt", "c.x.Glucupt", "c.x.Glucupt_1", "c.x.Glucupt_U", "c.x.HR1", "c.x.HR4", "c.x.Rib5P_gr", "c.x.akgdh", "c.x.bs_DHAP", "c.x.bs_accoa", "c.x.bs_akg", "c.x.bs_e4p", "c.x.bs_fru6P", "c.x.bs_glc6P", "c.x.bs_oaa", "c.x.bs_pep", "c.x.bs_pga", "c.x.bs_pyr", "c.x.bs_rib5P", "c.x.citsynth", "c.x.edd", "c.x.fum_a", "c.x.gnd", "c.x.idh", "c.x.maldh", "c.x.out_Ac", "c.x.out_co2", "c.x.pdh", "c.x.rib", "c.x.zwf")
fcx=c(0.0, 0.0, 0.0, 0.0, 0.24, 0.04, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.01, 0.0, 0.0, 0.42, 0.0, 0.0, 0.01, 0.99, 0.0)
fc=c(fcn, fcx)
nm_fc=c(nm_fcn, nm_fcx)
names(fc)=nm_fc
nb_fc=nb_fcn+nb_fcx

# variable growth fluxes (constant are already accounted in constrained fluxes)
nb_fgr=11
nm_fgr=c("g.n.Cit_gr", "g.n.Fru6P_gr", "g.n.FruBP_gr", "g.n.Glc6P_gr", "g.n.Gnt6P_gr", "g.n.Mal_gr", "g.n.PEP_gr", "g.n.PGA_gr", "g.n.Rub5P_gr", "g.n.Suc_gr", "g.n.Xul5P_gr")
fgr=c(0.0013043178400589984, 8.005366040985944e-05, 0.000394227192605698, 0.00039240789240039327, 0.00011584719214754172, 0.000484357623744415, 4.401038788888554e-05, 0.00040068956189050697, 4.137932594348138e-05, 0.0011879861254524412, 0.0001655173037739255)
nm_list$fgr=nm_fgr
nb_f$nb_fgr=nb_fgr

# total flux vector fallnx dimension
nb_fallnx=nb_fl+nb_ff+nb_fc+nb_fgr+nb_fgr
nb_fwrv=nb_fallnx

# net dependent and free fluxes
nm_dfn=c(nm_fln, nm_ffn)
names(nm_dfn)=substring(nm_dfn, 5)

# all flux cardinals
nb_f=append(nb_f, list(nb_fln=nb_fln, nb_flx=nb_flx, nb_fl=nb_fl,
   nb_ffn=nb_ffn, nb_ffx=nb_ffx, nb_ff=nb_ff,
   nb_fcn=nb_fcn, nb_fcx=nb_fcx, nb_fc=nb_fc,
   nb_fallnx=nb_fallnx, nb_fwrv=nb_fwrv,
   nb_fgr=nb_fgr,
   include_growth_flux=TRUE,
   mu=0.8))

# prepare p2bfl, c2bfl, g2bfl, cnst2bfl matrices such that p2bfl%*%param[1:nb_ff]+
# c2bfl%*%fc+g2bfl%*%fgr+cnst2bfl=bfl
# replace f.[nx].flx by corresponding param coefficient
p2bfl=simple_triplet_zero_matrix(nrow=nb_flr, ncol=nb_ff)
# replace c.[nx].flx by corresponding fc coefficient
c2bfl=simple_triplet_zero_matrix(nrow=nb_flr, ncol=nb_fc)
# variable growth fluxes
g2bfl=simple_triplet_zero_matrix(nrow=nb_flr, ncol=nb_fgr)
cnst2bfl=numeric(nb_flr); # may be coming from equalities
colnames(p2bfl)=nm_par
colnames(c2bfl)=nm_fc
colnames(g2bfl)=nm_fgr

p2bfl[1, pmatch(c("f.n.Glucupt_1"), nm_par)]=c(-1.0);

p2bfl[2, pmatch(c("f.n.pgi"), nm_par)]=c(1.0);
c2bfl[2, pmatch(c("c.n.bs_glc6P"), nm_fc)]=c(1.0);
g2bfl[2, pmatch(c("g.n.Glc6P_gr"), nm_fgr)]=c(1.0);

c2bfl[3, pmatch(c("c.n.CO2upt"), nm_fc)]=c(-1.0);

p2bfl[4, pmatch(c("f.n.pgi"), nm_par)]=c(-1.0);
c2bfl[4, pmatch(c("c.n.bs_fru6P"), nm_fc)]=c(1.0);
g2bfl[4, pmatch(c("g.n.Fru6P_gr"), nm_fgr)]=c(1.0);

g2bfl[5, pmatch(c("g.n.FruBP_gr"), nm_fgr)]=c(1.0);

p2bfl[6, pmatch(c("f.n.edd"), nm_par)]=c(-1.0);
c2bfl[6, pmatch(c("c.n.bs_DHAP"), nm_fc)]=c(1.0);

c2bfl[7, pmatch(c("c.n.bs_pga"), nm_fc)]=c(1.0);
g2bfl[7, pmatch(c("g.n.PGA_gr"), nm_fgr)]=c(1.0);

c2bfl[8, pmatch(c("c.n.bs_pep"), nm_fc)]=c(1.0);
g2bfl[8, pmatch(c("g.n.PEP_gr"), nm_fgr)]=c(1.0);

p2bfl[9, pmatch(c("f.n.edd"), nm_par)]=c(-1.0);
c2bfl[9, pmatch(c("c.n.bs_pyr"), nm_fc)]=c(1.0);

p2bfl[10, pmatch(c("f.n.edd"), nm_par)]=c(1.0);
g2bfl[10, pmatch(c("g.n.Gnt6P_gr"), nm_fgr)]=c(1.0);

g2bfl[11, pmatch(c("g.n.Rub5P_gr"), nm_fgr)]=c(1.0);

c2bfl[12, pmatch(c("c.n.bs_rib5P", "c.n.Rib5P_gr"), nm_fc)]=c(1.0, 1.0);

g2bfl[13, pmatch(c("g.n.Xul5P_gr"), nm_fgr)]=c(1.0);

c2bfl[15, pmatch(c("c.n.bs_e4p"), nm_fc)]=c(1.0);

p2bfl[18, pmatch(c("f.n.out_Ac"), nm_par)]=c(1.0);
c2bfl[18, pmatch(c("c.n.bs_accoa"), nm_fc)]=c(1.0);

c2bfl[19, pmatch(c("c.n.bs_oaa"), nm_fc)]=c(1.0);

g2bfl[20, pmatch(c("g.n.Cit_gr"), nm_fgr)]=c(1.0);

c2bfl[21, pmatch(c("c.n.bs_akg"), nm_fc)]=c(1.0);

g2bfl[22, pmatch(c("g.n.Suc_gr"), nm_fgr)]=c(1.0);

g2bfl[23, pmatch(c("g.n.Mal_gr"), nm_fgr)]=c(1.0);


p2bfl[25, pmatch(c("f.n.Glucupt_1"), nm_par)]=c(-1.0);
cnst2bfl[25]=1;

c2bfl[26, pmatch(c("c.x.fum_a"), nm_fc)]=c(-1.0);

bp=as.numeric(c2bfl%stm%fc+cnst2bfl)

if (ffguess) {
   # make an automatic guess for free/dependent flux partition
   afd=as.matrix(cBind(Afl, -p2bfl))
   qafd=qr(afd, LAPACK=TRUE)
   d=abs(diag(qafd$qr))
   rank=sum(d > d[1]*1.e-10)
   qrow=qr(t(afd))
   rankr=qrow$rank
   if (rank != rankr) {
      mes="Weird error: column and row ranks are not equal.\n"
      stop_mes(mes, file=fcerr)
   }
   irows=qrow$pivot[seq_len(rankr)]
   if (rank==0) {
      stop_mes("Error: No free/dependent flux partition could be made. Stoechiometric matrix has rank=0.\n", file=fcerr)
   }
   Afl=afd[irows, qafd$pivot[1L:rank], drop=FALSE]
   ka=kappa(Afl)
   if (ka > 1.e7) {
      mes=sprintf("Error: No working free/dependent flux partition could be proposed. Stoechiometric matrix has condition number %g.\n", ka)
      stop_mes(mes, file=fcerr)
   }
   p2bfl=-as.simple_triplet_matrix(afd[irows, qafd$pivot[-seq_len(rank)], drop=FALSE])
   c2bfl=c2bfl[irows, , drop=FALSE]
   g2bfl=g2bfl[irows, , drop=FALSE]
   cnst2bfl=cnst2bfl[irows]
   bp=bp[irows]
   
   # replace names
   nm_fl=sub("f.", "d.", colnames(Afl), fixed=TRUE)
   colnames(Afl)=nm_fl # both net and xch
   nm_fln=sort(grep("^d.n.", nm_fl, v=TRUE))
   nm_flx=sort(grep("^d.x.", nm_fl, v=TRUE))
   nm_fl=c(nm_fln, nm_flx)
   Afl=Afl[, nm_fl, drop=FALSE]
   
   nm_ff=sub("d.", "f.", colnames(p2bfl), fixed=TRUE) # both net and xch
   colnames(p2bfl)=nm_ff
   nm_ffn=sort(grep("^f.n.", nm_ff, v=TRUE))
   nm_ffx=sort(grep("^f.x.", nm_ff, v=TRUE))
   nm_ff=c(nm_ffn, nm_ffx)
   p2bfl=p2bfl[, nm_ff, drop=FALSE]
   
   # remake param vector
   if (!fdfit)
      param=c(runif(length(nm_ff)), if (nb_ff == 0) param else param[-seq_len(nb_ff)])
   names(param)[seq(along=nm_ff)]=nm_ff
#browser()
}
nm_list$flnx=nm_fl
nm_fallnx=c(nm_fln, nm_ffn, nm_fcn, nm_fgr, nm_flx, nm_ffx, nm_fcx, sub(".n.", ".x.", nm_fgr, fixed=TRUE))
nm_list$fallnx=nm_fallnx
nm_net=c(nm_fln, nm_ffn, nm_fcn)
names(nm_net)=substring(nm_net, 5)
nm_xch=c(nm_flx, nm_ffx, nm_fcx)
names(nm_xch)=substring(nm_xch, 5)
edge2fl[]=nm_net[substring(edge2fl, 5)]
nm_list$ff=nm_ff

# accounting numbers
nb_flr=nrow(Afl)
nb_param=length(param)
nb_ffn=length(nm_ffn)
nb_ffx=length(nm_ffx)
nb_ff=nb_ffn+nb_ffx
nb_fln=length(nm_fln)
nb_flx=length(nm_flx)
nb_fl=nb_fln+nb_flx
nm_par=names(param)

for (item in c("nb_fln", "nb_flx", "nb_fl", "nb_ffn", "nb_ffx", "nb_ff")) {
   nb_f[item]=get(item)
}
# translation from n-x to fw-rv
sh_fwrv=substring(nm_fwrv[1:(nb_fwrv/2)], 5)
sh_nx=substring(nm_fallnx, 2)
nb_f$inet2ifwrv=pmatch(paste(".n.", sh_fwrv, sep=""), sh_nx)
nb_f$ixch2ifwrv=pmatch(paste(".x.", sh_fwrv, sep=""), sh_nx)
#nb_f$inet2ifwrv=sapply(nm_fwrv[1:(nb_fwrv/2)], function(f) grep(sprintf("^.\\.n\\.%s$", substring(f, 5)), nm_fallnx))
#nb_f$ixch2ifwrv=sapply(nm_fwrv[1:(nb_fwrv/2)], function(f) grep(sprintf("^.\\.x\\.%s$", substring(f, 5)), nm_fallnx))

if (TIMEIT) {
   cat("Afl qr(): ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

qrAfl=qr(Afl, LAPACK=TRUE)
d=abs(diag(qrAfl$qr))
qrAfl$rank=sum(d > d[1]*1.e-10)
rank=qrAfl$rank
aful=as.matrix(cBind(Afl, -p2bfl, -c2bfl))
qrow=qr(t(aful))
rankr=qrow$rank
#browser()
# first check the presence of lindep rows
if (nrow(Afl) > rankr) {
   prop=sprintf("Error: Among %d equations (rows), %d are redundant and must be eliminated by hand.\n", nrow(Afl), nrow(Afl)-rankr)
   prop=paste(prop, "Candidate(s) for elimination is (are):\n",
      paste(rownames(Afl)[qrow$pivot[-(1:rankr)]], sep="", collapse="\n"),
               "\n", sep="")
   stop_mes(prop, file=fcerr)
}
if (nrow(Afl) != rank || nrow(Afl) != ncol(Afl)) {
   #write.table(Afl)
   mes=NULL
   if (nrow(Afl) <= rank) {
      mes=paste("Candidate(s) for free or constrained flux(es):\n",
         paste(colnames(Afl)[-qrAfl$pivot[1L:nrow(Afl)]], collapse="\n"),
         "\nFor this choice, condition number of stoechiometric matrix will be ",
         kappa(Afl[,qrAfl$pivot[1L:nrow(Afl)],drop=FALSE]), "\n", sep="")
   } else if (nrow(Afl) > rank) {
      nextra=nrow(Afl)-rank
      comb=combn(c(nm_ffn, colnames(Afl)[-qrAfl$pivot[1L:rank]]), nextra)
      aextra=cBind(Afl[,-qrAfl$pivot[1L:rank],drop=FALSE], -p2bfl)
      colnames(aextra)=c(colnames(Afl)[-qrAfl$pivot[1L:rank]], colnames(p2bfl))
      ara=Afl[,qrAfl$pivot[1L:rank],drop=FALSE]
      i=which.min(apply(comb, 2, function(i) kappa(cBind(ara, aextra[,i]))))[1L]
      nm_tmp=comb[,i]
      ka=kappa(cBind(ara, aextra[,nm_tmp]))
      if (ka < 1.e7) {
         prop=paste("Proposal to declare dependent flux(es) is:\n",
            paste(nm_tmp, collapse="\n"), "\n", sep="")
         if (rank < ncol(Afl)) {
            prop=prop%s+%"While the following dependent flux(es) should be declared free or constrained:\n"%s+%join("\n", colnames(Afl)[-qrAfl$pivot[1L:rank]])%s+%"\n"
         }
         prop=paste(prop, "For this choice, condition number of stoechiometric matrix will be ", ka, "\n", sep="")
      } else {
         # add constraint fluxes to candidate list
         if (nb_fcn > 0) {
            aextra=as.matrix(cBind(Afl[,-qrAfl$pivot[1L:rank],drop=FALSE], -p2bfl, -c2bfl))
            colnames(aextra)=c(colnames(Afl)[-qrAfl$pivot[1L:rank]], colnames(p2bfl), colnames(c2bfl))
         }
         aextended=aful
         qae=qr(aextended, LAPACK=TRUE)
         d=abs(diag(qae$qr))
         ranke=sum(d > d[1L]*1.e-10)
         if (ranke == nrow(Afl)) {
            prop=paste("Proposal to declare dependent flux(es) is:\n",
            join("\n", colnames(aextended)[qae$pivot[1L:ranke]]), "\n",
            "while free and constrained fluxes should be:\n",
            join("\n", colnames(aextended)[-qae$pivot[1L:ranke]]), "\n",
            sep="")
            ka=kappa(aextended[,qae$pivot[1L:ranke]])
            prop=paste(prop, "For this choice, condition number of stoechiometric matrix will be ", ka, "\n", sep="")
         } else {
            prop="No proposal for partition dependent/free fluxes could be made.\n"
         }
      }
      mes=paste("There is (are) probably ", nextra,
         " extra free flux(es) among the following:\n",
         paste(nm_ffn, collapse="\n"), "\n",
         prop,
         sep="")
   }
   stop_mes(paste("Flux matrix is not square or is singular: (", nrow(Afl), "eq x ", ncol(Afl), "unk)\n",
      "You have to change your choice of free fluxes in the 'e_coli_growth.ftbl' file.\n",
      mes, sep=""), file=fcerr)
}

# make sure that free params choice leads to not singular matrix
if (qrAfl$rank != nb_fl) {
   #write.table(Afl)
   # make a suggestion of new free fluxes
   A=cBind(Afl, -p2bfl, -c2bfl)
   colnames(A)=c(colnames(Afl), nm_ff, nm_fc)
   qa=qr(A, LAPACK=TRUE)
   d=diag(qa$qr)
   qa$rank=sum(abs(d)>=abs(d[1]*1.e-10))
   
   mes=paste("Error: Dependent flux matrix is singular.\n",
      "Change your partition on free/dependent/constrained fluxes in the 'e_coli_growth.ftbl' file.\n",
      "Can not resolve dependent fluxe(s):\n",
      paste(colnames(Afl)[-qrAfl$pivot[(1:qrAfl$rank)]], collapse="\n"),
      sep="")
   if (qa$rank==nb_fl) {
      mes=paste(mes,
      "\n\nSuggested dependent fluxes:\n",
      paste(colnames(A)[qa$pivot[(1:qa$rank)]], collapse="\n"),
      "\n\nWhich would give the following free and constrained fluxes:\n",
      paste(colnames(A)[-qa$pivot[(1:qa$rank)]], collapse="\n"), "\n",
      sep="")
   } else {
      mes=paste(mes, "\nNo suggested free fluxes could be found", sep="")
   }
   stop_mes(mes, file=fcerr)
}

# inverse flux matrix
invAfl=solve(qrAfl)

if (fdfit) {
#browser()
   # choose free fluxe values such that they fit starting values from ftbl
   #dep=invAfl%*%(p2bfl%*%ff+bp)
   #ff=ff
   ff=qr.solve(rbind(invAfl%stm%p2bfl, diag(ncol(p2bfl))), c(fl-invAfl%*%bp, param))
}
# intermediate jacobian
if (TIMEIT) {
   cat("dfl_dffg: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

dfl_dffg=invAfl%stm%p2bfl
if (nb_fgr > 0L) {
   dfl_dffg=cBind(dfl_dffg, invAfl%stm%g2bfl)
}
dimnames(dfl_dffg)=list(nm_fl, c(nm_ff, nm_fgr))
dfl_dffg[abs(dfl_dffg) < 1.e-14]=0.
nb_f$dfl_dffg=as.simple_triplet_matrix(dfl_dffg)

# prepare mf, md, mc and mg matrices
# such that mf%*%ff+md%*%fl+mc%*%fc+mg%*%fgr gives fallnx
# here ff free fluxes (param), fl are dependent fluxes, fc are constrained
# fluxes and fgr are variable growth fluxes
mf=matrix(0., nb_fallnx, nb_ff)
dimnames(mf)=list(nm_fallnx, nm_ff)
md=matrix(0., nb_fallnx, nb_fl)
dimnames(md)=list(nm_fallnx, nm_fl)
mc=matrix(0., nb_fallnx, nb_fc)
dimnames(mc)=list(nm_fallnx, nm_fc)
mg=matrix(0., nb_fallnx, nb_fgr)
dimnames(mg)=list(nm_fallnx, nm_fgr)

if (nb_ff > 0) {
   mf[nm_ff, nm_ff]=diag(1., nb_ff)
}
if (nb_fl > 0) {
   md[nm_fl, nm_fl]=diag(1., nb_fl)
}
if (nb_fc > 0) {
   mc[nm_fc, nm_fc]=diag(1., nb_fc)
}
if (nb_fgr > 0) {
   mg[nm_fgr, nm_fgr]=diag(1., nb_fgr)
}

# sparse matrix static parts
# $varname fields:
#  ind_fa - flux index in a_pre$vfwrv[ind_fa]
#  a_pre - sparse matrix whose colsum() gives the a$v vector
#  prodx - dense matrix whose colprod() will give x[ind_x1]*x[ind_x2]*...
#  ind_fb - flux index in b_pre$v=fwrv[ind_fb1]*colprod(prodx)
#  ind_b - dense matrix of indexes for  b_pre$v=f[ind_b[,"indf"]*x[ind_b[,2+1]]*x[ind_b[,2+2]], ...]
#  b_pre - sparse matrix whose colsum gives b@x

#  a - unsigned sparse cumomer A matrix (off-diagonal part)
#  b - unsigned sparse vector of right hand side

if (TIMEIT) {
   cat("spAbr   : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

nb_fwrv=106
nb_w=7
spAbr=list()

if (TIMEIT) {
   cat("weight 1: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=1
nb_c=99
ba_x=128; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=0 # number of lighter cumomers
maxprod=1
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(45, 0, 0, 88, 0, 0, 45, 0, 70, 88, 0, 59, 45, 1, 1, 88, 1, 1, 45, 1, 71, 88, 1, 58, 38, 2, 2, 39, 2, 2, 95, 2, 2, 38, 2, 89, 39, 2, 92, 95, 2, 83, 38, 3, 3, 39, 3, 3, 95, 3, 3, 38, 3, 90, 39, 3, 91, 95, 3, 82, 38, 4, 4, 39, 4, 4, 95, 4, 4, 38, 4, 91, 39, 4, 90, 95, 4, 81, 38, 5, 5, 39, 5, 5, 95, 5, 5, 38, 5, 92, 39, 5, 89, 95, 5, 80, 37, 6, 6, 103, 6, 6, 102, 6, 6, 37, 6, 9, 103, 6, 70, 102, 6, 82, 37, 7, 7, 103, 7, 7, 102, 7, 7, 37, 7, 10, 103, 7, 71, 102, 7, 81, 37, 8, 8, 103, 8, 8, 102, 8, 8, 37, 8, 11, 103, 8, 72, 102, 8, 80, 48, 9, 9, 90, 9, 9, 48, 9, 73, 90, 9, 6, 48, 10, 10, 90, 10, 10, 48, 10, 74, 90, 10, 7, 48, 11, 11, 90, 11, 11, 48, 11, 75, 90, 11, 8, 53, 12, 12, 93, 12, 12, 89, 12, 12, 53, 12, 46, 93, 12, 41, 89, 12, 73, 53, 13, 13, 93, 13, 13, 89, 13, 13, 53, 13, 47, 93, 13, 42, 89, 13, 74, 53, 14, 14, 93, 14, 14, 89, 14, 14, 53, 14, 48, 93, 14, 43, 89, 14, 75, 53, 15, 15, 93, 15, 15, 89, 15, 15, 53, 15, 49, 93, 15, 44, 89, 15, 70, 53, 16, 16, 93, 16, 16, 89, 16, 16, 53, 16, 50, 93, 16, 45, 89, 16, 71, 53, 17, 17, 93, 17, 17, 89, 17, 17, 53, 17, 51, 93, 17, 64, 89, 17, 72, 14, 18, 18, 66, 18, 18, 14, 18, 76, 66, 18, 31, 14, 19, 19, 66, 19, 19, 14, 19, 77, 66, 19, 32, 14, 20, 20, 66, 20, 20, 14, 20, 78, 66, 20, 33, 14, 21, 21, 66, 21, 21, 14, 21, 79, 66, 21, 34, 14, 22, 22, 66, 22, 22, 14, 22, 67, 66, 22, 35, 14, 23, 23, 66, 23, 23, 14, 23, 68, 66, 23, 65, 14, 24, 24, 66, 24, 24, 14, 24, 69, 66, 24, 66, 46, 25, 25, 76, 25, 25, 46, 25, 52, 76, 25, 73, 46, 26, 26, 76, 26, 26, 46, 26, 53, 76, 26, 74, 46, 27, 27, 76, 27, 27, 46, 27, 54, 76, 27, 75, 46, 28, 28, 76, 28, 28, 46, 28, 55, 76, 28, 75, 46, 29, 29, 76, 29, 29, 46, 29, 56, 76, 29, 74, 46, 30, 30, 76, 30, 30, 46, 30, 57, 76, 30, 73, 51, 31, 31, 13, 31, 31, 51, 31, 41, 13, 31, 18, 51, 32, 32, 13, 32, 32, 51, 32, 42, 13, 32, 19, 51, 33, 33, 13, 33, 33, 51, 33, 43, 13, 33, 20, 51, 34, 34, 13, 34, 34, 51, 34, 44, 13, 34, 21, 51, 35, 35, 13, 35, 35, 51, 35, 45, 13, 35, 22, 52, 36, 36, 10, 36, 36, 52, 36, 41, 10, 36, 73, 52, 37, 37, 10, 37, 37, 52, 37, 42, 10, 37, 74, 52, 38, 38, 10, 38, 38, 52, 38, 43, 10, 38, 75, 52, 39, 39, 10, 39, 39, 52, 39, 44, 10, 39, 65, 52, 40, 40, 10, 40, 40, 52, 40, 45, 10, 40, 66, 40, 41, 41, 104, 41, 41, 105, 41, 41, 40, 41, 12, 104, 41, 31, 105, 41, 36, 40, 42, 42, 104, 42, 42, 105, 42, 42, 40, 42, 13, 104, 42, 32, 105, 42, 37, 40, 43, 43, 104, 43, 43, 105, 43, 43, 40, 43, 14, 104, 43, 33, 105, 43, 38, 40, 44, 44, 104, 44, 44, 105, 44, 44, 40, 44, 15, 104, 44, 34, 105, 44, 39, 40, 45, 45, 104, 45, 45, 105, 45, 45, 40, 45, 16, 104, 45, 35, 105, 45, 40, 6, 46, 46, 100, 46, 46, 106, 46, 46, 6, 46, 93, 100, 46, 52, 106, 46, 12, 6, 47, 47, 100, 47, 47, 106, 47, 47, 6, 47, 94, 100, 47, 53, 106, 47, 13, 6, 48, 48, 100, 48, 48, 106, 48, 48, 6, 48, 95, 100, 48, 54, 106, 48, 14, 6, 49, 49, 100, 49, 49, 106, 49, 49, 6, 49, 96, 100, 49, 55, 106, 49, 15, 6, 50, 50, 100, 50, 50, 106, 50, 50, 6, 50, 97, 100, 50, 56, 106, 50, 16, 6, 51, 51, 100, 51, 51, 106, 51, 51, 6, 51, 98, 100, 51, 57, 106, 51, 17, 47, 52, 52, 99, 52, 52, 64, 52, 52, 65, 52, 52, 47, 52, 46, 99, 52, 25, 64, 52, 76, 65, 52, 73, 47, 53, 53, 99, 53, 53, 64, 53, 53, 65, 53, 53, 47, 53, 47, 99, 53, 26, 64, 53, 77, 65, 53, 74, 47, 54, 54, 99, 54, 54, 64, 54, 54, 65, 54, 54, 47, 54, 48, 99, 54, 27, 64, 54, 78, 65, 54, 75, 47, 55, 55, 99, 55, 55, 64, 55, 55, 65, 55, 55, 47, 55, 49, 99, 55, 28, 64, 55, 79, 65, 55, 67, 47, 56, 56, 99, 56, 56, 64, 56, 56, 65, 56, 56, 47, 56, 50, 99, 56, 29, 64, 56, 65, 65, 56, 68, 47, 57, 57, 99, 57, 57, 64, 57, 57, 65, 57, 57, 47, 57, 51, 99, 57, 30, 64, 57, 66, 65, 57, 69, 35, 58, 58, 94, 58, 58, 35, 58, 1, 94, 58, 84, 35, 59, 59, 94, 59, 59, 35, 59, 0, 94, 59, 85, 35, 60, 60, 94, 60, 60, 35, 60, 80, 94, 60, 64, 35, 61, 61, 94, 61, 61, 35, 61, 81, 94, 61, 86, 35, 62, 62, 94, 62, 62, 35, 62, 82, 94, 62, 87, 35, 63, 63, 94, 63, 63, 35, 63, 83, 94, 63, 88, 40, 64, 64, 45, 64, 64, 41, 64, 64, 22, 64, 64, 102, 64, 64, 1, 64, 64, 40, 64, 17, 45, 64, 72, 41, 64, 60, 22, 64, 88, 102, 64, 83, 11, 65, 65, 13, 65, 65, 63, 65, 65, 11, 65, 56, 13, 65, 23, 63, 65, 39, 11, 66, 66, 13, 66, 66, 63, 66, 66, 11, 66, 57, 13, 66, 24, 63, 66, 40, 12, 67, 67, 67, 67, 67, 12, 67, 55, 67, 67, 22, 12, 68, 68, 67, 68, 68, 12, 68, 56, 67, 68, 23, 12, 69, 69, 67, 69, 69, 12, 69, 57, 67, 69, 24, 50, 70, 70, 36, 70, 70, 98, 70, 70, 50, 70, 6, 36, 70, 15, 98, 70, 0, 50, 71, 71, 36, 71, 71, 98, 71, 71, 50, 71, 7, 36, 71, 16, 98, 71, 1, 50, 72, 72, 36, 72, 72, 98, 72, 72, 50, 72, 8, 36, 72, 17, 98, 72, 64, 23, 73, 73, 23, 73, 73, 36, 73, 73, 12, 73, 73, 101, 73, 73, 63, 73, 73, 23, 73, 30, 23, 73, 25, 36, 73, 12, 12, 73, 52, 101, 73, 9, 63, 73, 36, 23, 74, 74, 23, 74, 74, 36, 74, 74, 12, 74, 74, 101, 74, 74, 63, 74, 74, 23, 74, 29, 23, 74, 26, 36, 74, 13, 12, 74, 53, 101, 74, 10, 63, 74, 37, 23, 75, 75, 23, 75, 75, 36, 75, 75, 12, 75, 75, 101, 75, 75, 63, 75, 75, 23, 75, 28, 23, 75, 27, 36, 75, 14, 12, 75, 54, 101, 75, 11, 63, 75, 38, 11, 76, 76, 67, 76, 76, 11, 76, 52, 67, 76, 18, 11, 77, 77, 67, 77, 77, 11, 77, 53, 67, 77, 19, 11, 78, 78, 67, 78, 78, 11, 78, 54, 67, 78, 20, 11, 79, 79, 67, 79, 79, 11, 79, 55, 67, 79, 21, 42, 80, 80, 49, 80, 80, 88, 80, 80, 42, 80, 5, 49, 80, 8, 88, 80, 60, 42, 81, 81, 49, 81, 81, 88, 81, 81, 42, 81, 4, 49, 81, 7, 88, 81, 61, 42, 82, 82, 49, 82, 82, 88, 82, 82, 42, 82, 3, 49, 82, 6, 88, 82, 62, 42, 83, 83, 49, 83, 83, 88, 83, 83, 42, 83, 2, 49, 83, 64, 88, 83, 63, 41, 84, 84, 75, 84, 84, 41, 84, 58, 75, 84, 89, 41, 85, 85, 75, 85, 85, 41, 85, 59, 75, 85, 90, 41, 86, 86, 75, 86, 86, 41, 86, 61, 75, 86, 91, 41, 87, 87, 75, 87, 87, 41, 87, 62, 75, 87, 92, 41, 88, 88, 75, 88, 88, 41, 88, 63, 75, 88, 64, 22, 89, 89, 91, 89, 89, 92, 89, 89, 22, 89, 84, 91, 89, 2, 92, 89, 5, 22, 90, 90, 91, 90, 90, 92, 90, 90, 22, 90, 85, 91, 90, 3, 92, 90, 4, 22, 91, 91, 91, 91, 91, 92, 91, 91, 22, 91, 86, 91, 91, 4, 92, 91, 3, 22, 92, 92, 91, 92, 92, 92, 92, 92, 22, 92, 87, 91, 92, 5, 92, 92, 2, 59, 93, 93, 7, 93, 93, 8, 93, 93, 59, 93, 46, 59, 94, 94, 7, 94, 94, 8, 94, 94, 59, 94, 47, 59, 95, 95, 7, 95, 95, 8, 95, 95, 59, 95, 48, 59, 96, 96, 7, 96, 96, 8, 96, 96, 59, 96, 49, 59, 97, 97, 7, 97, 97, 8, 97, 97, 59, 97, 50, 59, 98, 98, 7, 98, 98, 8, 98, 98, 59, 98, 51)), ncol=3, byrow=TRUE)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(1, 65, 116, 7, 94, 117, 8, 94, 118, 7, 95, 119, 8, 95, 120, 7, 96, 121, 8, 96, 122, 7, 97, 123, 8, 97, 124, 7, 98, 125, 8, 98, 126, 7, 99, 127, 8, 99, 128)), ncol=2+1, byrow=TRUE)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(1), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 2: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=2
nb_c=192
ba_x=128; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=99 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(45, 0, 0, 88, 0, 0, 45, 0, 143, 88, 0, 124, 38, 1, 1, 39, 1, 1, 95, 1, 1, 38, 1, 171, 39, 1, 176, 95, 1, 160, 38, 2, 2, 39, 2, 2, 95, 2, 2, 38, 2, 172, 39, 2, 175, 95, 2, 159, 38, 3, 3, 39, 3, 3, 95, 3, 3, 38, 3, 173, 39, 3, 173, 95, 3, 158, 38, 4, 4, 39, 4, 4, 95, 4, 4, 38, 4, 174, 39, 4, 174, 95, 4, 157, 38, 5, 5, 39, 5, 5, 95, 5, 5, 38, 5, 175, 39, 5, 172, 95, 5, 156, 38, 6, 6, 39, 6, 6, 95, 6, 6, 38, 6, 176, 39, 6, 171, 95, 6, 155, 37, 7, 7, 103, 7, 7, 102, 7, 7, 37, 7, 10, 103, 7, 143, 102, 7, 157, 37, 8, 8, 103, 8, 8, 102, 8, 8, 37, 8, 11, 103, 8, 144, 102, 8, 156, 37, 9, 9, 103, 9, 9, 102, 9, 9, 37, 9, 12, 103, 9, 145, 102, 9, 155, 48, 10, 10, 90, 10, 10, 48, 10, 146, 90, 10, 7, 48, 11, 11, 90, 11, 11, 48, 11, 147, 90, 11, 8, 48, 12, 12, 90, 12, 12, 48, 12, 148, 90, 12, 9, 53, 13, 13, 93, 13, 13, 89, 13, 13, 53, 13, 94, 93, 13, 84, 89, 13, 146, 53, 14, 14, 93, 14, 14, 89, 14, 14, 53, 14, 95, 93, 14, 85, 89, 14, 147, 53, 15, 15, 93, 15, 15, 89, 15, 15, 53, 15, 96, 93, 15, 86, 89, 15, 148, 53, 16, 16, 93, 16, 16, 89, 16, 16, 53, 16, 97, 93, 16, 87, 53, 17, 17, 93, 17, 17, 89, 17, 17, 53, 17, 98, 93, 17, 88, 53, 18, 18, 93, 18, 18, 89, 18, 18, 53, 18, 99, 93, 18, 89, 53, 19, 19, 93, 19, 19, 89, 19, 19, 53, 19, 100, 93, 19, 90, 53, 20, 20, 93, 20, 20, 89, 20, 20, 53, 20, 101, 93, 20, 91, 53, 21, 21, 93, 21, 21, 89, 21, 21, 53, 21, 102, 93, 21, 92, 53, 22, 22, 93, 22, 22, 89, 22, 22, 53, 22, 103, 93, 22, 93, 89, 22, 143, 53, 23, 23, 93, 23, 23, 89, 23, 23, 53, 23, 104, 53, 24, 24, 93, 24, 24, 89, 24, 24, 53, 24, 105, 53, 25, 25, 93, 25, 25, 89, 25, 25, 53, 25, 106, 53, 26, 26, 89, 26, 26, 93, 26, 26, 53, 26, 107, 89, 26, 144, 53, 27, 27, 89, 27, 27, 93, 27, 27, 53, 27, 108, 89, 27, 145, 14, 28, 28, 66, 28, 28, 14, 28, 149, 66, 28, 64, 14, 29, 29, 66, 29, 29, 14, 29, 150, 66, 29, 65, 14, 30, 30, 66, 30, 30, 14, 30, 151, 66, 30, 66, 14, 31, 31, 66, 31, 31, 14, 31, 152, 66, 31, 67, 14, 32, 32, 66, 32, 32, 14, 32, 153, 66, 32, 68, 14, 33, 33, 66, 33, 33, 14, 33, 154, 66, 33, 69, 66, 34, 34, 14, 34, 34, 66, 34, 70, 66, 35, 35, 14, 35, 35, 66, 35, 71, 66, 36, 36, 14, 36, 36, 66, 36, 72, 66, 37, 37, 14, 37, 37, 66, 37, 73, 14, 38, 38, 66, 38, 38, 14, 39, 39, 66, 39, 39, 14, 40, 40, 66, 40, 40, 14, 41, 41, 66, 41, 41, 14, 42, 42, 66, 42, 42, 14, 42, 140, 14, 43, 43, 66, 43, 43, 14, 44, 44, 66, 44, 44, 14, 45, 45, 66, 45, 45, 14, 46, 46, 66, 46, 46, 14, 47, 47, 66, 47, 47, 14, 47, 141, 14, 48, 48, 66, 48, 48, 14, 48, 142, 66, 48, 139, 46, 49, 49, 76, 49, 49, 46, 49, 109, 76, 49, 146, 46, 50, 50, 76, 50, 50, 46, 50, 110, 76, 50, 147, 46, 51, 51, 76, 51, 51, 46, 51, 111, 76, 51, 148, 46, 52, 52, 76, 52, 52, 46, 52, 112, 46, 53, 53, 76, 53, 53, 46, 53, 113, 46, 54, 54, 76, 54, 54, 46, 54, 114, 46, 55, 55, 76, 55, 55, 46, 55, 115, 46, 56, 56, 76, 56, 56, 46, 56, 116, 46, 57, 57, 76, 57, 57, 46, 57, 117, 46, 58, 58, 76, 58, 58, 46, 58, 118, 76, 58, 148, 46, 59, 59, 76, 59, 59, 46, 59, 119, 46, 60, 60, 76, 60, 60, 46, 60, 120, 46, 61, 61, 76, 61, 61, 46, 61, 121, 46, 62, 62, 76, 62, 62, 46, 62, 122, 76, 62, 147, 46, 63, 63, 76, 63, 63, 46, 63, 123, 76, 63, 146, 51, 64, 64, 13, 64, 64, 51, 64, 84, 13, 64, 28, 51, 65, 65, 13, 65, 65, 51, 65, 85, 13, 65, 29, 51, 66, 66, 13, 66, 66, 51, 66, 86, 13, 66, 30, 51, 67, 67, 13, 67, 67, 51, 67, 87, 13, 67, 31, 51, 68, 68, 13, 68, 68, 51, 68, 88, 13, 68, 32, 51, 69, 69, 13, 69, 69, 51, 69, 89, 13, 69, 33, 51, 70, 70, 13, 70, 70, 51, 70, 90, 13, 70, 34, 51, 71, 71, 13, 71, 71, 51, 71, 91, 13, 71, 35, 51, 72, 72, 13, 72, 72, 51, 72, 92, 13, 72, 36, 51, 73, 73, 13, 73, 73, 51, 73, 93, 13, 73, 37, 52, 74, 74, 10, 74, 74, 52, 74, 84, 10, 74, 146, 52, 75, 75, 10, 75, 75, 52, 75, 85, 10, 75, 147, 52, 76, 76, 10, 76, 76, 52, 76, 86, 10, 76, 148, 52, 77, 77, 10, 77, 77, 52, 77, 87, 52, 78, 78, 10, 78, 78, 52, 78, 88, 52, 79, 79, 10, 79, 79, 52, 79, 89, 52, 80, 80, 10, 80, 80, 52, 80, 90, 52, 81, 81, 10, 81, 81, 52, 81, 91, 52, 82, 82, 10, 82, 82, 52, 82, 92, 52, 83, 83, 10, 83, 83, 52, 83, 93, 10, 83, 139, 40, 84, 84, 104, 84, 84, 105, 84, 84, 40, 84, 13, 104, 84, 64, 105, 84, 74, 40, 85, 85, 104, 85, 85, 105, 85, 85, 40, 85, 14, 104, 85, 65, 105, 85, 75, 40, 86, 86, 104, 86, 86, 105, 86, 86, 40, 86, 15, 104, 86, 66, 105, 86, 76, 40, 87, 87, 104, 87, 87, 105, 87, 87, 40, 87, 16, 104, 87, 67, 105, 87, 77, 40, 88, 88, 104, 88, 88, 105, 88, 88, 40, 88, 17, 104, 88, 68, 105, 88, 78, 40, 89, 89, 104, 89, 89, 105, 89, 89, 40, 89, 18, 104, 89, 69, 105, 89, 79, 40, 90, 90, 104, 90, 90, 105, 90, 90, 40, 90, 19, 104, 90, 70, 105, 90, 80, 40, 91, 91, 104, 91, 91, 105, 91, 91, 40, 91, 20, 104, 91, 71, 105, 91, 81, 40, 92, 92, 104, 92, 92, 105, 92, 92, 40, 92, 21, 104, 92, 72, 105, 92, 82, 40, 93, 93, 104, 93, 93, 105, 93, 93, 40, 93, 22, 104, 93, 73, 105, 93, 83, 6, 94, 94, 100, 94, 94, 106, 94, 94, 6, 94, 177, 100, 94, 109, 106, 94, 13, 6, 95, 95, 100, 95, 95, 106, 95, 95, 6, 95, 178, 100, 95, 110, 106, 95, 14, 6, 96, 96, 100, 96, 96, 106, 96, 96, 6, 96, 179, 100, 96, 111, 106, 96, 15, 6, 97, 97, 100, 97, 97, 106, 97, 97, 6, 97, 180, 100, 97, 112, 106, 97, 16, 6, 98, 98, 100, 98, 98, 106, 98, 98, 6, 98, 181, 100, 98, 113, 106, 98, 17, 6, 99, 99, 100, 99, 99, 106, 99, 99, 6, 99, 182, 100, 99, 114, 106, 99, 18, 6, 100, 100, 100, 100, 100, 106, 100, 100, 6, 100, 183, 100, 100, 115, 106, 100, 19, 6, 101, 101, 100, 101, 101, 106, 101, 101, 6, 101, 184, 100, 101, 116, 106, 101, 20, 6, 102, 102, 100, 102, 102, 106, 102, 102, 6, 102, 185, 100, 102, 117, 106, 102, 21, 6, 103, 103, 100, 103, 103, 106, 103, 103, 6, 103, 186, 100, 103, 118, 106, 103, 22, 6, 104, 104, 100, 104, 104, 106, 104, 104, 6, 104, 187, 100, 104, 119, 106, 104, 23, 6, 105, 105, 100, 105, 105, 106, 105, 105, 6, 105, 188, 100, 105, 120, 106, 105, 24, 6, 106, 106, 100, 106, 106, 106, 106, 106, 6, 106, 189, 100, 106, 121, 106, 106, 25, 6, 107, 107, 100, 107, 107, 106, 107, 107, 6, 107, 190, 100, 107, 122, 106, 107, 26, 6, 108, 108, 100, 108, 108, 106, 108, 108, 6, 108, 191, 100, 108, 123, 106, 108, 27, 47, 109, 109, 99, 109, 109, 64, 109, 109, 65, 109, 109, 47, 109, 94, 99, 109, 49, 64, 109, 149, 65, 109, 146, 47, 110, 110, 99, 110, 110, 64, 110, 110, 65, 110, 110, 47, 110, 95, 99, 110, 50, 64, 110, 150, 65, 110, 147, 47, 111, 111, 99, 111, 111, 64, 111, 111, 65, 111, 111, 47, 111, 96, 99, 111, 51, 64, 111, 151, 65, 111, 148, 47, 112, 112, 99, 112, 112, 64, 112, 112, 65, 112, 112, 47, 112, 97, 99, 112, 52, 64, 112, 152, 47, 113, 113, 99, 113, 113, 64, 113, 113, 65, 113, 113, 47, 113, 98, 99, 113, 53, 64, 113, 153, 47, 114, 114, 99, 114, 114, 64, 114, 114, 65, 114, 114, 47, 114, 99, 99, 114, 54, 64, 114, 154, 47, 115, 115, 99, 115, 115, 64, 115, 115, 65, 115, 115, 47, 115, 100, 99, 115, 55, 47, 116, 116, 99, 116, 116, 64, 116, 116, 65, 116, 116, 47, 116, 101, 99, 116, 56, 47, 117, 117, 99, 117, 117, 64, 117, 117, 65, 117, 117, 47, 117, 102, 99, 117, 57, 47, 118, 118, 99, 118, 118, 65, 118, 118, 64, 118, 118, 47, 118, 103, 99, 118, 58, 65, 118, 140, 47, 119, 119, 99, 119, 119, 64, 119, 119, 65, 119, 119, 47, 119, 104, 99, 119, 59, 47, 120, 120, 99, 120, 120, 64, 120, 120, 65, 120, 120, 47, 120, 105, 99, 120, 60, 47, 121, 121, 99, 121, 121, 64, 121, 121, 65, 121, 121, 47, 121, 106, 99, 121, 61, 47, 122, 122, 99, 122, 122, 65, 122, 122, 64, 122, 122, 47, 122, 107, 99, 122, 62, 65, 122, 141, 47, 123, 123, 99, 123, 123, 64, 123, 123, 65, 123, 123, 47, 123, 108, 99, 123, 63, 64, 123, 139, 65, 123, 142, 35, 124, 124, 94, 124, 124, 35, 124, 0, 94, 124, 161, 35, 125, 125, 94, 125, 125, 94, 126, 126, 35, 126, 126, 94, 126, 162, 94, 127, 127, 35, 127, 127, 94, 127, 163, 94, 128, 128, 35, 128, 128, 94, 128, 164, 35, 129, 129, 94, 129, 129, 94, 130, 130, 35, 130, 130, 94, 130, 165, 94, 131, 131, 35, 131, 131, 94, 131, 166, 94, 132, 132, 35, 132, 132, 94, 132, 167, 35, 133, 133, 94, 133, 133, 35, 133, 155, 35, 134, 134, 94, 134, 134, 35, 134, 156, 35, 135, 135, 94, 135, 135, 35, 135, 158, 35, 136, 136, 94, 136, 136, 35, 136, 157, 94, 136, 168, 35, 137, 137, 94, 137, 137, 35, 137, 159, 94, 137, 169, 35, 138, 138, 94, 138, 138, 35, 138, 160, 94, 138, 170, 11, 139, 139, 13, 139, 139, 63, 139, 139, 11, 139, 123, 13, 139, 48, 63, 139, 83, 12, 140, 140, 67, 140, 140, 12, 140, 118, 67, 140, 42, 12, 141, 141, 67, 141, 141, 12, 141, 122, 67, 141, 47, 12, 142, 142, 67, 142, 142, 12, 142, 123, 67, 142, 48, 50, 143, 143, 36, 143, 143, 98, 143, 143, 50, 143, 7, 36, 143, 22, 98, 143, 0, 50, 144, 144, 36, 144, 144, 98, 144, 144, 50, 144, 8, 36, 144, 26, 50, 145, 145, 36, 145, 145, 98, 145, 145, 50, 145, 9, 36, 145, 27, 23, 146, 146, 23, 146, 146, 36, 146, 146, 12, 146, 146, 101, 146, 146, 63, 146, 146, 23, 146, 63, 23, 146, 49, 36, 146, 13, 12, 146, 109, 101, 146, 10, 63, 146, 74, 23, 147, 147, 23, 147, 147, 36, 147, 147, 12, 147, 147, 101, 147, 147, 63, 147, 147, 23, 147, 62, 23, 147, 50, 36, 147, 14, 12, 147, 110, 101, 147, 11, 63, 147, 75, 23, 148, 148, 23, 148, 148, 36, 148, 148, 12, 148, 148, 101, 148, 148, 63, 148, 148, 23, 148, 58, 23, 148, 51, 36, 148, 15, 12, 148, 111, 101, 148, 12, 63, 148, 76, 11, 149, 149, 67, 149, 149, 11, 149, 109, 67, 149, 28, 11, 150, 150, 67, 150, 150, 11, 150, 110, 67, 150, 29, 11, 151, 151, 67, 151, 151, 11, 151, 111, 67, 151, 30, 11, 152, 152, 67, 152, 152, 11, 152, 112, 67, 152, 31, 11, 153, 153, 67, 153, 153, 11, 153, 113, 67, 153, 32, 11, 154, 154, 67, 154, 154, 11, 154, 114, 67, 154, 33, 42, 155, 155, 49, 155, 155, 88, 155, 155, 42, 155, 6, 49, 155, 9, 88, 155, 133, 42, 156, 156, 49, 156, 156, 88, 156, 156, 42, 156, 5, 49, 156, 8, 88, 156, 134, 42, 157, 157, 49, 157, 157, 88, 157, 157, 42, 157, 4, 49, 157, 7, 88, 157, 136, 42, 158, 158, 88, 158, 158, 49, 158, 158, 42, 158, 3, 88, 158, 135, 42, 159, 159, 88, 159, 159, 49, 159, 159, 42, 159, 2, 88, 159, 137, 42, 160, 160, 88, 160, 160, 49, 160, 160, 42, 160, 1, 88, 160, 138, 41, 161, 161, 75, 161, 161, 41, 161, 124, 75, 161, 171, 41, 162, 162, 75, 162, 162, 41, 162, 126, 75, 162, 172, 41, 163, 163, 75, 163, 163, 41, 163, 127, 75, 163, 173, 41, 164, 164, 75, 164, 164, 41, 164, 128, 41, 165, 165, 75, 165, 165, 41, 165, 130, 75, 165, 174, 41, 166, 166, 75, 166, 166, 41, 166, 131, 75, 166, 175, 41, 167, 167, 75, 167, 167, 41, 167, 132, 41, 168, 168, 75, 168, 168, 41, 168, 136, 75, 168, 176, 41, 169, 169, 75, 169, 169, 41, 169, 137, 41, 170, 170, 75, 170, 170, 41, 170, 138, 22, 171, 171, 91, 171, 171, 92, 171, 171, 22, 171, 161, 91, 171, 1, 92, 171, 6, 22, 172, 172, 91, 172, 172, 92, 172, 172, 22, 172, 162, 91, 172, 2, 92, 172, 5, 22, 173, 173, 91, 173, 173, 92, 173, 173, 22, 173, 163, 91, 173, 3, 92, 173, 3, 22, 174, 174, 91, 174, 174, 92, 174, 174, 22, 174, 165, 91, 174, 4, 92, 174, 4, 22, 175, 175, 91, 175, 175, 92, 175, 175, 22, 175, 166, 91, 175, 5, 92, 175, 2, 22, 176, 176, 91, 176, 176, 92, 176, 176, 22, 176, 168, 91, 176, 6, 92, 176, 1, 59, 177, 177, 7, 177, 177, 8, 177, 177, 59, 177, 94, 59, 178, 178, 7, 178, 178, 8, 178, 178, 59, 178, 95, 59, 179, 179, 7, 179, 179, 8, 179, 179, 59, 179, 96, 59, 180, 180, 7, 180, 180, 8, 180, 180, 59, 180, 97, 59, 181, 181, 7, 181, 181, 8, 181, 181, 59, 181, 98, 59, 182, 182, 7, 182, 182, 8, 182, 182, 59, 182, 99, 59, 183, 183, 7, 183, 183, 8, 183, 183, 59, 183, 100, 59, 184, 184, 7, 184, 184, 8, 184, 184, 59, 184, 101, 59, 185, 185, 7, 185, 185, 8, 185, 185, 59, 185, 102, 59, 186, 186, 7, 186, 186, 8, 186, 186, 59, 186, 103, 59, 187, 187, 7, 187, 187, 8, 187, 187, 59, 187, 104, 59, 188, 188, 7, 188, 188, 8, 188, 188, 59, 188, 105, 59, 189, 189, 7, 189, 189, 8, 189, 189, 59, 189, 106, 59, 190, 190, 7, 190, 190, 8, 190, 190, 59, 190, 107, 59, 191, 191, 7, 191, 191, 8, 191, 191, 59, 191, 108)), ncol=3, byrow=TRUE)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(89, 17, 199, 202, 89, 18, 199, 203, 89, 19, 199, 204, 89, 20, 200, 202, 89, 21, 200, 203, 89, 22, 200, 204, 93, 24, 193, 170, 89, 24, 201, 202, 93, 25, 193, 171, 89, 25, 201, 203, 93, 26, 193, 172, 89, 26, 201, 204, 93, 27, 193, 173, 93, 28, 193, 174, 14, 35, 205, 196, 14, 36, 206, 196, 14, 37, 207, 196, 14, 38, 208, 196, 14, 39, 205, 197, 66, 39, 160, 194, 14, 40, 206, 197, 66, 40, 161, 194, 14, 41, 207, 197, 66, 41, 162, 194, 14, 42, 208, 197, 66, 42, 163, 194, 66, 43, 164, 194, 14, 44, 205, 198, 66, 44, 160, 195, 14, 45, 206, 198, 66, 45, 161, 195, 14, 46, 207, 198, 66, 46, 162, 195, 14, 47, 208, 198, 66, 47, 163, 195, 66, 48, 164, 195, 76, 53, 204, 202, 76, 54, 204, 203, 76, 55, 204, 204, 76, 56, 203, 202, 76, 57, 203, 203, 76, 58, 203, 204, 76, 60, 202, 202, 76, 61, 202, 203, 76, 62, 202, 204, 10, 78, 202, 194, 10, 79, 203, 194, 10, 80, 204, 194, 10, 81, 202, 195, 10, 82, 203, 195, 10, 83, 204, 195, 65, 113, 202, 196, 65, 114, 203, 196, 65, 115, 204, 196, 64, 116, 205, 194, 65, 116, 202, 197, 64, 117, 206, 194, 65, 117, 203, 197, 64, 118, 207, 194, 65, 118, 204, 197, 64, 119, 208, 194, 64, 120, 205, 195, 65, 120, 202, 198, 64, 121, 206, 195, 65, 121, 203, 198, 64, 122, 207, 195, 65, 122, 204, 198, 64, 123, 208, 195, 35, 126, 130, 209, 94, 126, 213, 193, 35, 127, 130, 210, 35, 128, 130, 211, 35, 129, 130, 212, 35, 130, 129, 209, 94, 130, 214, 193, 35, 131, 129, 210, 35, 132, 129, 211, 35, 133, 129, 212, 94, 134, 215, 193, 94, 135, 216, 193, 94, 136, 217, 193, 98, 145, 129, 193, 98, 146, 130, 193, 49, 159, 137, 193, 49, 160, 136, 193, 49, 161, 135, 193, 75, 165, 218, 193, 75, 168, 219, 193, 75, 170, 220, 193, 75, 171, 221, 193, 7, 178, 86, 1, 8, 178, 87, 1, 7, 179, 88, 1, 8, 179, 89, 1, 7, 180, 90, 1, 8, 180, 91, 1, 7, 181, 92, 1, 8, 181, 93, 1, 7, 182, 94, 1, 8, 182, 95, 1, 7, 183, 96, 1, 8, 183, 97, 1, 7, 184, 98, 1, 8, 184, 99, 1, 7, 185, 100, 1, 8, 185, 101, 1, 7, 186, 102, 1, 8, 186, 103, 1, 7, 187, 104, 1, 8, 187, 105, 1, 7, 188, 106, 1, 8, 188, 107, 1, 7, 189, 108, 1, 8, 189, 109, 1, 7, 190, 110, 1, 8, 190, 111, 1, 7, 191, 112, 1, 8, 191, 113, 1, 7, 192, 114, 1, 8, 192, 115, 1)), ncol=2+2, byrow=TRUE)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 3: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=3
nb_c=216
ba_x=128; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=291 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(38, 0, 0, 39, 0, 0, 95, 0, 0, 38, 0, 192, 39, 0, 195, 95, 0, 181, 38, 1, 1, 39, 1, 1, 95, 1, 1, 38, 1, 193, 39, 1, 194, 95, 1, 180, 38, 2, 2, 39, 2, 2, 95, 2, 2, 38, 2, 194, 39, 2, 193, 95, 2, 179, 38, 3, 3, 39, 3, 3, 95, 3, 3, 38, 3, 195, 39, 3, 192, 95, 3, 178, 37, 4, 4, 103, 4, 4, 102, 4, 4, 37, 4, 5, 103, 4, 172, 102, 4, 178, 48, 5, 5, 90, 5, 5, 48, 5, 173, 90, 5, 4, 53, 6, 6, 93, 6, 6, 89, 6, 6, 53, 6, 111, 93, 6, 101, 89, 6, 173, 53, 7, 7, 93, 7, 7, 89, 7, 7, 53, 7, 112, 93, 7, 102, 53, 8, 8, 93, 8, 8, 89, 8, 8, 53, 8, 113, 93, 8, 103, 53, 9, 9, 93, 9, 9, 89, 9, 9, 53, 9, 114, 93, 9, 104, 53, 10, 10, 93, 10, 10, 89, 10, 10, 53, 10, 115, 93, 10, 105, 53, 11, 11, 93, 11, 11, 89, 11, 11, 53, 11, 116, 93, 11, 106, 53, 12, 12, 93, 12, 12, 89, 12, 12, 53, 12, 117, 93, 12, 107, 53, 13, 13, 93, 13, 13, 89, 13, 13, 53, 13, 118, 93, 13, 108, 53, 14, 14, 93, 14, 14, 89, 14, 14, 53, 14, 119, 93, 14, 109, 53, 15, 15, 93, 15, 15, 89, 15, 15, 53, 15, 120, 93, 15, 110, 53, 16, 16, 93, 16, 16, 89, 16, 16, 53, 16, 121, 53, 17, 17, 93, 17, 17, 89, 17, 17, 53, 17, 122, 53, 18, 18, 93, 18, 18, 89, 18, 18, 53, 18, 123, 53, 19, 19, 93, 19, 19, 89, 19, 19, 53, 19, 124, 53, 20, 20, 93, 20, 20, 89, 20, 20, 53, 20, 125, 53, 21, 21, 93, 21, 21, 89, 21, 21, 53, 21, 126, 53, 22, 22, 93, 22, 22, 89, 22, 22, 53, 22, 127, 53, 23, 23, 93, 23, 23, 89, 23, 23, 53, 23, 128, 53, 24, 24, 93, 24, 24, 89, 24, 24, 53, 24, 129, 53, 25, 25, 89, 25, 25, 93, 25, 25, 53, 25, 130, 89, 25, 172, 14, 26, 26, 66, 26, 26, 14, 26, 174, 66, 26, 81, 14, 27, 27, 66, 27, 27, 14, 27, 175, 66, 27, 82, 14, 28, 28, 66, 28, 28, 14, 28, 176, 66, 28, 83, 14, 29, 29, 66, 29, 29, 14, 29, 177, 66, 29, 84, 66, 30, 30, 14, 30, 30, 66, 30, 85, 66, 31, 31, 14, 31, 31, 66, 31, 86, 66, 32, 32, 14, 32, 32, 66, 32, 87, 66, 33, 33, 14, 33, 33, 66, 33, 88, 66, 34, 34, 14, 34, 34, 66, 34, 89, 66, 35, 35, 14, 35, 35, 66, 35, 90, 14, 36, 36, 66, 36, 36, 14, 37, 37, 66, 37, 37, 14, 38, 38, 66, 38, 38, 14, 39, 39, 66, 39, 39, 14, 40, 40, 66, 40, 40, 14, 41, 41, 66, 41, 41, 14, 42, 42, 66, 42, 42, 14, 43, 43, 66, 43, 43, 14, 44, 44, 66, 44, 44, 14, 45, 45, 66, 45, 45, 14, 46, 46, 66, 46, 46, 14, 47, 47, 66, 47, 47, 14, 48, 48, 66, 48, 48, 14, 49, 49, 66, 49, 49, 14, 50, 50, 66, 50, 50, 14, 51, 51, 66, 51, 51, 14, 52, 52, 66, 52, 52, 14, 53, 53, 66, 53, 53, 14, 54, 54, 66, 54, 54, 14, 55, 55, 66, 55, 55, 14, 56, 56, 66, 56, 56, 14, 57, 57, 66, 57, 57, 14, 58, 58, 66, 58, 58, 14, 59, 59, 66, 59, 59, 14, 60, 60, 66, 60, 60, 14, 60, 171, 46, 61, 61, 76, 61, 61, 46, 61, 131, 76, 61, 173, 46, 62, 62, 76, 62, 62, 46, 62, 132, 46, 63, 63, 76, 63, 63, 46, 63, 133, 46, 64, 64, 76, 64, 64, 46, 64, 134, 46, 65, 65, 76, 65, 65, 46, 65, 135, 46, 66, 66, 76, 66, 66, 46, 66, 136, 46, 67, 67, 76, 67, 67, 46, 67, 137, 46, 68, 68, 76, 68, 68, 46, 68, 138, 46, 69, 69, 76, 69, 69, 46, 69, 139, 46, 70, 70, 76, 70, 70, 46, 70, 140, 46, 71, 71, 76, 71, 71, 46, 71, 141, 46, 72, 72, 76, 72, 72, 46, 72, 142, 46, 73, 73, 76, 73, 73, 46, 73, 143, 46, 74, 74, 76, 74, 74, 46, 74, 144, 46, 75, 75, 76, 75, 75, 46, 75, 145, 46, 76, 76, 76, 76, 76, 46, 76, 146, 46, 77, 77, 76, 77, 77, 46, 77, 147, 46, 78, 78, 76, 78, 78, 46, 78, 148, 46, 79, 79, 76, 79, 79, 46, 79, 149, 46, 80, 80, 76, 80, 80, 46, 80, 150, 76, 80, 173, 51, 81, 81, 13, 81, 81, 51, 81, 101, 13, 81, 26, 51, 82, 82, 13, 82, 82, 51, 82, 102, 13, 82, 27, 51, 83, 83, 13, 83, 83, 51, 83, 103, 13, 83, 28, 51, 84, 84, 13, 84, 84, 51, 84, 104, 13, 84, 29, 51, 85, 85, 13, 85, 85, 51, 85, 105, 13, 85, 30, 51, 86, 86, 13, 86, 86, 51, 86, 106, 13, 86, 31, 51, 87, 87, 13, 87, 87, 51, 87, 107, 13, 87, 32, 51, 88, 88, 13, 88, 88, 51, 88, 108, 13, 88, 33, 51, 89, 89, 13, 89, 89, 51, 89, 109, 13, 89, 34, 51, 90, 90, 13, 90, 90, 51, 90, 110, 13, 90, 35, 52, 91, 91, 10, 91, 91, 52, 91, 101, 10, 91, 173, 52, 92, 92, 10, 92, 92, 52, 92, 102, 52, 93, 93, 10, 93, 93, 52, 93, 103, 52, 94, 94, 10, 94, 94, 52, 94, 104, 52, 95, 95, 10, 95, 95, 52, 95, 105, 52, 96, 96, 10, 96, 96, 52, 96, 106, 52, 97, 97, 10, 97, 97, 52, 97, 107, 52, 98, 98, 10, 98, 98, 52, 98, 108, 52, 99, 99, 10, 99, 99, 52, 99, 109, 52, 100, 100, 10, 100, 100, 52, 100, 110, 40, 101, 101, 104, 101, 101, 105, 101, 101, 40, 101, 6, 104, 101, 81, 105, 101, 91, 40, 102, 102, 104, 102, 102, 105, 102, 102, 40, 102, 7, 104, 102, 82, 105, 102, 92, 40, 103, 103, 104, 103, 103, 105, 103, 103, 40, 103, 8, 104, 103, 83, 105, 103, 93, 40, 104, 104, 104, 104, 104, 105, 104, 104, 40, 104, 9, 104, 104, 84, 105, 104, 94, 40, 105, 105, 104, 105, 105, 105, 105, 105, 40, 105, 10, 104, 105, 85, 105, 105, 95, 40, 106, 106, 104, 106, 106, 105, 106, 106, 40, 106, 11, 104, 106, 86, 105, 106, 96, 40, 107, 107, 104, 107, 107, 105, 107, 107, 40, 107, 12, 104, 107, 87, 105, 107, 97, 40, 108, 108, 104, 108, 108, 105, 108, 108, 40, 108, 13, 104, 108, 88, 105, 108, 98, 40, 109, 109, 104, 109, 109, 105, 109, 109, 40, 109, 14, 104, 109, 89, 105, 109, 99, 40, 110, 110, 104, 110, 110, 105, 110, 110, 40, 110, 15, 104, 110, 90, 105, 110, 100, 6, 111, 111, 100, 111, 111, 106, 111, 111, 6, 111, 196, 100, 111, 131, 106, 111, 6, 6, 112, 112, 100, 112, 112, 106, 112, 112, 6, 112, 197, 100, 112, 132, 106, 112, 7, 6, 113, 113, 100, 113, 113, 106, 113, 113, 6, 113, 198, 100, 113, 133, 106, 113, 8, 6, 114, 114, 100, 114, 114, 106, 114, 114, 6, 114, 199, 100, 114, 134, 106, 114, 9, 6, 115, 115, 100, 115, 115, 106, 115, 115, 6, 115, 200, 100, 115, 135, 106, 115, 10, 6, 116, 116, 100, 116, 116, 106, 116, 116, 6, 116, 201, 100, 116, 136, 106, 116, 11, 6, 117, 117, 100, 117, 117, 106, 117, 117, 6, 117, 202, 100, 117, 137, 106, 117, 12, 6, 118, 118, 100, 118, 118, 106, 118, 118, 6, 118, 203, 100, 118, 138, 106, 118, 13, 6, 119, 119, 100, 119, 119, 106, 119, 119, 6, 119, 204, 100, 119, 139, 106, 119, 14, 6, 120, 120, 100, 120, 120, 106, 120, 120, 6, 120, 205, 100, 120, 140, 106, 120, 15, 6, 121, 121, 100, 121, 121, 106, 121, 121, 6, 121, 206, 100, 121, 141, 106, 121, 16, 6, 122, 122, 100, 122, 122, 106, 122, 122, 6, 122, 207, 100, 122, 142, 106, 122, 17, 6, 123, 123, 100, 123, 123, 106, 123, 123, 6, 123, 208, 100, 123, 143, 106, 123, 18, 6, 124, 124, 100, 124, 124, 106, 124, 124, 6, 124, 209, 100, 124, 144, 106, 124, 19, 6, 125, 125, 100, 125, 125, 106, 125, 125, 6, 125, 210, 100, 125, 145, 106, 125, 20, 6, 126, 126, 100, 126, 126, 106, 126, 126, 6, 126, 211, 100, 126, 146, 106, 126, 21, 6, 127, 127, 100, 127, 127, 106, 127, 127, 6, 127, 212, 100, 127, 147, 106, 127, 22, 6, 128, 128, 100, 128, 128, 106, 128, 128, 6, 128, 213, 100, 128, 148, 106, 128, 23, 6, 129, 129, 100, 129, 129, 106, 129, 129, 6, 129, 214, 100, 129, 149, 106, 129, 24, 6, 130, 130, 100, 130, 130, 106, 130, 130, 6, 130, 215, 100, 130, 150, 106, 130, 25, 47, 131, 131, 99, 131, 131, 64, 131, 131, 65, 131, 131, 47, 131, 111, 99, 131, 61, 64, 131, 174, 65, 131, 173, 47, 132, 132, 99, 132, 132, 64, 132, 132, 65, 132, 132, 47, 132, 112, 99, 132, 62, 64, 132, 175, 47, 133, 133, 99, 133, 133, 64, 133, 133, 65, 133, 133, 47, 133, 113, 99, 133, 63, 64, 133, 176, 47, 134, 134, 99, 134, 134, 64, 134, 134, 65, 134, 134, 47, 134, 114, 99, 134, 64, 64, 134, 177, 47, 135, 135, 99, 135, 135, 64, 135, 135, 65, 135, 135, 47, 135, 115, 99, 135, 65, 47, 136, 136, 99, 136, 136, 64, 136, 136, 65, 136, 136, 47, 136, 116, 99, 136, 66, 47, 137, 137, 99, 137, 137, 64, 137, 137, 65, 137, 137, 47, 137, 117, 99, 137, 67, 47, 138, 138, 99, 138, 138, 64, 138, 138, 65, 138, 138, 47, 138, 118, 99, 138, 68, 47, 139, 139, 99, 139, 139, 64, 139, 139, 65, 139, 139, 47, 139, 119, 99, 139, 69, 47, 140, 140, 99, 140, 140, 64, 140, 140, 65, 140, 140, 47, 140, 120, 99, 140, 70, 47, 141, 141, 99, 141, 141, 64, 141, 141, 65, 141, 141, 47, 141, 121, 99, 141, 71, 47, 142, 142, 99, 142, 142, 64, 142, 142, 65, 142, 142, 47, 142, 122, 99, 142, 72, 47, 143, 143, 99, 143, 143, 64, 143, 143, 65, 143, 143, 47, 143, 123, 99, 143, 73, 47, 144, 144, 99, 144, 144, 64, 144, 144, 65, 144, 144, 47, 144, 124, 99, 144, 74, 47, 145, 145, 99, 145, 145, 64, 145, 145, 65, 145, 145, 47, 145, 125, 99, 145, 75, 47, 146, 146, 99, 146, 146, 64, 146, 146, 65, 146, 146, 47, 146, 126, 99, 146, 76, 47, 147, 147, 99, 147, 147, 64, 147, 147, 65, 147, 147, 47, 147, 127, 99, 147, 77, 47, 148, 148, 99, 148, 148, 64, 148, 148, 65, 148, 148, 47, 148, 128, 99, 148, 78, 47, 149, 149, 99, 149, 149, 64, 149, 149, 65, 149, 149, 47, 149, 129, 99, 149, 79, 47, 150, 150, 99, 150, 150, 65, 150, 150, 64, 150, 150, 47, 150, 130, 99, 150, 80, 65, 150, 171, 35, 151, 151, 94, 151, 151, 94, 152, 152, 35, 152, 152, 94, 152, 182, 35, 153, 153, 94, 153, 153, 94, 154, 154, 35, 154, 154, 94, 154, 183, 35, 155, 155, 94, 155, 155, 94, 156, 156, 35, 156, 156, 94, 156, 184, 94, 157, 157, 35, 157, 157, 94, 157, 185, 35, 158, 158, 94, 158, 158, 94, 159, 159, 35, 159, 159, 94, 159, 186, 94, 160, 160, 35, 160, 160, 94, 160, 187, 35, 161, 161, 94, 161, 161, 35, 162, 162, 94, 162, 162, 94, 163, 163, 35, 163, 163, 94, 163, 188, 35, 164, 164, 94, 164, 164, 94, 165, 165, 35, 165, 165, 94, 165, 189, 94, 166, 166, 35, 166, 166, 94, 166, 190, 35, 167, 167, 94, 167, 167, 35, 167, 178, 35, 168, 168, 94, 168, 168, 35, 168, 179, 35, 169, 169, 94, 169, 169, 35, 169, 180, 35, 170, 170, 94, 170, 170, 35, 170, 181, 94, 170, 191, 12, 171, 171, 67, 171, 171, 12, 171, 150, 67, 171, 60, 50, 172, 172, 36, 172, 172, 98, 172, 172, 50, 172, 4, 36, 172, 25, 23, 173, 173, 23, 173, 173, 36, 173, 173, 12, 173, 173, 101, 173, 173, 63, 173, 173, 23, 173, 80, 23, 173, 61, 36, 173, 6, 12, 173, 131, 101, 173, 5, 63, 173, 91, 11, 174, 174, 67, 174, 174, 11, 174, 131, 67, 174, 26, 11, 175, 175, 67, 175, 175, 11, 175, 132, 67, 175, 27, 11, 176, 176, 67, 176, 176, 11, 176, 133, 67, 176, 28, 11, 177, 177, 67, 177, 177, 11, 177, 134, 67, 177, 29, 42, 178, 178, 49, 178, 178, 88, 178, 178, 42, 178, 3, 49, 178, 4, 88, 178, 167, 42, 179, 179, 88, 179, 179, 49, 179, 179, 42, 179, 2, 88, 179, 168, 42, 180, 180, 88, 180, 180, 49, 180, 180, 42, 180, 1, 88, 180, 169, 42, 181, 181, 88, 181, 181, 49, 181, 181, 42, 181, 0, 88, 181, 170, 41, 182, 182, 75, 182, 182, 41, 182, 152, 75, 182, 192, 41, 183, 183, 75, 183, 183, 41, 183, 154, 75, 183, 193, 41, 184, 184, 75, 184, 184, 41, 184, 156, 75, 184, 194, 41, 185, 185, 75, 185, 185, 41, 185, 157, 41, 186, 186, 75, 186, 186, 41, 186, 159, 41, 187, 187, 75, 187, 187, 41, 187, 160, 41, 188, 188, 75, 188, 188, 41, 188, 163, 75, 188, 195, 41, 189, 189, 75, 189, 189, 41, 189, 165, 41, 190, 190, 75, 190, 190, 41, 190, 166, 41, 191, 191, 75, 191, 191, 41, 191, 170, 22, 192, 192, 91, 192, 192, 92, 192, 192, 22, 192, 182, 91, 192, 0, 92, 192, 3, 22, 193, 193, 91, 193, 193, 92, 193, 193, 22, 193, 183, 91, 193, 1, 92, 193, 2, 22, 194, 194, 91, 194, 194, 92, 194, 194, 22, 194, 184, 91, 194, 2, 92, 194, 1, 22, 195, 195, 91, 195, 195, 92, 195, 195, 22, 195, 188, 91, 195, 3, 92, 195, 0, 59, 196, 196, 7, 196, 196, 8, 196, 196, 59, 196, 111, 59, 197, 197, 7, 197, 197, 8, 197, 197, 59, 197, 112, 59, 198, 198, 7, 198, 198, 8, 198, 198, 59, 198, 113, 59, 199, 199, 7, 199, 199, 8, 199, 199, 59, 199, 114, 59, 200, 200, 7, 200, 200, 8, 200, 200, 59, 200, 115, 59, 201, 201, 7, 201, 201, 8, 201, 201, 59, 201, 116, 59, 202, 202, 7, 202, 202, 8, 202, 202, 59, 202, 117, 59, 203, 203, 7, 203, 203, 8, 203, 203, 59, 203, 118, 59, 204, 204, 7, 204, 204, 8, 204, 204, 59, 204, 119, 59, 205, 205, 7, 205, 205, 8, 205, 205, 59, 205, 120, 59, 206, 206, 7, 206, 206, 8, 206, 206, 59, 206, 121, 59, 207, 207, 7, 207, 207, 8, 207, 207, 59, 207, 122, 59, 208, 208, 7, 208, 208, 8, 208, 208, 59, 208, 123, 59, 209, 209, 7, 209, 209, 8, 209, 209, 59, 209, 124, 59, 210, 210, 7, 210, 210, 8, 210, 210, 59, 210, 125, 59, 211, 211, 7, 211, 211, 8, 211, 211, 59, 211, 126, 59, 212, 212, 7, 212, 212, 8, 212, 212, 59, 212, 127, 59, 213, 213, 7, 213, 213, 8, 213, 213, 59, 213, 128, 59, 214, 214, 7, 214, 214, 8, 214, 214, 59, 214, 129, 59, 215, 215, 7, 215, 215, 8, 215, 215, 59, 215, 130)), ncol=3, byrow=TRUE)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(89, 8, 199, 374, 89, 9, 199, 375, 89, 10, 199, 376, 89, 11, 200, 374, 89, 12, 200, 375, 89, 13, 200, 376, 89, 14, 371, 202, 89, 15, 371, 203, 89, 16, 371, 204, 93, 17, 193, 312, 89, 17, 201, 374, 93, 18, 193, 313, 89, 18, 201, 375, 93, 19, 193, 314, 89, 19, 201, 376, 93, 20, 193, 315, 89, 20, 372, 202, 93, 21, 193, 316, 89, 21, 372, 203, 93, 22, 193, 317, 89, 22, 372, 204, 93, 23, 193, 318, 89, 23, 373, 202, 93, 24, 193, 319, 89, 24, 373, 203, 93, 25, 193, 320, 89, 25, 373, 204, 93, 26, 193, 321, 14, 31, 377, 196, 14, 32, 378, 196, 14, 33, 379, 196, 14, 34, 380, 196, 14, 35, 381, 196, 14, 36, 382, 196, 14, 37, 377, 197, 66, 37, 292, 194, 14, 38, 378, 197, 66, 38, 293, 194, 14, 39, 379, 197, 66, 39, 294, 194, 14, 40, 380, 197, 66, 40, 295, 194, 14, 41, 381, 197, 66, 41, 296, 194, 14, 42, 382, 197, 66, 42, 297, 194, 14, 43, 205, 368, 66, 43, 298, 194, 14, 44, 206, 368, 66, 44, 299, 194, 14, 45, 207, 368, 66, 45, 300, 194, 14, 46, 208, 368, 66, 46, 301, 194, 14, 47, 377, 198, 66, 47, 292, 195, 14, 48, 378, 198, 66, 48, 293, 195, 14, 49, 379, 198, 66, 49, 294, 195, 14, 50, 380, 198, 66, 50, 295, 195, 14, 51, 381, 198, 66, 51, 296, 195, 14, 52, 382, 198, 66, 52, 297, 195, 14, 53, 205, 369, 66, 53, 298, 195, 14, 54, 206, 369, 66, 54, 299, 195, 14, 55, 207, 369, 66, 55, 300, 195, 14, 56, 208, 369, 66, 56, 301, 195, 14, 57, 205, 370, 66, 57, 160, 367, 14, 58, 206, 370, 66, 58, 161, 367, 14, 59, 207, 370, 66, 59, 162, 367, 14, 60, 208, 370, 66, 60, 163, 367, 66, 61, 164, 367, 76, 63, 204, 374, 76, 64, 204, 375, 76, 65, 204, 376, 76, 66, 203, 374, 76, 67, 203, 375, 76, 68, 203, 376, 76, 69, 376, 202, 76, 70, 376, 203, 76, 71, 376, 204, 76, 72, 202, 374, 76, 73, 202, 375, 76, 74, 202, 376, 76, 75, 375, 202, 76, 76, 375, 203, 76, 77, 375, 204, 76, 78, 374, 202, 76, 79, 374, 203, 76, 80, 374, 204, 10, 93, 374, 194, 10, 94, 375, 194, 10, 95, 376, 194, 10, 96, 374, 195, 10, 97, 375, 195, 10, 98, 376, 195, 10, 99, 202, 367, 10, 100, 203, 367, 10, 101, 204, 367, 65, 133, 374, 196, 65, 134, 375, 196, 65, 135, 376, 196, 64, 136, 377, 194, 65, 136, 374, 197, 64, 137, 378, 194, 65, 137, 375, 197, 64, 138, 379, 194, 65, 138, 376, 197, 64, 139, 380, 194, 65, 139, 202, 368, 64, 140, 381, 194, 65, 140, 203, 368, 64, 141, 382, 194, 65, 141, 204, 368, 64, 142, 377, 195, 65, 142, 374, 198, 64, 143, 378, 195, 65, 143, 375, 198, 64, 144, 379, 195, 65, 144, 376, 198, 64, 145, 380, 195, 65, 145, 202, 369, 64, 146, 381, 195, 65, 146, 203, 369, 64, 147, 382, 195, 65, 147, 204, 369, 64, 148, 205, 367, 65, 148, 202, 370, 64, 149, 206, 367, 65, 149, 203, 370, 64, 150, 207, 367, 65, 150, 204, 370, 64, 151, 208, 367, 35, 152, 228, 209, 94, 152, 389, 193, 35, 153, 228, 210, 35, 154, 130, 383, 94, 154, 390, 193, 35, 155, 228, 211, 35, 156, 130, 384, 94, 156, 391, 193, 35, 157, 130, 385, 35, 158, 228, 212, 35, 159, 130, 386, 94, 159, 392, 193, 35, 160, 130, 387, 35, 161, 130, 388, 35, 162, 129, 383, 94, 162, 393, 193, 35, 163, 129, 384, 94, 163, 394, 193, 35, 164, 129, 385, 35, 165, 129, 386, 94, 165, 395, 193, 35, 166, 129, 387, 35, 167, 129, 388, 94, 168, 396, 193, 94, 169, 397, 193, 94, 170, 398, 193, 98, 173, 228, 193, 49, 180, 237, 193, 49, 181, 236, 193, 49, 182, 235, 193, 75, 186, 399, 193, 75, 187, 400, 193, 75, 188, 401, 193, 75, 190, 402, 193, 75, 191, 403, 193, 75, 192, 404, 193, 7, 197, 46, 1, 8, 197, 47, 1, 7, 198, 48, 1, 8, 198, 49, 1, 7, 199, 50, 1, 8, 199, 51, 1, 7, 200, 52, 1, 8, 200, 53, 1, 7, 201, 54, 1, 8, 201, 55, 1, 7, 202, 56, 1, 8, 202, 57, 1, 7, 203, 58, 1, 8, 203, 59, 1, 7, 204, 60, 1, 8, 204, 61, 1, 7, 205, 62, 1, 8, 205, 63, 1, 7, 206, 64, 1, 8, 206, 65, 1, 7, 207, 66, 1, 8, 207, 67, 1, 7, 208, 68, 1, 8, 208, 69, 1, 7, 209, 70, 1, 8, 209, 71, 1, 7, 210, 72, 1, 8, 210, 73, 1, 7, 211, 74, 1, 8, 211, 75, 1, 7, 212, 76, 1, 8, 212, 77, 1, 7, 213, 78, 1, 8, 213, 79, 1, 7, 214, 80, 1, 8, 214, 81, 1, 7, 215, 82, 1, 8, 215, 83, 1, 7, 216, 84, 1, 8, 216, 85, 1)), ncol=2+2, byrow=TRUE)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 4: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=4
nb_c=149
ba_x=128; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=507 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(38, 0, 0, 39, 0, 0, 95, 0, 0, 38, 0, 133, 39, 0, 133, 95, 0, 127, 53, 1, 1, 93, 1, 1, 89, 1, 1, 53, 1, 81, 93, 1, 76, 53, 2, 2, 93, 2, 2, 89, 2, 2, 53, 2, 82, 93, 2, 77, 53, 3, 3, 93, 3, 3, 89, 3, 3, 53, 3, 83, 93, 3, 78, 53, 4, 4, 93, 4, 4, 89, 4, 4, 53, 4, 84, 93, 4, 79, 53, 5, 5, 93, 5, 5, 89, 5, 5, 53, 5, 85, 93, 5, 80, 53, 6, 6, 93, 6, 6, 89, 6, 6, 53, 6, 86, 53, 7, 7, 93, 7, 7, 89, 7, 7, 53, 7, 87, 53, 8, 8, 93, 8, 8, 89, 8, 8, 53, 8, 88, 53, 9, 9, 93, 9, 9, 89, 9, 9, 53, 9, 89, 53, 10, 10, 93, 10, 10, 89, 10, 10, 53, 10, 90, 53, 11, 11, 93, 11, 11, 89, 11, 11, 53, 11, 91, 53, 12, 12, 93, 12, 12, 89, 12, 12, 53, 12, 92, 53, 13, 13, 93, 13, 13, 89, 13, 13, 53, 13, 93, 53, 14, 14, 93, 14, 14, 89, 14, 14, 53, 14, 94, 53, 15, 15, 93, 15, 15, 89, 15, 15, 53, 15, 95, 14, 16, 16, 66, 16, 16, 14, 16, 126, 66, 16, 66, 66, 17, 17, 14, 17, 17, 66, 17, 67, 66, 18, 18, 14, 18, 18, 66, 18, 68, 66, 19, 19, 14, 19, 19, 66, 19, 69, 66, 20, 20, 14, 20, 20, 66, 20, 70, 14, 21, 21, 66, 21, 21, 14, 22, 22, 66, 22, 22, 14, 23, 23, 66, 23, 23, 14, 24, 24, 66, 24, 24, 14, 25, 25, 66, 25, 25, 14, 26, 26, 66, 26, 26, 14, 27, 27, 66, 27, 27, 14, 28, 28, 66, 28, 28, 14, 29, 29, 66, 29, 29, 14, 30, 30, 66, 30, 30, 14, 31, 31, 66, 31, 31, 14, 32, 32, 66, 32, 32, 14, 33, 33, 66, 33, 33, 14, 34, 34, 66, 34, 34, 14, 35, 35, 66, 35, 35, 14, 36, 36, 66, 36, 36, 14, 37, 37, 66, 37, 37, 14, 38, 38, 66, 38, 38, 14, 39, 39, 66, 39, 39, 14, 40, 40, 66, 40, 40, 14, 41, 41, 66, 41, 41, 14, 42, 42, 66, 42, 42, 14, 43, 43, 66, 43, 43, 14, 44, 44, 66, 44, 44, 14, 45, 45, 66, 45, 45, 14, 46, 46, 66, 46, 46, 14, 47, 47, 66, 47, 47, 14, 48, 48, 66, 48, 48, 14, 49, 49, 66, 49, 49, 14, 50, 50, 66, 50, 50, 46, 51, 51, 76, 51, 51, 46, 51, 96, 46, 52, 52, 76, 52, 52, 46, 52, 97, 46, 53, 53, 76, 53, 53, 46, 53, 98, 46, 54, 54, 76, 54, 54, 46, 54, 99, 46, 55, 55, 76, 55, 55, 46, 55, 100, 46, 56, 56, 76, 56, 56, 46, 56, 101, 46, 57, 57, 76, 57, 57, 46, 57, 102, 46, 58, 58, 76, 58, 58, 46, 58, 103, 46, 59, 59, 76, 59, 59, 46, 59, 104, 46, 60, 60, 76, 60, 60, 46, 60, 105, 46, 61, 61, 76, 61, 61, 46, 61, 106, 46, 62, 62, 76, 62, 62, 46, 62, 107, 46, 63, 63, 76, 63, 63, 46, 63, 108, 46, 64, 64, 76, 64, 64, 46, 64, 109, 46, 65, 65, 76, 65, 65, 46, 65, 110, 51, 66, 66, 13, 66, 66, 51, 66, 76, 13, 66, 16, 51, 67, 67, 13, 67, 67, 51, 67, 77, 13, 67, 17, 51, 68, 68, 13, 68, 68, 51, 68, 78, 13, 68, 18, 51, 69, 69, 13, 69, 69, 51, 69, 79, 13, 69, 19, 51, 70, 70, 13, 70, 70, 51, 70, 80, 13, 70, 20, 52, 71, 71, 10, 71, 71, 52, 71, 76, 52, 72, 72, 10, 72, 72, 52, 72, 77, 52, 73, 73, 10, 73, 73, 52, 73, 78, 52, 74, 74, 10, 74, 74, 52, 74, 79, 52, 75, 75, 10, 75, 75, 52, 75, 80, 40, 76, 76, 104, 76, 76, 105, 76, 76, 40, 76, 1, 104, 76, 66, 105, 76, 71, 40, 77, 77, 104, 77, 77, 105, 77, 77, 40, 77, 2, 104, 77, 67, 105, 77, 72, 40, 78, 78, 104, 78, 78, 105, 78, 78, 40, 78, 3, 104, 78, 68, 105, 78, 73, 40, 79, 79, 104, 79, 79, 105, 79, 79, 40, 79, 4, 104, 79, 69, 105, 79, 74, 40, 80, 80, 104, 80, 80, 105, 80, 80, 40, 80, 5, 104, 80, 70, 105, 80, 75, 6, 81, 81, 100, 81, 81, 106, 81, 81, 6, 81, 134, 100, 81, 96, 106, 81, 1, 6, 82, 82, 100, 82, 82, 106, 82, 82, 6, 82, 135, 100, 82, 97, 106, 82, 2, 6, 83, 83, 100, 83, 83, 106, 83, 83, 6, 83, 136, 100, 83, 98, 106, 83, 3, 6, 84, 84, 100, 84, 84, 106, 84, 84, 6, 84, 137, 100, 84, 99, 106, 84, 4, 6, 85, 85, 100, 85, 85, 106, 85, 85, 6, 85, 138, 100, 85, 100, 106, 85, 5, 6, 86, 86, 100, 86, 86, 106, 86, 86, 6, 86, 139, 100, 86, 101, 106, 86, 6, 6, 87, 87, 100, 87, 87, 106, 87, 87, 6, 87, 140, 100, 87, 102, 106, 87, 7, 6, 88, 88, 100, 88, 88, 106, 88, 88, 6, 88, 141, 100, 88, 103, 106, 88, 8, 6, 89, 89, 100, 89, 89, 106, 89, 89, 6, 89, 142, 100, 89, 104, 106, 89, 9, 6, 90, 90, 100, 90, 90, 106, 90, 90, 6, 90, 143, 100, 90, 105, 106, 90, 10, 6, 91, 91, 100, 91, 91, 106, 91, 91, 6, 91, 144, 100, 91, 106, 106, 91, 11, 6, 92, 92, 100, 92, 92, 106, 92, 92, 6, 92, 145, 100, 92, 107, 106, 92, 12, 6, 93, 93, 100, 93, 93, 106, 93, 93, 6, 93, 146, 100, 93, 108, 106, 93, 13, 6, 94, 94, 100, 94, 94, 106, 94, 94, 6, 94, 147, 100, 94, 109, 106, 94, 14, 6, 95, 95, 100, 95, 95, 106, 95, 95, 6, 95, 148, 100, 95, 110, 106, 95, 15, 47, 96, 96, 99, 96, 96, 64, 96, 96, 65, 96, 96, 47, 96, 81, 99, 96, 51, 64, 96, 126, 47, 97, 97, 99, 97, 97, 64, 97, 97, 65, 97, 97, 47, 97, 82, 99, 97, 52, 47, 98, 98, 99, 98, 98, 64, 98, 98, 65, 98, 98, 47, 98, 83, 99, 98, 53, 47, 99, 99, 99, 99, 99, 64, 99, 99, 65, 99, 99, 47, 99, 84, 99, 99, 54, 47, 100, 100, 99, 100, 100, 64, 100, 100, 65, 100, 100, 47, 100, 85, 99, 100, 55, 47, 101, 101, 99, 101, 101, 64, 101, 101, 65, 101, 101, 47, 101, 86, 99, 101, 56, 47, 102, 102, 99, 102, 102, 64, 102, 102, 65, 102, 102, 47, 102, 87, 99, 102, 57, 47, 103, 103, 99, 103, 103, 64, 103, 103, 65, 103, 103, 47, 103, 88, 99, 103, 58, 47, 104, 104, 99, 104, 104, 64, 104, 104, 65, 104, 104, 47, 104, 89, 99, 104, 59, 47, 105, 105, 99, 105, 105, 64, 105, 105, 65, 105, 105, 47, 105, 90, 99, 105, 60, 47, 106, 106, 99, 106, 106, 64, 106, 106, 65, 106, 106, 47, 106, 91, 99, 106, 61, 47, 107, 107, 99, 107, 107, 64, 107, 107, 65, 107, 107, 47, 107, 92, 99, 107, 62, 47, 108, 108, 99, 108, 108, 64, 108, 108, 65, 108, 108, 47, 108, 93, 99, 108, 63, 47, 109, 109, 99, 109, 109, 64, 109, 109, 65, 109, 109, 47, 109, 94, 99, 109, 64, 47, 110, 110, 99, 110, 110, 64, 110, 110, 65, 110, 110, 47, 110, 95, 99, 110, 65, 35, 111, 111, 94, 111, 111, 35, 112, 112, 94, 112, 112, 94, 113, 113, 35, 113, 113, 94, 113, 128, 35, 114, 114, 94, 114, 114, 35, 115, 115, 94, 115, 115, 94, 116, 116, 35, 116, 116, 94, 116, 129, 35, 117, 117, 94, 117, 117, 94, 118, 118, 35, 118, 118, 94, 118, 130, 35, 119, 119, 94, 119, 119, 94, 120, 120, 35, 120, 120, 94, 120, 131, 35, 121, 121, 94, 121, 121, 35, 122, 122, 94, 122, 122, 35, 123, 123, 94, 123, 123, 94, 124, 124, 35, 124, 124, 94, 124, 132, 35, 125, 125, 94, 125, 125, 35, 125, 127, 11, 126, 126, 67, 126, 126, 11, 126, 96, 67, 126, 16, 42, 127, 127, 88, 127, 127, 49, 127, 127, 42, 127, 0, 88, 127, 125, 41, 128, 128, 75, 128, 128, 41, 128, 113, 75, 128, 133, 41, 129, 129, 75, 129, 129, 41, 129, 116, 41, 130, 130, 75, 130, 130, 41, 130, 118, 41, 131, 131, 75, 131, 131, 41, 131, 120, 41, 132, 132, 75, 132, 132, 41, 132, 124, 22, 133, 133, 91, 133, 133, 92, 133, 133, 22, 133, 128, 91, 133, 0, 92, 133, 0, 59, 134, 134, 7, 134, 134, 8, 134, 134, 59, 134, 81, 59, 135, 135, 7, 135, 135, 8, 135, 135, 59, 135, 82, 59, 136, 136, 7, 136, 136, 8, 136, 136, 59, 136, 83, 59, 137, 137, 7, 137, 137, 8, 137, 137, 59, 137, 84, 59, 138, 138, 7, 138, 138, 8, 138, 138, 59, 138, 85, 59, 139, 139, 7, 139, 139, 8, 139, 139, 59, 139, 86, 59, 140, 140, 7, 140, 140, 8, 140, 140, 59, 140, 87, 59, 141, 141, 7, 141, 141, 8, 141, 141, 59, 141, 88, 59, 142, 142, 7, 142, 142, 8, 142, 142, 59, 142, 89, 59, 143, 143, 7, 143, 143, 8, 143, 143, 59, 143, 90, 59, 144, 144, 7, 144, 144, 8, 144, 144, 59, 144, 91, 59, 145, 145, 7, 145, 145, 8, 145, 145, 59, 145, 92, 59, 146, 146, 7, 146, 146, 8, 146, 146, 59, 146, 93, 59, 147, 147, 7, 147, 147, 8, 147, 147, 59, 147, 94, 59, 148, 148, 7, 148, 148, 8, 148, 148, 59, 148, 95)), ncol=3, byrow=TRUE)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(89, 2, 199, 593, 89, 3, 200, 593, 89, 4, 371, 374, 89, 5, 371, 375, 89, 6, 371, 376, 93, 7, 193, 521, 89, 7, 201, 593, 93, 8, 193, 522, 89, 8, 372, 374, 93, 9, 193, 523, 89, 9, 372, 375, 93, 10, 193, 524, 89, 10, 372, 376, 93, 11, 193, 525, 89, 11, 373, 374, 93, 12, 193, 526, 89, 12, 373, 375, 93, 13, 193, 527, 89, 13, 373, 376, 93, 14, 193, 528, 89, 14, 592, 202, 93, 15, 193, 529, 89, 15, 592, 203, 93, 16, 193, 530, 89, 16, 592, 204, 14, 18, 594, 196, 14, 19, 595, 196, 14, 20, 596, 196, 14, 21, 597, 196, 14, 22, 594, 197, 66, 22, 501, 194, 14, 23, 595, 197, 66, 23, 502, 194, 14, 24, 596, 197, 66, 24, 503, 194, 14, 25, 597, 197, 66, 25, 504, 194, 14, 26, 377, 368, 66, 26, 505, 194, 14, 27, 378, 368, 66, 27, 506, 194, 14, 28, 379, 368, 66, 28, 507, 194, 14, 29, 380, 368, 66, 29, 508, 194, 14, 30, 381, 368, 66, 30, 509, 194, 14, 31, 382, 368, 66, 31, 510, 194, 14, 32, 594, 198, 66, 32, 501, 195, 14, 33, 595, 198, 66, 33, 502, 195, 14, 34, 596, 198, 66, 34, 503, 195, 14, 35, 597, 198, 66, 35, 504, 195, 14, 36, 377, 369, 66, 36, 505, 195, 14, 37, 378, 369, 66, 37, 506, 195, 14, 38, 379, 369, 66, 38, 507, 195, 14, 39, 380, 369, 66, 39, 508, 195, 14, 40, 381, 369, 66, 40, 509, 195, 14, 41, 382, 369, 66, 41, 510, 195, 14, 42, 377, 370, 66, 42, 292, 367, 14, 43, 378, 370, 66, 43, 293, 367, 14, 44, 379, 370, 66, 44, 294, 367, 14, 45, 380, 370, 66, 45, 295, 367, 14, 46, 381, 370, 66, 46, 296, 367, 14, 47, 382, 370, 66, 47, 297, 367, 14, 48, 205, 591, 66, 48, 298, 367, 14, 49, 206, 591, 66, 49, 299, 367, 14, 50, 207, 591, 66, 50, 300, 367, 14, 51, 208, 591, 66, 51, 301, 367, 76, 52, 204, 593, 76, 53, 203, 593, 76, 54, 376, 374, 76, 55, 376, 375, 76, 56, 376, 376, 76, 57, 202, 593, 76, 58, 375, 374, 76, 59, 375, 375, 76, 60, 375, 376, 76, 61, 374, 374, 76, 62, 374, 375, 76, 63, 374, 376, 76, 64, 593, 202, 76, 65, 593, 203, 76, 66, 593, 204, 10, 72, 593, 194, 10, 73, 593, 195, 10, 74, 374, 367, 10, 75, 375, 367, 10, 76, 376, 367, 65, 97, 593, 196, 64, 98, 594, 194, 65, 98, 593, 197, 64, 99, 595, 194, 65, 99, 374, 368, 64, 100, 596, 194, 65, 100, 375, 368, 64, 101, 597, 194, 65, 101, 376, 368, 64, 102, 594, 195, 65, 102, 593, 198, 64, 103, 595, 195, 65, 103, 374, 369, 64, 104, 596, 195, 65, 104, 375, 369, 64, 105, 597, 195, 65, 105, 376, 369, 64, 106, 377, 367, 65, 106, 374, 370, 64, 107, 378, 367, 65, 107, 375, 370, 64, 108, 379, 367, 65, 108, 376, 370, 64, 109, 380, 367, 65, 109, 202, 591, 64, 110, 381, 367, 65, 110, 203, 591, 64, 111, 382, 367, 65, 111, 204, 591, 35, 112, 228, 383, 94, 112, 602, 193, 35, 113, 228, 384, 94, 113, 603, 193, 35, 114, 228, 385, 35, 115, 130, 598, 94, 115, 604, 193, 35, 116, 228, 386, 94, 116, 605, 193, 35, 117, 228, 387, 35, 118, 130, 599, 94, 118, 606, 193, 35, 119, 228, 388, 35, 120, 130, 600, 94, 120, 607, 193, 35, 121, 130, 601, 35, 122, 129, 598, 94, 122, 608, 193, 35, 123, 129, 599, 94, 123, 609, 193, 35, 124, 129, 600, 94, 124, 610, 193, 35, 125, 129, 601, 94, 126, 611, 193, 49, 128, 424, 193, 75, 130, 612, 193, 75, 131, 613, 193, 75, 132, 614, 193, 75, 133, 615, 193, 7, 135, 16, 1, 8, 135, 17, 1, 7, 136, 18, 1, 8, 136, 19, 1, 7, 137, 20, 1, 8, 137, 21, 1, 7, 138, 22, 1, 8, 138, 23, 1, 7, 139, 24, 1, 8, 139, 25, 1, 7, 140, 26, 1, 8, 140, 27, 1, 7, 141, 28, 1, 8, 141, 29, 1, 7, 142, 30, 1, 8, 142, 31, 1, 7, 143, 32, 1, 8, 143, 33, 1, 7, 144, 34, 1, 8, 144, 35, 1, 7, 145, 36, 1, 8, 145, 37, 1, 7, 146, 38, 1, 8, 146, 39, 1, 7, 147, 40, 1, 8, 147, 41, 1, 7, 148, 42, 1, 8, 148, 43, 1, 7, 149, 44, 1, 8, 149, 45, 1)), ncol=2+2, byrow=TRUE)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 5: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=5
nb_c=61
ba_x=128; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=656 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(53, 0, 0, 93, 0, 0, 89, 0, 0, 53, 0, 36, 93, 0, 35, 53, 1, 1, 93, 1, 1, 89, 1, 1, 53, 1, 37, 53, 2, 2, 93, 2, 2, 89, 2, 2, 53, 2, 38, 53, 3, 3, 93, 3, 3, 89, 3, 3, 53, 3, 39, 53, 4, 4, 93, 4, 4, 89, 4, 4, 53, 4, 40, 53, 5, 5, 93, 5, 5, 89, 5, 5, 53, 5, 41, 66, 6, 6, 14, 6, 6, 66, 6, 33, 14, 7, 7, 66, 7, 7, 14, 8, 8, 66, 8, 8, 14, 9, 9, 66, 9, 9, 14, 10, 10, 66, 10, 10, 14, 11, 11, 66, 11, 11, 14, 12, 12, 66, 12, 12, 14, 13, 13, 66, 13, 13, 14, 14, 14, 66, 14, 14, 14, 15, 15, 66, 15, 15, 14, 16, 16, 66, 16, 16, 14, 17, 17, 66, 17, 17, 14, 18, 18, 66, 18, 18, 14, 19, 19, 66, 19, 19, 14, 20, 20, 66, 20, 20, 14, 21, 21, 66, 21, 21, 14, 22, 22, 66, 22, 22, 14, 23, 23, 66, 23, 23, 14, 24, 24, 66, 24, 24, 14, 25, 25, 66, 25, 25, 14, 26, 26, 66, 26, 26, 46, 27, 27, 76, 27, 27, 46, 27, 42, 46, 28, 28, 76, 28, 28, 46, 28, 43, 46, 29, 29, 76, 29, 29, 46, 29, 44, 46, 30, 30, 76, 30, 30, 46, 30, 45, 46, 31, 31, 76, 31, 31, 46, 31, 46, 46, 32, 32, 76, 32, 32, 46, 32, 47, 51, 33, 33, 13, 33, 33, 51, 33, 35, 13, 33, 6, 52, 34, 34, 10, 34, 34, 52, 34, 35, 40, 35, 35, 104, 35, 35, 105, 35, 35, 40, 35, 0, 104, 35, 33, 105, 35, 34, 6, 36, 36, 100, 36, 36, 106, 36, 36, 6, 36, 55, 100, 36, 42, 106, 36, 0, 6, 37, 37, 100, 37, 37, 106, 37, 37, 6, 37, 56, 100, 37, 43, 106, 37, 1, 6, 38, 38, 100, 38, 38, 106, 38, 38, 6, 38, 57, 100, 38, 44, 106, 38, 2, 6, 39, 39, 100, 39, 39, 106, 39, 39, 6, 39, 58, 100, 39, 45, 106, 39, 3, 6, 40, 40, 100, 40, 40, 106, 40, 40, 6, 40, 59, 100, 40, 46, 106, 40, 4, 6, 41, 41, 100, 41, 41, 106, 41, 41, 6, 41, 60, 100, 41, 47, 106, 41, 5, 47, 42, 42, 99, 42, 42, 64, 42, 42, 65, 42, 42, 47, 42, 36, 99, 42, 27, 47, 43, 43, 99, 43, 43, 64, 43, 43, 65, 43, 43, 47, 43, 37, 99, 43, 28, 47, 44, 44, 99, 44, 44, 64, 44, 44, 65, 44, 44, 47, 44, 38, 99, 44, 29, 47, 45, 45, 99, 45, 45, 64, 45, 45, 65, 45, 45, 47, 45, 39, 99, 45, 30, 47, 46, 46, 99, 46, 46, 64, 46, 46, 65, 46, 46, 47, 46, 40, 99, 46, 31, 47, 47, 47, 99, 47, 47, 64, 47, 47, 65, 47, 47, 47, 47, 41, 99, 47, 32, 35, 48, 48, 94, 48, 48, 35, 49, 49, 94, 49, 49, 35, 50, 50, 94, 50, 50, 94, 51, 51, 35, 51, 51, 94, 51, 54, 35, 52, 52, 94, 52, 52, 35, 53, 53, 94, 53, 53, 41, 54, 54, 75, 54, 54, 41, 54, 51, 59, 55, 55, 7, 55, 55, 8, 55, 55, 59, 55, 36, 59, 56, 56, 7, 56, 56, 8, 56, 56, 59, 56, 37, 59, 57, 57, 7, 57, 57, 8, 57, 57, 59, 57, 38, 59, 58, 58, 7, 58, 58, 8, 58, 58, 59, 58, 39, 59, 59, 59, 7, 59, 59, 8, 59, 59, 59, 59, 40, 59, 60, 60, 7, 60, 60, 8, 60, 60, 59, 60, 41)), ncol=3, byrow=TRUE)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(89, 1, 371, 593, 93, 2, 193, 712, 89, 2, 372, 593, 93, 3, 193, 713, 89, 3, 373, 593, 93, 4, 193, 714, 89, 4, 592, 374, 93, 5, 193, 715, 89, 5, 592, 375, 93, 6, 193, 716, 89, 6, 592, 376, 14, 7, 762, 196, 14, 8, 762, 197, 66, 8, 702, 194, 14, 9, 594, 368, 66, 9, 703, 194, 14, 10, 595, 368, 66, 10, 704, 194, 14, 11, 596, 368, 66, 11, 705, 194, 14, 12, 597, 368, 66, 12, 706, 194, 14, 13, 762, 198, 66, 13, 702, 195, 14, 14, 594, 369, 66, 14, 703, 195, 14, 15, 595, 369, 66, 15, 704, 195, 14, 16, 596, 369, 66, 16, 705, 195, 14, 17, 597, 369, 66, 17, 706, 195, 14, 18, 594, 370, 66, 18, 501, 367, 14, 19, 595, 370, 66, 19, 502, 367, 14, 20, 596, 370, 66, 20, 503, 367, 14, 21, 597, 370, 66, 21, 504, 367, 14, 22, 377, 591, 66, 22, 505, 367, 14, 23, 378, 591, 66, 23, 506, 367, 14, 24, 379, 591, 66, 24, 507, 367, 14, 25, 380, 591, 66, 25, 508, 367, 14, 26, 381, 591, 66, 26, 509, 367, 14, 27, 382, 591, 66, 27, 510, 367, 76, 28, 376, 593, 76, 29, 375, 593, 76, 30, 374, 593, 76, 31, 593, 374, 76, 32, 593, 375, 76, 33, 593, 376, 10, 35, 593, 367, 64, 43, 762, 194, 65, 43, 593, 368, 64, 44, 762, 195, 65, 44, 593, 369, 64, 45, 594, 367, 65, 45, 593, 370, 64, 46, 595, 367, 65, 46, 374, 591, 64, 47, 596, 367, 65, 47, 375, 591, 64, 48, 597, 367, 65, 48, 376, 591, 35, 49, 228, 598, 94, 49, 764, 193, 35, 50, 228, 599, 94, 50, 765, 193, 35, 51, 228, 600, 94, 51, 766, 193, 35, 52, 228, 601, 35, 53, 130, 763, 94, 53, 767, 193, 35, 54, 129, 763, 94, 54, 768, 193, 75, 55, 769, 193, 7, 56, 4, 1, 8, 56, 5, 1, 7, 57, 6, 1, 8, 57, 7, 1, 7, 58, 8, 1, 8, 58, 9, 1, 7, 59, 10, 1, 8, 59, 11, 1, 7, 60, 12, 1, 8, 60, 13, 1, 7, 61, 14, 1, 8, 61, 15, 1)), ncol=2+2, byrow=TRUE)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 6: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=6
nb_c=13
ba_x=128; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=717 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(53, 0, 0, 93, 0, 0, 89, 0, 0, 53, 0, 9, 14, 1, 1, 66, 1, 1, 14, 2, 2, 66, 2, 2, 14, 3, 3, 66, 3, 3, 14, 4, 4, 66, 4, 4, 14, 5, 5, 66, 5, 5, 14, 6, 6, 66, 6, 6, 14, 7, 7, 66, 7, 7, 46, 8, 8, 76, 8, 8, 46, 8, 10, 6, 9, 9, 100, 9, 9, 106, 9, 9, 6, 9, 12, 100, 9, 10, 106, 9, 0, 47, 10, 10, 99, 10, 10, 64, 10, 10, 65, 10, 10, 47, 10, 9, 99, 10, 8, 35, 11, 11, 94, 11, 11, 59, 12, 12, 7, 12, 12, 8, 12, 12, 59, 12, 9)), ncol=3, byrow=TRUE)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(93, 1, 193, 820, 89, 1, 592, 593, 14, 2, 762, 368, 66, 2, 818, 194, 14, 3, 762, 369, 66, 3, 818, 195, 14, 4, 762, 370, 66, 4, 702, 367, 14, 5, 594, 591, 66, 5, 703, 367, 14, 6, 595, 591, 66, 6, 704, 367, 14, 7, 596, 591, 66, 7, 705, 367, 14, 8, 597, 591, 66, 8, 706, 367, 76, 9, 593, 593, 64, 11, 762, 367, 65, 11, 593, 591, 35, 12, 228, 763, 94, 12, 839, 193, 7, 13, 2, 1, 8, 13, 3, 1)), ncol=2+2, byrow=TRUE)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

if (TIMEIT) {
   cat("weight 7: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
w=7
nb_c=1
ba_x=128; # base of cumomer indexes in incu vector
l=new.env()
l$w=w
l$nb_c=nb_c
l$nb_fwrv=nb_fwrv
l$nb_cl=730 # number of lighter cumomers
maxprod=2
if (nb_c > 0) {
   # matrix a
   ind_a=matrix(as.integer(c(14, 0, 0, 66, 0, 0)), ncol=3, byrow=TRUE)
   colnames(ind_a)=c("indf", "ir0", "ic0")
   l$ind_a=ind_a
   
   # vector b
   ind_b=matrix(as.integer(c(14, 1, 762, 591, 66, 1, 818, 367)), ncol=2+2, byrow=TRUE)
   colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(2), sep=""))
   l$ind_b=ind_b
   
   # jacobian b_x
   imaxprod=seq_len(maxprod)
   ind_bx=c()
   for (ix in imaxprod) {
      i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
      tmp=ind_b[i,,drop=FALSE]
      ind_bx=rbind(ind_bx, tmp[,c(1,2,ix+2,2+imaxprod[-ix])]) # move diff var to ic1 place
   }
   if (length(ind_bx)) {
      colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1)))
      ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
   }
   l$ind_bx=ind_bx
}
spAbr[[w]]=l

# weight count
nb_rw=7
# cumomer count by weight
nb_rcumos=c(99, 192, 216, 149, 61, 13, 1)
nbc_cumos=c(0, cumsum(nb_rcumos))
# cumo names
nm_rcumo=c("AcCoA:1", "AcCoA:2", "Mal:1", "Mal:2", "Mal:4", "Mal:8", "PEP:1", "PEP:2", "PEP:4", "PGA:1", "PGA:2", "PGA:4", "Gnt6P:1", "Gnt6P:2", "Gnt6P:4", "Gnt6P:8", "Gnt6P:16", "Gnt6P:32", "Sed7P:1", "Sed7P:2", "Sed7P:4", "Sed7P:8", "Sed7P:16", "Sed7P:32", "Sed7P:64", "FruBP:1", "FruBP:2", "FruBP:4", "FruBP:8", "FruBP:16", "FruBP:32", "Rib5P:1", "Rib5P:2", "Rib5P:4", "Rib5P:8", "Rib5P:16", "Xul5P:1", "Xul5P:2", "Xul5P:4", "Xul5P:8", "Xul5P:16", "Rub5P:1", "Rub5P:2", "Rub5P:4", "Rub5P:8", "Rub5P:16", "Glc6P:1", "Glc6P:2", "Glc6P:4", "Glc6P:8", "Glc6P:16", "Glc6P:32", "Fru6P:1", "Fru6P:2", "Fru6P:4", "Fru6P:8", "Fru6P:16", "Fru6P:32", "Cit:1", "Cit:2", "Cit:4", "Cit:8", "Cit:16", "Cit:32", "CO2:1", "E2:1", "E2:2", "E3:1", "E3:2", "E3:4", "Pyr:1", "Pyr:2", "Pyr:4", "GA3P:1", "GA3P:2", "GA3P:4", "Ery4P:1", "Ery4P:2", "Ery4P:4", "Ery4P:8", "OAA:8", "OAA:4", "OAA:2", "OAA:1", "AKG:1", "AKG:2", "AKG:4", "AKG:8", "AKG:16", "Suc:1", "Suc:2", "Suc:4", "Suc:8", "Glc:1", "Glc:2", "Glc:4", "Glc:8", "Glc:16", "Glc:32", "AcCoA:3", "Mal:3", "Mal:5", "Mal:9", "Mal:6", "Mal:10", "Mal:12", "PEP:3", "PEP:5", "PEP:6", "PGA:3", "PGA:5", "PGA:6", "Gnt6P:3", "Gnt6P:5", "Gnt6P:6", "Gnt6P:9", "Gnt6P:10", "Gnt6P:12", "Gnt6P:17", "Gnt6P:18", "Gnt6P:20", "Gnt6P:24", "Gnt6P:33", "Gnt6P:34", "Gnt6P:36", "Gnt6P:40", "Gnt6P:48", "Sed7P:3", "Sed7P:5", "Sed7P:6", "Sed7P:9", "Sed7P:10", "Sed7P:12", "Sed7P:17", "Sed7P:18", "Sed7P:20", "Sed7P:24", "Sed7P:33", "Sed7P:34", "Sed7P:36", "Sed7P:40", "Sed7P:48", "Sed7P:65", "Sed7P:66", "Sed7P:68", "Sed7P:72", "Sed7P:80", "Sed7P:96", "FruBP:3", "FruBP:5", "FruBP:6", "FruBP:9", "FruBP:10", "FruBP:12", "FruBP:17", "FruBP:18", "FruBP:20", "FruBP:24", "FruBP:33", "FruBP:34", "FruBP:36", "FruBP:40", "FruBP:48", "Rib5P:3", "Rib5P:5", "Rib5P:6", "Rib5P:9", "Rib5P:10", "Rib5P:12", "Rib5P:17", "Rib5P:18", "Rib5P:20", "Rib5P:24", "Xul5P:3", "Xul5P:5", "Xul5P:6", "Xul5P:9", "Xul5P:10", "Xul5P:12", "Xul5P:17", "Xul5P:18", "Xul5P:20", "Xul5P:24", "Rub5P:3", "Rub5P:5", "Rub5P:6", "Rub5P:9", "Rub5P:10", "Rub5P:12", "Rub5P:17", "Rub5P:18", "Rub5P:20", "Rub5P:24", "Glc6P:3", "Glc6P:5", "Glc6P:6", "Glc6P:9", "Glc6P:10", "Glc6P:12", "Glc6P:17", "Glc6P:18", "Glc6P:20", "Glc6P:24", "Glc6P:33", "Glc6P:34", "Glc6P:36", "Glc6P:40", "Glc6P:48", "Fru6P:3", "Fru6P:5", "Fru6P:6", "Fru6P:9", "Fru6P:10", "Fru6P:12", "Fru6P:17", "Fru6P:18", "Fru6P:20", "Fru6P:24", "Fru6P:33", "Fru6P:34", "Fru6P:36", "Fru6P:40", "Fru6P:48", "Cit:3", "Cit:5", "Cit:9", "Cit:17", "Cit:33", "Cit:6", "Cit:10", "Cit:18", "Cit:34", "Cit:12", "Cit:20", "Cit:36", "Cit:24", "Cit:40", "Cit:48", "E2:3", "E3:3", "E3:5", "E3:6", "Pyr:3", "Pyr:5", "Pyr:6", "GA3P:3", "GA3P:5", "GA3P:6", "Ery4P:3", "Ery4P:5", "Ery4P:6", "Ery4P:9", "Ery4P:10", "Ery4P:12", "OAA:12", "OAA:10", "OAA:6", "OAA:9", "OAA:5", "OAA:3", "AKG:3", "AKG:5", "AKG:9", "AKG:17", "AKG:6", "AKG:10", "AKG:18", "AKG:12", "AKG:20", "AKG:24", "Suc:3", "Suc:5", "Suc:9", "Suc:6", "Suc:10", "Suc:12", "Glc:3", "Glc:5", "Glc:6", "Glc:9", "Glc:10", "Glc:12", "Glc:17", "Glc:18", "Glc:20", "Glc:24", "Glc:33", "Glc:34", "Glc:36", "Glc:40", "Glc:48", "Mal:7", "Mal:11", "Mal:13", "Mal:14", "PEP:7", "PGA:7", "Gnt6P:7", "Gnt6P:11", "Gnt6P:13", "Gnt6P:14", "Gnt6P:19", "Gnt6P:21", "Gnt6P:22", "Gnt6P:25", "Gnt6P:26", "Gnt6P:28", "Gnt6P:35", "Gnt6P:37", "Gnt6P:38", "Gnt6P:41", "Gnt6P:42", "Gnt6P:44", "Gnt6P:49", "Gnt6P:50", "Gnt6P:52", "Gnt6P:56", "Sed7P:7", "Sed7P:11", "Sed7P:13", "Sed7P:14", "Sed7P:19", "Sed7P:21", "Sed7P:22", "Sed7P:25", "Sed7P:26", "Sed7P:28", "Sed7P:35", "Sed7P:37", "Sed7P:38", "Sed7P:41", "Sed7P:42", "Sed7P:44", "Sed7P:49", "Sed7P:50", "Sed7P:52", "Sed7P:56", "Sed7P:67", "Sed7P:69", "Sed7P:70", "Sed7P:73", "Sed7P:74", "Sed7P:76", "Sed7P:81", "Sed7P:82", "Sed7P:84", "Sed7P:88", "Sed7P:97", "Sed7P:98", "Sed7P:100", "Sed7P:104", "Sed7P:112", "FruBP:7", "FruBP:11", "FruBP:13", "FruBP:14", "FruBP:19", "FruBP:21", "FruBP:22", "FruBP:25", "FruBP:26", "FruBP:28", "FruBP:35", "FruBP:37", "FruBP:38", "FruBP:41", "FruBP:42", "FruBP:44", "FruBP:49", "FruBP:50", "FruBP:52", "FruBP:56", "Rib5P:7", "Rib5P:11", "Rib5P:13", "Rib5P:14", "Rib5P:19", "Rib5P:21", "Rib5P:22", "Rib5P:25", "Rib5P:26", "Rib5P:28", "Xul5P:7", "Xul5P:11", "Xul5P:13", "Xul5P:14", "Xul5P:19", "Xul5P:21", "Xul5P:22", "Xul5P:25", "Xul5P:26", "Xul5P:28", "Rub5P:7", "Rub5P:11", "Rub5P:13", "Rub5P:14", "Rub5P:19", "Rub5P:21", "Rub5P:22", "Rub5P:25", "Rub5P:26", "Rub5P:28", "Glc6P:7", "Glc6P:11", "Glc6P:13", "Glc6P:14", "Glc6P:19", "Glc6P:21", "Glc6P:22", "Glc6P:25", "Glc6P:26", "Glc6P:28", "Glc6P:35", "Glc6P:37", "Glc6P:38", "Glc6P:41", "Glc6P:42", "Glc6P:44", "Glc6P:49", "Glc6P:50", "Glc6P:52", "Glc6P:56", "Fru6P:7", "Fru6P:11", "Fru6P:13", "Fru6P:14", "Fru6P:19", "Fru6P:21", "Fru6P:22", "Fru6P:25", "Fru6P:26", "Fru6P:28", "Fru6P:35", "Fru6P:37", "Fru6P:38", "Fru6P:41", "Fru6P:42", "Fru6P:44", "Fru6P:49", "Fru6P:50", "Fru6P:52", "Fru6P:56", "Cit:7", "Cit:11", "Cit:13", "Cit:19", "Cit:21", "Cit:25", "Cit:35", "Cit:37", "Cit:41", "Cit:49", "Cit:14", "Cit:22", "Cit:26", "Cit:38", "Cit:42", "Cit:50", "Cit:28", "Cit:44", "Cit:52", "Cit:56", "E3:7", "Pyr:7", "GA3P:7", "Ery4P:7", "Ery4P:11", "Ery4P:13", "Ery4P:14", "OAA:14", "OAA:13", "OAA:11", "OAA:7", "AKG:7", "AKG:11", "AKG:13", "AKG:19", "AKG:21", "AKG:25", "AKG:14", "AKG:22", "AKG:26", "AKG:28", "Suc:7", "Suc:11", "Suc:13", "Suc:14", "Glc:7", "Glc:11", "Glc:13", "Glc:14", "Glc:19", "Glc:21", "Glc:22", "Glc:25", "Glc:26", "Glc:28", "Glc:35", "Glc:37", "Glc:38", "Glc:41", "Glc:42", "Glc:44", "Glc:49", "Glc:50", "Glc:52", "Glc:56", "Mal:15", "Gnt6P:15", "Gnt6P:23", "Gnt6P:27", "Gnt6P:29", "Gnt6P:30", "Gnt6P:39", "Gnt6P:43", "Gnt6P:45", "Gnt6P:46", "Gnt6P:51", "Gnt6P:53", "Gnt6P:54", "Gnt6P:57", "Gnt6P:58", "Gnt6P:60", "Sed7P:15", "Sed7P:23", "Sed7P:27", "Sed7P:29", "Sed7P:30", "Sed7P:39", "Sed7P:43", "Sed7P:45", "Sed7P:46", "Sed7P:51", "Sed7P:53", "Sed7P:54", "Sed7P:57", "Sed7P:58", "Sed7P:60", "Sed7P:71", "Sed7P:75", "Sed7P:77", "Sed7P:78", "Sed7P:83", "Sed7P:85", "Sed7P:86", "Sed7P:89", "Sed7P:90", "Sed7P:92", "Sed7P:99", "Sed7P:101", "Sed7P:102", "Sed7P:105", "Sed7P:106", "Sed7P:108", "Sed7P:113", "Sed7P:114", "Sed7P:116", "Sed7P:120", "FruBP:15", "FruBP:23", "FruBP:27", "FruBP:29", "FruBP:30", "FruBP:39", "FruBP:43", "FruBP:45", "FruBP:46", "FruBP:51", "FruBP:53", "FruBP:54", "FruBP:57", "FruBP:58", "FruBP:60", "Rib5P:15", "Rib5P:23", "Rib5P:27", "Rib5P:29", "Rib5P:30", "Xul5P:15", "Xul5P:23", "Xul5P:27", "Xul5P:29", "Xul5P:30", "Rub5P:15", "Rub5P:23", "Rub5P:27", "Rub5P:29", "Rub5P:30", "Glc6P:15", "Glc6P:23", "Glc6P:27", "Glc6P:29", "Glc6P:30", "Glc6P:39", "Glc6P:43", "Glc6P:45", "Glc6P:46", "Glc6P:51", "Glc6P:53", "Glc6P:54", "Glc6P:57", "Glc6P:58", "Glc6P:60", "Fru6P:15", "Fru6P:23", "Fru6P:27", "Fru6P:29", "Fru6P:30", "Fru6P:39", "Fru6P:43", "Fru6P:45", "Fru6P:46", "Fru6P:51", "Fru6P:53", "Fru6P:54", "Fru6P:57", "Fru6P:58", "Fru6P:60", "Cit:15", "Cit:23", "Cit:27", "Cit:29", "Cit:39", "Cit:43", "Cit:45", "Cit:51", "Cit:53", "Cit:57", "Cit:30", "Cit:46", "Cit:54", "Cit:58", "Cit:60", "Ery4P:15", "OAA:15", "AKG:15", "AKG:23", "AKG:27", "AKG:29", "AKG:30", "Suc:15", "Glc:15", "Glc:23", "Glc:27", "Glc:29", "Glc:30", "Glc:39", "Glc:43", "Glc:45", "Glc:46", "Glc:51", "Glc:53", "Glc:54", "Glc:57", "Glc:58", "Glc:60", "Gnt6P:31", "Gnt6P:47", "Gnt6P:55", "Gnt6P:59", "Gnt6P:61", "Gnt6P:62", "Sed7P:31", "Sed7P:47", "Sed7P:55", "Sed7P:59", "Sed7P:61", "Sed7P:62", "Sed7P:79", "Sed7P:87", "Sed7P:91", "Sed7P:93", "Sed7P:94", "Sed7P:103", "Sed7P:107", "Sed7P:109", "Sed7P:110", "Sed7P:115", "Sed7P:117", "Sed7P:118", "Sed7P:121", "Sed7P:122", "Sed7P:124", "FruBP:31", "FruBP:47", "FruBP:55", "FruBP:59", "FruBP:61", "FruBP:62", "Rib5P:31", "Xul5P:31", "Rub5P:31", "Glc6P:31", "Glc6P:47", "Glc6P:55", "Glc6P:59", "Glc6P:61", "Glc6P:62", "Fru6P:31", "Fru6P:47", "Fru6P:55", "Fru6P:59", "Fru6P:61", "Fru6P:62", "Cit:31", "Cit:47", "Cit:55", "Cit:59", "Cit:61", "Cit:62", "AKG:31", "Glc:31", "Glc:47", "Glc:55", "Glc:59", "Glc:61", "Glc:62", "Gnt6P:63", "Sed7P:63", "Sed7P:95", "Sed7P:111", "Sed7P:119", "Sed7P:123", "Sed7P:125", "Sed7P:126", "FruBP:63", "Glc6P:63", "Fru6P:63", "Cit:63", "Glc:63", "Sed7P:127")
nm_list$rcumo=nm_rcumo

if (case_i) {
   # check the coherence of metabolites/cumomers
   met_net=unique(matrix(unlist(strsplit(nm_rcumo, ":", fixed=TRUE)), nrow=2)[1,])
   net_pool=sort(setdiff(met_net, names(nm_poolall)))
   if (length(net_pool) > 0) {
      stop_mes("The following metabolites are internal in NETWORK section but not in METABOLITE_POOLS one:\n"%s+%paste(net_pool, collapse="\n"), file=fcerr)
   }
}

nb_exp=1
nm_exp=c("e_coli_growth")
nm_list$nm_exp=nm_exp
# input cumomer vectors
xi=c(0, 0.952, 0, 0.96, 0, 0.96, 0, 0.96, 0, 0.96, 0, 0.96, 0, 0.96, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.968, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.976, 0, 0.984, 0, 0.984, 0, 0.984, 0, 0.984, 0, 0.984, 0, 0.984, 0, 0.984, 0, 0.984, 0, 0.984, 0, 0.984, 0.0107, 0.984, 0.0107, 0.984, 0.0107, 0.984, 0.0107, 0.984, 0.0107, 0.984, 0.0107, 0.0107, 0.992, 0.0107, 0.992, 0.0107, 0.992, 0.0107, 0.992, 0.0107, 0.992, 1.0000000000000002, 0.992)
if (length(xi)) {
   dim(xi)=c(length(xi)/nb_exp, nb_exp)
} else {
   stop_mes("No reduced label entry is defined (may be because no measurement defined in FTBL). Cannot continue.", file=fcerr)
}
nm_xi=c("Gluc_1:63", "Gluc_U:63", "Gluc_1:31", "Gluc_U:31", "Gluc_1:47", "Gluc_U:47", "Gluc_1:55", "Gluc_U:55", "Gluc_1:59", "Gluc_U:59", "Gluc_1:61", "Gluc_U:61", "Gluc_1:62", "Gluc_U:62", "Gluc_1:15", "Gluc_U:15", "Gluc_1:23", "Gluc_U:23", "Gluc_1:27", "Gluc_U:27", "Gluc_1:29", "Gluc_U:29", "Gluc_1:30", "Gluc_U:30", "Gluc_1:39", "Gluc_U:39", "Gluc_1:43", "Gluc_U:43", "Gluc_1:45", "Gluc_U:45", "Gluc_1:46", "Gluc_U:46", "Gluc_1:51", "Gluc_U:51", "Gluc_1:53", "Gluc_U:53", "Gluc_1:54", "Gluc_U:54", "Gluc_1:57", "Gluc_U:57", "Gluc_1:58", "Gluc_U:58", "Gluc_1:60", "Gluc_U:60", "Gluc_1:7", "Gluc_U:7", "Gluc_1:11", "Gluc_U:11", "Gluc_1:13", "Gluc_U:13", "Gluc_1:14", "Gluc_U:14", "Gluc_1:19", "Gluc_U:19", "Gluc_1:21", "Gluc_U:21", "Gluc_1:22", "Gluc_U:22", "Gluc_1:25", "Gluc_U:25", "Gluc_1:26", "Gluc_U:26", "Gluc_1:28", "Gluc_U:28", "Gluc_1:35", "Gluc_U:35", "Gluc_1:37", "Gluc_U:37", "Gluc_1:38", "Gluc_U:38", "Gluc_1:41", "Gluc_U:41", "Gluc_1:42", "Gluc_U:42", "Gluc_1:44", "Gluc_U:44", "Gluc_1:49", "Gluc_U:49", "Gluc_1:50", "Gluc_U:50", "Gluc_1:52", "Gluc_U:52", "Gluc_1:56", "Gluc_U:56", "Gluc_1:3", "Gluc_U:3", "Gluc_1:5", "Gluc_U:5", "Gluc_1:6", "Gluc_U:6", "Gluc_1:9", "Gluc_U:9", "Gluc_1:10", "Gluc_U:10", "Gluc_1:12", "Gluc_U:12", "Gluc_1:17", "Gluc_U:17", "Gluc_1:18", "Gluc_U:18", "Gluc_1:20", "Gluc_U:20", "Gluc_1:24", "Gluc_U:24", "Gluc_1:33", "Gluc_U:33", "Gluc_1:34", "Gluc_U:34", "Gluc_1:36", "Gluc_U:36", "Gluc_1:40", "Gluc_U:40", "Gluc_1:48", "Gluc_U:48", "CO2_ext:1", "Gluc_1:1", "Gluc_U:1", "Gluc_1:2", "Gluc_U:2", "Gluc_1:4", "Gluc_U:4", "Gluc_1:8", "Gluc_U:8", "Gluc_1:16", "Gluc_U:16", "Gluc_1:32", "Gluc_U:32")
rownames(xi)=nm_xi
nm_list$xi=nm_xi
nb_xi=length(nm_xi)
nb_f$xi=nb_xi
nb_cumoi=nb_xi
nm_inp=nm_xi
nm_incu=c("one", nm_xi, nm_rcumo)
nm_inlab=nm_incu
spa=spAbr
nm_x=nm_rcumo
nb_x=nb_rcumos
nb_f$rcumos=nb_rcumos
nb_f$cumoi=nb_cumoi
if (emu) {
   nm_emu=c()
   nb_emus=nb_rcumos*(seq_len(nb_rw)+1)
   nb_f$emus=nb_emus
   nm_list$emu=nm_emu
   nm_x=nm_emu
   nb_x=nb_emus
   xiemu=matrix(c(), ncol=nb_exp)
   nm_xiemu=c()
   nm_list$xiemu=nm_xiemu
   rownames(xiemu)=nm_xiemu
   nb_xiemu=length(nm_xiemu)
   nb_f$xiemu=nb_xiemu
   nb_f$xi=nb_xiemu
   nb_xi=nb_xiemu
   nm_inp=nm_xiemu
   xi=xiemu
   nm_inemu=c("one", nm_xiemu, nm_emu)
   nm_inlab=nm_inemu
   spa=spr2emu(spAbr, nm_incu, nm_inemu, nb_f)
}
# reorder indexes to accelerate sparse matrix construction
spa=sparse2spa(spa)
#browser()
# composite labeling vector incu c(1, xi, xc) names
nm_inlab=c("one", nm_inp, nm_x); # the constant 1 has name "one"
nm_list$x=nm_x
nm_list$inp=nm_inp
nb_f$x=nb_x
nm_cumo=NULL

if (TIMEIT) {
   cat("measure : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
if (!noscale) {
   # make place for scaling factors
   nb_sc=vector("integer", 1)
# experiment: 1

   # mass
   # initial values for scales are set later
   param=c(param,1, 1, 1, 1, 1, 1, 1, 1, 1, 1)
   nm_par=c(nm_par,c("1:mass;Cit;111111;762", "1:mass;Fru6P;111111;754", "1:mass;FruBP;111111;734", "1:mass;Glc6P;111111;747", "1:mass;Gnt6P;111111;719", "1:mass;Mal;1111;707", "1:mass;PEP;111;711", "1:mass;PGA;111;715", "1:mass;Rib5P+Xul5P+Rub5P;11111;741", "1:mass;Sed7P;1111111;726"))
   names(param)=nm_par

   nb_param=length(param)
   nb_sc[1]=nb_param-nb_ff # at this moment it is cumulated sum. diff() is taken later

   # indices mapping from scaling to measure matrix row
   # c(1,par)[ir2isc[[iexp]]] replicates scale parameters
   # for corresponding rows of measure matrix
   ir2isc=vector("list", 1)

   # 1:label
   ir2isc[[1]]=c(ir2isc[[1]],c(1, 1, 1, 1))

   # 1:mass
   ir2isc[[1]]=c(ir2isc[[1]],c(22, 22, 22, 22, 23, 23, 23, 23, 24, 24, 24, 24, 21, 21, 21, 21, 21, 21, 21, 26, 26, 26, 26, 26, 26, 26, 26, 19, 19, 19, 19, 19, 19, 19, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 20, 20, 20, 20, 20, 20, 20, 18, 18, 18, 18, 18, 18, 18, 17, 17, 17, 17, 17, 17))

   # cumulated base for nb_sc
   nb_sc_base=c(0, nb_sc[-nb_exp])
   nb_sc=diff(c(0, nb_sc))
   nb_sc_tot=sum(nb_sc)
   nb_f$nb_sc=nb_sc
   nb_f$nb_sc_tot=nb_sc_tot
   nb_f$nb_sc_base=nb_sc_base
#browser()
} else {
   # no scaling
   ir2isc=list()
   nb_sc=integer(nb_exp)
   nb_sc_tot=0
}
nb_f$nb_sc=nb_sc
nb_f$nb_sc_tot=nb_sc_tot
nm_list$par=nm_par

# make a list of sparse measurement matrices
# measmat*xr+memaone gives a vector of simulated not-yet-pooled and not-yet-scaled measurements
# all but 0. Coefficients of 0-cumomers (by defenition equal to 1)
# are all regrouped in the memaone.
nm_measmat=nm_meas=nb_meas=nb_measmat=measmat=memaone=measvec=measdev=ipooled=vector("list", 1)

nm_measmat[[1]]=c("l:AcCoA:#00:682", "l:AcCoA:#01:683", "l:AcCoA:#10:684", "l:AcCoA:#11:685", "m:Mal:1,2,3,4:1:707", "m:Mal:1,2,3,4:2:708", "m:Mal:1,2,3,4:3:709", "m:Mal:1,2,3,4:4:710", "m:PEP:1,2,3:0:711", "m:PEP:1,2,3:1:712", "m:PEP:1,2,3:2:713", "m:PEP:1,2,3:3:714", "m:PGA:1,2,3:0:715", "m:PGA:1,2,3:1:716", "m:PGA:1,2,3:2:717", "m:PGA:1,2,3:3:718", "m:Gnt6P:1,2,3,4,5,6:0:719", "m:Gnt6P:1,2,3,4,5,6:1:720", "m:Gnt6P:1,2,3,4,5,6:2:721", "m:Gnt6P:1,2,3,4,5,6:3:722", "m:Gnt6P:1,2,3,4,5,6:4:723", "m:Gnt6P:1,2,3,4,5,6:5:724", "m:Gnt6P:1,2,3,4,5,6:6:725", "m:Sed7P:1,2,3,4,5,6,7:0:726", "m:Sed7P:1,2,3,4,5,6,7:1:727", "m:Sed7P:1,2,3,4,5,6,7:2:728", "m:Sed7P:1,2,3,4,5,6,7:3:729", "m:Sed7P:1,2,3,4,5,6,7:4:730", "m:Sed7P:1,2,3,4,5,6,7:5:731", "m:Sed7P:1,2,3,4,5,6,7:6:732", "m:Sed7P:1,2,3,4,5,6,7:7:733", "m:FruBP:1,2,3,4,5,6:0:734", "m:FruBP:1,2,3,4,5,6:1:735", "m:FruBP:1,2,3,4,5,6:2:736", "m:FruBP:1,2,3,4,5,6:3:737", "m:FruBP:1,2,3,4,5,6:4:738", "m:FruBP:1,2,3,4,5,6:5:739", "m:FruBP:1,2,3,4,5,6:6:740", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:0:741", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:0:741", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:0:741", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:1:742", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:1:742", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:1:742", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:2:743", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:2:743", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:2:743", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:3:744", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:3:744", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:3:744", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:4:745", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:4:745", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:4:745", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:5:746", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:5:746", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:5:746", "m:Glc6P:1,2,3,4,5,6:0:747", "m:Glc6P:1,2,3,4,5,6:1:748", "m:Glc6P:1,2,3,4,5,6:2:749", "m:Glc6P:1,2,3,4,5,6:3:750", "m:Glc6P:1,2,3,4,5,6:4:751", "m:Glc6P:1,2,3,4,5,6:5:752", "m:Glc6P:1,2,3,4,5,6:6:753", "m:Fru6P:1,2,3,4,5,6:0:754", "m:Fru6P:1,2,3,4,5,6:1:755", "m:Fru6P:1,2,3,4,5,6:2:756", "m:Fru6P:1,2,3,4,5,6:3:757", "m:Fru6P:1,2,3,4,5,6:4:758", "m:Fru6P:1,2,3,4,5,6:5:759", "m:Fru6P:1,2,3,4,5,6:6:760", "m:Cit:1,2,3,4,5,6:1:762", "m:Cit:1,2,3,4,5,6:2:763", "m:Cit:1,2,3,4,5,6:3:764", "m:Cit:1,2,3,4,5,6:4:765", "m:Cit:1,2,3,4,5,6:5:766", "m:Cit:1,2,3,4,5,6:6:767")
nm_meas[[1]]=c("l:AcCoA:#00:682", "l:AcCoA:#01:683", "l:AcCoA:#10:684", "l:AcCoA:#11:685", "m:Mal:1,2,3,4:1:707", "m:Mal:1,2,3,4:2:708", "m:Mal:1,2,3,4:3:709", "m:Mal:1,2,3,4:4:710", "m:PEP:1,2,3:0:711", "m:PEP:1,2,3:1:712", "m:PEP:1,2,3:2:713", "m:PEP:1,2,3:3:714", "m:PGA:1,2,3:0:715", "m:PGA:1,2,3:1:716", "m:PGA:1,2,3:2:717", "m:PGA:1,2,3:3:718", "m:Gnt6P:1,2,3,4,5,6:0:719", "m:Gnt6P:1,2,3,4,5,6:1:720", "m:Gnt6P:1,2,3,4,5,6:2:721", "m:Gnt6P:1,2,3,4,5,6:3:722", "m:Gnt6P:1,2,3,4,5,6:4:723", "m:Gnt6P:1,2,3,4,5,6:5:724", "m:Gnt6P:1,2,3,4,5,6:6:725", "m:Sed7P:1,2,3,4,5,6,7:0:726", "m:Sed7P:1,2,3,4,5,6,7:1:727", "m:Sed7P:1,2,3,4,5,6,7:2:728", "m:Sed7P:1,2,3,4,5,6,7:3:729", "m:Sed7P:1,2,3,4,5,6,7:4:730", "m:Sed7P:1,2,3,4,5,6,7:5:731", "m:Sed7P:1,2,3,4,5,6,7:6:732", "m:Sed7P:1,2,3,4,5,6,7:7:733", "m:FruBP:1,2,3,4,5,6:0:734", "m:FruBP:1,2,3,4,5,6:1:735", "m:FruBP:1,2,3,4,5,6:2:736", "m:FruBP:1,2,3,4,5,6:3:737", "m:FruBP:1,2,3,4,5,6:4:738", "m:FruBP:1,2,3,4,5,6:5:739", "m:FruBP:1,2,3,4,5,6:6:740", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:0:741", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:1:742", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:2:743", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:3:744", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:4:745", "m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:5:746", "m:Glc6P:1,2,3,4,5,6:0:747", "m:Glc6P:1,2,3,4,5,6:1:748", "m:Glc6P:1,2,3,4,5,6:2:749", "m:Glc6P:1,2,3,4,5,6:3:750", "m:Glc6P:1,2,3,4,5,6:4:751", "m:Glc6P:1,2,3,4,5,6:5:752", "m:Glc6P:1,2,3,4,5,6:6:753", "m:Fru6P:1,2,3,4,5,6:0:754", "m:Fru6P:1,2,3,4,5,6:1:755", "m:Fru6P:1,2,3,4,5,6:2:756", "m:Fru6P:1,2,3,4,5,6:3:757", "m:Fru6P:1,2,3,4,5,6:4:758", "m:Fru6P:1,2,3,4,5,6:5:759", "m:Fru6P:1,2,3,4,5,6:6:760", "m:Cit:1,2,3,4,5,6:1:762", "m:Cit:1,2,3,4,5,6:2:763", "m:Cit:1,2,3,4,5,6:3:764", "m:Cit:1,2,3,4,5,6:4:765", "m:Cit:1,2,3,4,5,6:5:766", "m:Cit:1,2,3,4,5,6:6:767")
nb_meas[[1]]=length(nm_meas[[1]])
nb_measmat[[1]]=length(nm_measmat[[1]])
measmat[[1]]=simple_triplet_zero_matrix(nrow=nb_measmat[[1]], ncol=731)
dimnames(measmat[[1]])=list(nm_measmat[[1]], nm_x)
memaone[[1]]=numeric(nb_measmat[[1]])
measvec[[1]]=c(0.495, 0.303, 0.012, 0.19, 0.587391867374382, 0.216493214407424, 0.159494782909672, 0.0366201353085213, 0.462166666666667, 0.340003333333333, 0.0273166666666667, 0.170513333333333, 0.447066666666667, 0.34127, 0.02441, 0.187253333333333, 0.0195533333333333, 0.72562, 0.0571233333333333, 0.0135033333333333, 0.01331, 0.0131033333333333, 0.157793333333333, 0.272433333333333, 0.23752, 0.180446666666667, 0.12744, 0.06321, 0.0839233333333333, 0.01751, 0.0175266666666667, 0.0853733333333333, 0.482283333333333, 0.140086666666667, 0.0953466666666667, 0.09712, 0.0120166666666667, 0.0877666666666667, 0.433956666666667, 0.215956666666667, 0.09658, 0.129033333333333, 0.0272733333333333, 0.0971933333333333, 0.0167633333333333, 0.716826666666667, 0.0578233333333333, 0.0122433333333333, 0.01151, 0.01089, 0.173946666666667, 0.04716, 0.623343333333333, 0.0820266666666667, 0.03604, 0.0315766666666667, 0.0149133333333333, 0.164943333333333, 0.322208057034832, 0.288291305558056, 0.212855540659154, 0.117626468347467, 0.0484839619377435, 0.0105346664627478)
measdev[[1]]=c(0.02, 0.02, 0.02, 0.02, 0.0493159626907812, 0.0306546571894417, 0.03, 0.03, 0.01, 0.01, 0.01, 0.01, 0.0180848260520618, 0.018075350619006, 0.01, 0.01, 0.01, 0.0120547874307264, 0.01, 0.01, 0.01, 0.01, 0.01, 0.0122309539012022, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.02, 0.0115292555411585, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.0106878170518274, 0.01, 0.01, 0.01, 0.01, 0.0111688555068697, 0.03, 0.03, 0.03, 0.03, 0.03, 0.03)
names(measvec[[1]])=nm_meas[[1]]
names(measdev[[1]])=nm_meas[[1]]
ipooled[[1]]=list(ishort=pmatch(nm_meas[[1]], nm_measmat[[1]]))

nm_meas_tot=unlist(nm_meas)
nb_meas=unlist(nb_meas)
nb_meas_cumo=c(0., cumsum(nb_meas[-nb_exp]))
iexp_meas=lapply(seq_len(nb_exp), function(iexp) seq_len(nb_meas[iexp])+nb_meas_cumo[iexp])
nm_list$meas=nm_meas
nm_list$measmat=nm_measmat
nm_list$meas_tot=nm_meas_tot
nb_f$nb_meas=nb_meas

# prepare indices of pooled measurements
ipooled[[1]][["m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:0:741"]]=1+4+c(34, 35, 36)

# prepare indices of pooled measurements
ipooled[[1]][["m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:1:742"]]=1+4+c(37, 38, 39)

# prepare indices of pooled measurements
ipooled[[1]][["m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:2:743"]]=1+4+c(40, 41, 42)

# prepare indices of pooled measurements
ipooled[[1]][["m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:3:744"]]=1+4+c(43, 44, 45)

# prepare indices of pooled measurements
ipooled[[1]][["m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:4:745"]]=1+4+c(46, 47, 48)

# prepare indices of pooled measurements
ipooled[[1]][["m:Rib5P+Xul5P+Rub5P:1,2,3,4,5:5:746"]]=1+4+c(49, 50, 51)

names(measvec)=names(measdev)=nm_exp

if (!noscale) {
   for (iexp in seq_len(nb_exp))
      ir2isc[[iexp]]=ir2isc[[iexp]][ipooled[[iexp]]$ishort]

   # prepare indexes of dispatching scale params in jacobian
   if (nb_sc_tot > 0) {
      nb_f$is2m=vector("list", nb_exp)
      for (iexp in seq_len(nb_exp)) {
         ipaire=matrix(0, nrow=0, ncol=2)
         tmp=lapply(seq_len(nb_sc[[iexp]]), function(isc) {
            i=which(ir2isc[[iexp]]==isc+nb_sc_base[iexp]+1+nb_ff)
            ipaire <<- rbind(ipaire, cbind(i, isc+nb_sc_base[iexp]))
            return(NULL)
         })
         nb_f$is2m[[iexp]]=ipaire
         # place holder for scale part of jacobian
         jx_f$dr_dsc[[iexp]]=simple_triplet_zero_matrix(nrow=length(ir2isc[[iexp]]), ncol=nb_sc_tot)
      }
   }
}
# prepare measmat indexes and values : ir, ic, val

ind_mema=matrix(c(
1, 100, 1, 1, 1, -1, 1, 2, -1,
2, 1, 1, 2, 100, -1,
3, 2, 1, 3, 100, -1,
4, 100, 1,
5, 3, 1, 5, 292, 3, 5, 293, 3, 5, 294, 3, 5, 101, -2, 5, 102, -2, 5, 103, -2, 5, 508, -4, 5, 4, 1, 5, 295, 3, 5, 104, -2, 5, 105, -2, 5, 5, 1, 5, 106, -2, 5, 6, 1,
6, 101, 1, 6, 508, 6, 6, 292, -3, 6, 293, -3, 6, 102, 1, 6, 294, -3, 6, 104, 1, 6, 295, -3, 6, 103, 1, 6, 105, 1, 6, 106, 1,
7, 292, 1, 7, 508, -4, 7, 293, 1, 7, 294, 1, 7, 295, 1,
8, 508, 1,
9, 107, 1, 9, 108, 1, 9, 109, 1, 9, 7, -1, 9, 8, -1, 9, 9, -1, 9, 296, -1,
10, 7, 1, 10, 296, 3, 10, 107, -2, 10, 108, -2, 10, 8, 1, 10, 109, -2, 10, 9, 1,
11, 107, 1, 11, 296, -3, 11, 108, 1, 11, 109, 1,
12, 296, 1,
13, 110, 1, 13, 111, 1, 13, 112, 1, 13, 10, -1, 13, 11, -1, 13, 12, -1, 13, 297, -1,
14, 10, 1, 14, 297, 3, 14, 110, -2, 14, 111, -2, 14, 11, 1, 14, 112, -2, 14, 12, 1,
15, 110, 1, 15, 297, -3, 15, 111, 1, 15, 112, 1,
16, 297, 1,
17, 113, 1, 17, 114, 1, 17, 115, 1, 17, 116, 1, 17, 117, 1, 17, 118, 1, 17, 509, 1, 17, 119, 1, 17, 120, 1, 17, 121, 1, 17, 510, 1, 17, 122, 1, 17, 511, 1, 17, 512, 1, 17, 513, 1, 17, 123, 1, 17, 124, 1, 17, 125, 1, 17, 514, 1, 17, 126, 1, 17, 515, 1, 17, 516, 1, 17, 517, 1, 17, 127, 1, 17, 518, 1, 17, 519, 1, 17, 520, 1, 17, 521, 1, 17, 522, 1, 17, 523, 1, 17, 718, 1, 17, 13, -1, 17, 14, -1, 17, 15, -1, 17, 298, -1, 17, 16, -1, 17, 299, -1, 17, 300, -1, 17, 301, -1, 17, 17, -1, 17, 302, -1, 17, 303, -1, 17, 304, -1, 17, 305, -1, 17, 306, -1, 17, 307, -1, 17, 657, -1, 17, 18, -1, 17, 308, -1, 17, 309, -1, 17, 310, -1, 17, 311, -1, 17, 312, -1, 17, 313, -1, 17, 658, -1, 17, 314, -1, 17, 315, -1, 17, 316, -1, 17, 659, -1, 17, 317, -1, 17, 660, -1, 17, 661, -1, 17, 662, -1,
18, 13, 1, 18, 298, 3, 18, 299, 3, 18, 300, 3, 18, 302, 3, 18, 303, 3, 18, 305, 3, 18, 657, 5, 18, 308, 3, 18, 309, 3, 18, 311, 3, 18, 658, 5, 18, 314, 3, 18, 659, 5, 18, 660, 5, 18, 661, 5, 18, 113, -2, 18, 114, -2, 18, 116, -2, 18, 509, -4, 18, 119, -2, 18, 510, -4, 18, 511, -4, 18, 512, -4, 18, 123, -2, 18, 514, -4, 18, 515, -4, 18, 516, -4, 18, 518, -4, 18, 519, -4, 18, 521, -4, 18, 718, -6, 18, 14, 1, 18, 301, 3, 18, 304, 3, 18, 306, 3, 18, 310, 3, 18, 312, 3, 18, 315, 3, 18, 662, 5, 18, 115, -2, 18, 117, -2, 18, 120, -2, 18, 513, -4, 18, 124, -2, 18, 517, -4, 18, 520, -4, 18, 522, -4, 18, 15, 1, 18, 307, 3, 18, 313, 3, 18, 316, 3, 18, 118, -2, 18, 121, -2, 18, 125, -2, 18, 523, -4, 18, 16, 1, 18, 317, 3, 18, 122, -2, 18, 126, -2, 18, 17, 1, 18, 127, -2, 18, 18, 1,
19, 113, 1, 19, 509, 6, 19, 510, 6, 19, 511, 6, 19, 514, 6, 19, 515, 6, 19, 518, 6, 19, 718, 15, 19, 298, -3, 19, 299, -3, 19, 302, -3, 19, 657, -10, 19, 308, -3, 19, 658, -10, 19, 659, -10, 19, 660, -10, 19, 114, 1, 19, 512, 6, 19, 516, 6, 19, 519, 6, 19, 300, -3, 19, 303, -3, 19, 309, -3, 19, 661, -10, 19, 115, 1, 19, 513, 6, 19, 517, 6, 19, 520, 6, 19, 301, -3, 19, 304, -3, 19, 310, -3, 19, 662, -10, 19, 116, 1, 19, 521, 6, 19, 305, -3, 19, 311, -3, 19, 117, 1, 19, 522, 6, 19, 306, -3, 19, 312, -3, 19, 118, 1, 19, 523, 6, 19, 307, -3, 19, 313, -3, 19, 119, 1, 19, 314, -3, 19, 120, 1, 19, 315, -3, 19, 121, 1, 19, 316, -3, 19, 122, 1, 19, 317, -3, 19, 123, 1, 19, 124, 1, 19, 125, 1, 19, 126, 1, 19, 127, 1,
20, 298, 1, 20, 657, 10, 20, 658, 10, 20, 659, 10, 20, 509, -4, 20, 510, -4, 20, 514, -4, 20, 718, -20, 20, 299, 1, 20, 660, 10, 20, 511, -4, 20, 515, -4, 20, 300, 1, 20, 661, 10, 20, 512, -4, 20, 516, -4, 20, 301, 1, 20, 662, 10, 20, 513, -4, 20, 517, -4, 20, 302, 1, 20, 518, -4, 20, 303, 1, 20, 519, -4, 20, 304, 1, 20, 520, -4, 20, 305, 1, 20, 521, -4, 20, 306, 1, 20, 522, -4, 20, 307, 1, 20, 523, -4, 20, 308, 1, 20, 309, 1, 20, 310, 1, 20, 311, 1, 20, 312, 1, 20, 313, 1, 20, 314, 1, 20, 315, 1, 20, 316, 1, 20, 317, 1,
21, 509, 1, 21, 718, 15, 21, 657, -5, 21, 658, -5, 21, 510, 1, 21, 659, -5, 21, 511, 1, 21, 660, -5, 21, 512, 1, 21, 661, -5, 21, 513, 1, 21, 662, -5, 21, 514, 1, 21, 515, 1, 21, 516, 1, 21, 517, 1, 21, 518, 1, 21, 519, 1, 21, 520, 1, 21, 521, 1, 21, 522, 1, 21, 523, 1,
22, 657, 1, 22, 718, -6, 22, 658, 1, 22, 659, 1, 22, 660, 1, 22, 661, 1, 22, 662, 1,
23, 718, 1,
24, 128, 1, 24, 129, 1, 24, 130, 1, 24, 131, 1, 24, 132, 1, 24, 133, 1, 24, 524, 1, 24, 134, 1, 24, 135, 1, 24, 136, 1, 24, 525, 1, 24, 137, 1, 24, 526, 1, 24, 527, 1, 24, 528, 1, 24, 138, 1, 24, 139, 1, 24, 140, 1, 24, 529, 1, 24, 141, 1, 24, 530, 1, 24, 531, 1, 24, 532, 1, 24, 142, 1, 24, 533, 1, 24, 534, 1, 24, 535, 1, 24, 536, 1, 24, 537, 1, 24, 538, 1, 24, 719, 1, 24, 143, 1, 24, 144, 1, 24, 145, 1, 24, 539, 1, 24, 146, 1, 24, 540, 1, 24, 541, 1, 24, 542, 1, 24, 147, 1, 24, 543, 1, 24, 544, 1, 24, 545, 1, 24, 546, 1, 24, 547, 1, 24, 548, 1, 24, 720, 1, 24, 148, 1, 24, 549, 1, 24, 550, 1, 24, 551, 1, 24, 552, 1, 24, 553, 1, 24, 554, 1, 24, 721, 1, 24, 555, 1, 24, 556, 1, 24, 557, 1, 24, 722, 1, 24, 558, 1, 24, 723, 1, 24, 724, 1, 24, 725, 1, 24, 19, -1, 24, 20, -1, 24, 21, -1, 24, 318, -1, 24, 22, -1, 24, 319, -1, 24, 320, -1, 24, 321, -1, 24, 23, -1, 24, 322, -1, 24, 323, -1, 24, 324, -1, 24, 325, -1, 24, 326, -1, 24, 327, -1, 24, 663, -1, 24, 24, -1, 24, 328, -1, 24, 329, -1, 24, 330, -1, 24, 331, -1, 24, 332, -1, 24, 333, -1, 24, 664, -1, 24, 334, -1, 24, 335, -1, 24, 336, -1, 24, 665, -1, 24, 337, -1, 24, 666, -1, 24, 667, -1, 24, 668, -1, 24, 25, -1, 24, 338, -1, 24, 339, -1, 24, 340, -1, 24, 341, -1, 24, 342, -1, 24, 343, -1, 24, 669, -1, 24, 344, -1, 24, 345, -1, 24, 346, -1, 24, 670, -1, 24, 347, -1, 24, 671, -1, 24, 672, -1, 24, 673, -1, 24, 348, -1, 24, 349, -1, 24, 350, -1, 24, 674, -1, 24, 351, -1, 24, 675, -1, 24, 676, -1, 24, 677, -1, 24, 352, -1, 24, 678, -1, 24, 679, -1, 24, 680, -1, 24, 681, -1, 24, 682, -1, 24, 683, -1, 24, 731, -1,
25, 19, 1, 25, 318, 3, 25, 319, 3, 25, 320, 3, 25, 322, 3, 25, 323, 3, 25, 325, 3, 25, 663, 5, 25, 328, 3, 25, 329, 3, 25, 331, 3, 25, 664, 5, 25, 334, 3, 25, 665, 5, 25, 666, 5, 25, 667, 5, 25, 338, 3, 25, 339, 3, 25, 341, 3, 25, 669, 5, 25, 344, 3, 25, 670, 5, 25, 671, 5, 25, 672, 5, 25, 348, 3, 25, 674, 5, 25, 675, 5, 25, 676, 5, 25, 678, 5, 25, 679, 5, 25, 681, 5, 25, 731, 7, 25, 128, -2, 25, 129, -2, 25, 131, -2, 25, 524, -4, 25, 134, -2, 25, 525, -4, 25, 526, -4, 25, 527, -4, 25, 138, -2, 25, 529, -4, 25, 530, -4, 25, 531, -4, 25, 533, -4, 25, 534, -4, 25, 536, -4, 25, 719, -6, 25, 143, -2, 25, 539, -4, 25, 540, -4, 25, 541, -4, 25, 543, -4, 25, 544, -4, 25, 546, -4, 25, 720, -6, 25, 549, -4, 25, 550, -4, 25, 552, -4, 25, 721, -6, 25, 555, -4, 25, 722, -6, 25, 723, -6, 25, 724, -6, 25, 20, 1, 25, 321, 3, 25, 324, 3, 25, 326, 3, 25, 330, 3, 25, 332, 3, 25, 335, 3, 25, 668, 5, 25, 340, 3, 25, 342, 3, 25, 345, 3, 25, 673, 5, 25, 349, 3, 25, 677, 5, 25, 680, 5, 25, 682, 5, 25, 130, -2, 25, 132, -2, 25, 135, -2, 25, 528, -4, 25, 139, -2, 25, 532, -4, 25, 535, -4, 25, 537, -4, 25, 144, -2, 25, 542, -4, 25, 545, -4, 25, 547, -4, 25, 551, -4, 25, 553, -4, 25, 556, -4, 25, 725, -6, 25, 21, 1, 25, 327, 3, 25, 333, 3, 25, 336, 3, 25, 343, 3, 25, 346, 3, 25, 350, 3, 25, 683, 5, 25, 133, -2, 25, 136, -2, 25, 140, -2, 25, 538, -4, 25, 145, -2, 25, 548, -4, 25, 554, -4, 25, 557, -4, 25, 22, 1, 25, 337, 3, 25, 347, 3, 25, 351, 3, 25, 137, -2, 25, 141, -2, 25, 146, -2, 25, 558, -4, 25, 23, 1, 25, 352, 3, 25, 142, -2, 25, 147, -2, 25, 24, 1, 25, 148, -2, 25, 25, 1,
26, 128, 1, 26, 524, 6, 26, 525, 6, 26, 526, 6, 26, 529, 6, 26, 530, 6, 26, 533, 6, 26, 719, 15, 26, 539, 6, 26, 540, 6, 26, 543, 6, 26, 720, 15, 26, 549, 6, 26, 721, 15, 26, 722, 15, 26, 723, 15, 26, 318, -3, 26, 319, -3, 26, 322, -3, 26, 663, -10, 26, 328, -3, 26, 664, -10, 26, 665, -10, 26, 666, -10, 26, 338, -3, 26, 669, -10, 26, 670, -10, 26, 671, -10, 26, 674, -10, 26, 675, -10, 26, 678, -10, 26, 731, -21, 26, 129, 1, 26, 527, 6, 26, 531, 6, 26, 534, 6, 26, 541, 6, 26, 544, 6, 26, 550, 6, 26, 724, 15, 26, 320, -3, 26, 323, -3, 26, 329, -3, 26, 667, -10, 26, 339, -3, 26, 672, -10, 26, 676, -10, 26, 679, -10, 26, 130, 1, 26, 528, 6, 26, 532, 6, 26, 535, 6, 26, 542, 6, 26, 545, 6, 26, 551, 6, 26, 725, 15, 26, 321, -3, 26, 324, -3, 26, 330, -3, 26, 668, -10, 26, 340, -3, 26, 673, -10, 26, 677, -10, 26, 680, -10, 26, 131, 1, 26, 536, 6, 26, 546, 6, 26, 552, 6, 26, 325, -3, 26, 331, -3, 26, 341, -3, 26, 681, -10, 26, 132, 1, 26, 537, 6, 26, 547, 6, 26, 553, 6, 26, 326, -3, 26, 332, -3, 26, 342, -3, 26, 682, -10, 26, 133, 1, 26, 538, 6, 26, 548, 6, 26, 554, 6, 26, 327, -3, 26, 333, -3, 26, 343, -3, 26, 683, -10, 26, 134, 1, 26, 555, 6, 26, 334, -3, 26, 344, -3, 26, 135, 1, 26, 556, 6, 26, 335, -3, 26, 345, -3, 26, 136, 1, 26, 557, 6, 26, 336, -3, 26, 346, -3, 26, 137, 1, 26, 558, 6, 26, 337, -3, 26, 347, -3, 26, 138, 1, 26, 348, -3, 26, 139, 1, 26, 349, -3, 26, 140, 1, 26, 350, -3, 26, 141, 1, 26, 351, -3, 26, 142, 1, 26, 352, -3, 26, 143, 1, 26, 144, 1, 26, 145, 1, 26, 146, 1, 26, 147, 1, 26, 148, 1,
27, 318, 1, 27, 663, 10, 27, 664, 10, 27, 665, 10, 27, 669, 10, 27, 670, 10, 27, 674, 10, 27, 731, 35, 27, 524, -4, 27, 525, -4, 27, 529, -4, 27, 719, -20, 27, 539, -4, 27, 720, -20, 27, 721, -20, 27, 722, -20, 27, 319, 1, 27, 666, 10, 27, 671, 10, 27, 675, 10, 27, 526, -4, 27, 530, -4, 27, 540, -4, 27, 723, -20, 27, 320, 1, 27, 667, 10, 27, 672, 10, 27, 676, 10, 27, 527, -4, 27, 531, -4, 27, 541, -4, 27, 724, -20, 27, 321, 1, 27, 668, 10, 27, 673, 10, 27, 677, 10, 27, 528, -4, 27, 532, -4, 27, 542, -4, 27, 725, -20, 27, 322, 1, 27, 678, 10, 27, 533, -4, 27, 543, -4, 27, 323, 1, 27, 679, 10, 27, 534, -4, 27, 544, -4, 27, 324, 1, 27, 680, 10, 27, 535, -4, 27, 545, -4, 27, 325, 1, 27, 681, 10, 27, 536, -4, 27, 546, -4, 27, 326, 1, 27, 682, 10, 27, 537, -4, 27, 547, -4, 27, 327, 1, 27, 683, 10, 27, 538, -4, 27, 548, -4, 27, 328, 1, 27, 549, -4, 27, 329, 1, 27, 550, -4, 27, 330, 1, 27, 551, -4, 27, 331, 1, 27, 552, -4, 27, 332, 1, 27, 553, -4, 27, 333, 1, 27, 554, -4, 27, 334, 1, 27, 555, -4, 27, 335, 1, 27, 556, -4, 27, 336, 1, 27, 557, -4, 27, 337, 1, 27, 558, -4, 27, 338, 1, 27, 339, 1, 27, 340, 1, 27, 341, 1, 27, 342, 1, 27, 343, 1, 27, 344, 1, 27, 345, 1, 27, 346, 1, 27, 347, 1, 27, 348, 1, 27, 349, 1, 27, 350, 1, 27, 351, 1, 27, 352, 1,
28, 524, 1, 28, 719, 15, 28, 720, 15, 28, 721, 15, 28, 663, -5, 28, 664, -5, 28, 669, -5, 28, 731, -35, 28, 525, 1, 28, 722, 15, 28, 665, -5, 28, 670, -5, 28, 526, 1, 28, 723, 15, 28, 666, -5, 28, 671, -5, 28, 527, 1, 28, 724, 15, 28, 667, -5, 28, 672, -5, 28, 528, 1, 28, 725, 15, 28, 668, -5, 28, 673, -5, 28, 529, 1, 28, 674, -5, 28, 530, 1, 28, 675, -5, 28, 531, 1, 28, 676, -5, 28, 532, 1, 28, 677, -5, 28, 533, 1, 28, 678, -5, 28, 534, 1, 28, 679, -5, 28, 535, 1, 28, 680, -5, 28, 536, 1, 28, 681, -5, 28, 537, 1, 28, 682, -5, 28, 538, 1, 28, 683, -5, 28, 539, 1, 28, 540, 1, 28, 541, 1, 28, 542, 1, 28, 543, 1, 28, 544, 1, 28, 545, 1, 28, 546, 1, 28, 547, 1, 28, 548, 1, 28, 549, 1, 28, 550, 1, 28, 551, 1, 28, 552, 1, 28, 553, 1, 28, 554, 1, 28, 555, 1, 28, 556, 1, 28, 557, 1, 28, 558, 1,
29, 663, 1, 29, 731, 21, 29, 719, -6, 29, 720, -6, 29, 664, 1, 29, 721, -6, 29, 665, 1, 29, 722, -6, 29, 666, 1, 29, 723, -6, 29, 667, 1, 29, 724, -6, 29, 668, 1, 29, 725, -6, 29, 669, 1, 29, 670, 1, 29, 671, 1, 29, 672, 1, 29, 673, 1, 29, 674, 1, 29, 675, 1, 29, 676, 1, 29, 677, 1, 29, 678, 1, 29, 679, 1, 29, 680, 1, 29, 681, 1, 29, 682, 1, 29, 683, 1,
30, 719, 1, 30, 731, -7, 30, 720, 1, 30, 721, 1, 30, 722, 1, 30, 723, 1, 30, 724, 1, 30, 725, 1,
31, 731, 1,
32, 149, 1, 32, 150, 1, 32, 151, 1, 32, 152, 1, 32, 153, 1, 32, 154, 1, 32, 559, 1, 32, 155, 1, 32, 156, 1, 32, 157, 1, 32, 560, 1, 32, 158, 1, 32, 561, 1, 32, 562, 1, 32, 563, 1, 32, 159, 1, 32, 160, 1, 32, 161, 1, 32, 564, 1, 32, 162, 1, 32, 565, 1, 32, 566, 1, 32, 567, 1, 32, 163, 1, 32, 568, 1, 32, 569, 1, 32, 570, 1, 32, 571, 1, 32, 572, 1, 32, 573, 1, 32, 726, 1, 32, 26, -1, 32, 27, -1, 32, 28, -1, 32, 353, -1, 32, 29, -1, 32, 354, -1, 32, 355, -1, 32, 356, -1, 32, 30, -1, 32, 357, -1, 32, 358, -1, 32, 359, -1, 32, 360, -1, 32, 361, -1, 32, 362, -1, 32, 684, -1, 32, 31, -1, 32, 363, -1, 32, 364, -1, 32, 365, -1, 32, 366, -1, 32, 367, -1, 32, 368, -1, 32, 685, -1, 32, 369, -1, 32, 370, -1, 32, 371, -1, 32, 686, -1, 32, 372, -1, 32, 687, -1, 32, 688, -1, 32, 689, -1,
33, 26, 1, 33, 353, 3, 33, 354, 3, 33, 355, 3, 33, 357, 3, 33, 358, 3, 33, 360, 3, 33, 684, 5, 33, 363, 3, 33, 364, 3, 33, 366, 3, 33, 685, 5, 33, 369, 3, 33, 686, 5, 33, 687, 5, 33, 688, 5, 33, 149, -2, 33, 150, -2, 33, 152, -2, 33, 559, -4, 33, 155, -2, 33, 560, -4, 33, 561, -4, 33, 562, -4, 33, 159, -2, 33, 564, -4, 33, 565, -4, 33, 566, -4, 33, 568, -4, 33, 569, -4, 33, 571, -4, 33, 726, -6, 33, 27, 1, 33, 356, 3, 33, 359, 3, 33, 361, 3, 33, 365, 3, 33, 367, 3, 33, 370, 3, 33, 689, 5, 33, 151, -2, 33, 153, -2, 33, 156, -2, 33, 563, -4, 33, 160, -2, 33, 567, -4, 33, 570, -4, 33, 572, -4, 33, 28, 1, 33, 362, 3, 33, 368, 3, 33, 371, 3, 33, 154, -2, 33, 157, -2, 33, 161, -2, 33, 573, -4, 33, 29, 1, 33, 372, 3, 33, 158, -2, 33, 162, -2, 33, 30, 1, 33, 163, -2, 33, 31, 1,
34, 149, 1, 34, 559, 6, 34, 560, 6, 34, 561, 6, 34, 564, 6, 34, 565, 6, 34, 568, 6, 34, 726, 15, 34, 353, -3, 34, 354, -3, 34, 357, -3, 34, 684, -10, 34, 363, -3, 34, 685, -10, 34, 686, -10, 34, 687, -10, 34, 150, 1, 34, 562, 6, 34, 566, 6, 34, 569, 6, 34, 355, -3, 34, 358, -3, 34, 364, -3, 34, 688, -10, 34, 151, 1, 34, 563, 6, 34, 567, 6, 34, 570, 6, 34, 356, -3, 34, 359, -3, 34, 365, -3, 34, 689, -10, 34, 152, 1, 34, 571, 6, 34, 360, -3, 34, 366, -3, 34, 153, 1, 34, 572, 6, 34, 361, -3, 34, 367, -3, 34, 154, 1, 34, 573, 6, 34, 362, -3, 34, 368, -3, 34, 155, 1, 34, 369, -3, 34, 156, 1, 34, 370, -3, 34, 157, 1, 34, 371, -3, 34, 158, 1, 34, 372, -3, 34, 159, 1, 34, 160, 1, 34, 161, 1, 34, 162, 1, 34, 163, 1,
35, 353, 1, 35, 684, 10, 35, 685, 10, 35, 686, 10, 35, 559, -4, 35, 560, -4, 35, 564, -4, 35, 726, -20, 35, 354, 1, 35, 687, 10, 35, 561, -4, 35, 565, -4, 35, 355, 1, 35, 688, 10, 35, 562, -4, 35, 566, -4, 35, 356, 1, 35, 689, 10, 35, 563, -4, 35, 567, -4, 35, 357, 1, 35, 568, -4, 35, 358, 1, 35, 569, -4, 35, 359, 1, 35, 570, -4, 35, 360, 1, 35, 571, -4, 35, 361, 1, 35, 572, -4, 35, 362, 1, 35, 573, -4, 35, 363, 1, 35, 364, 1, 35, 365, 1, 35, 366, 1, 35, 367, 1, 35, 368, 1, 35, 369, 1, 35, 370, 1, 35, 371, 1, 35, 372, 1,
36, 559, 1, 36, 726, 15, 36, 684, -5, 36, 685, -5, 36, 560, 1, 36, 686, -5, 36, 561, 1, 36, 687, -5, 36, 562, 1, 36, 688, -5, 36, 563, 1, 36, 689, -5, 36, 564, 1, 36, 565, 1, 36, 566, 1, 36, 567, 1, 36, 568, 1, 36, 569, 1, 36, 570, 1, 36, 571, 1, 36, 572, 1, 36, 573, 1,
37, 684, 1, 37, 726, -6, 37, 685, 1, 37, 686, 1, 37, 687, 1, 37, 688, 1, 37, 689, 1,
38, 726, 1,
39, 164, 1, 39, 165, 1, 39, 166, 1, 39, 167, 1, 39, 168, 1, 39, 169, 1, 39, 574, 1, 39, 170, 1, 39, 171, 1, 39, 172, 1, 39, 575, 1, 39, 173, 1, 39, 576, 1, 39, 577, 1, 39, 578, 1, 39, 32, -1, 39, 33, -1, 39, 34, -1, 39, 373, -1, 39, 35, -1, 39, 374, -1, 39, 375, -1, 39, 376, -1, 39, 36, -1, 39, 377, -1, 39, 378, -1, 39, 379, -1, 39, 380, -1, 39, 381, -1, 39, 382, -1, 39, 690, -1,
40, 174, 1, 40, 175, 1, 40, 176, 1, 40, 177, 1, 40, 178, 1, 40, 179, 1, 40, 579, 1, 40, 180, 1, 40, 181, 1, 40, 182, 1, 40, 580, 1, 40, 183, 1, 40, 581, 1, 40, 582, 1, 40, 583, 1, 40, 37, -1, 40, 38, -1, 40, 39, -1, 40, 383, -1, 40, 40, -1, 40, 384, -1, 40, 385, -1, 40, 386, -1, 40, 41, -1, 40, 387, -1, 40, 388, -1, 40, 389, -1, 40, 390, -1, 40, 391, -1, 40, 392, -1, 40, 691, -1,
41, 184, 1, 41, 185, 1, 41, 186, 1, 41, 187, 1, 41, 188, 1, 41, 189, 1, 41, 584, 1, 41, 190, 1, 41, 191, 1, 41, 192, 1, 41, 585, 1, 41, 193, 1, 41, 586, 1, 41, 587, 1, 41, 588, 1, 41, 42, -1, 41, 43, -1, 41, 44, -1, 41, 393, -1, 41, 45, -1, 41, 394, -1, 41, 395, -1, 41, 396, -1, 41, 46, -1, 41, 397, -1, 41, 398, -1, 41, 399, -1, 41, 400, -1, 41, 401, -1, 41, 402, -1, 41, 692, -1,
42, 32, 1, 42, 373, 3, 42, 374, 3, 42, 375, 3, 42, 377, 3, 42, 378, 3, 42, 380, 3, 42, 690, 5, 42, 164, -2, 42, 165, -2, 42, 167, -2, 42, 574, -4, 42, 170, -2, 42, 575, -4, 42, 576, -4, 42, 577, -4, 42, 33, 1, 42, 376, 3, 42, 379, 3, 42, 381, 3, 42, 166, -2, 42, 168, -2, 42, 171, -2, 42, 578, -4, 42, 34, 1, 42, 382, 3, 42, 169, -2, 42, 172, -2, 42, 35, 1, 42, 173, -2, 42, 36, 1,
43, 37, 1, 43, 383, 3, 43, 384, 3, 43, 385, 3, 43, 387, 3, 43, 388, 3, 43, 390, 3, 43, 691, 5, 43, 174, -2, 43, 175, -2, 43, 177, -2, 43, 579, -4, 43, 180, -2, 43, 580, -4, 43, 581, -4, 43, 582, -4, 43, 38, 1, 43, 386, 3, 43, 389, 3, 43, 391, 3, 43, 176, -2, 43, 178, -2, 43, 181, -2, 43, 583, -4, 43, 39, 1, 43, 392, 3, 43, 179, -2, 43, 182, -2, 43, 40, 1, 43, 183, -2, 43, 41, 1,
44, 42, 1, 44, 393, 3, 44, 394, 3, 44, 395, 3, 44, 397, 3, 44, 398, 3, 44, 400, 3, 44, 692, 5, 44, 184, -2, 44, 185, -2, 44, 187, -2, 44, 584, -4, 44, 190, -2, 44, 585, -4, 44, 586, -4, 44, 587, -4, 44, 43, 1, 44, 396, 3, 44, 399, 3, 44, 401, 3, 44, 186, -2, 44, 188, -2, 44, 191, -2, 44, 588, -4, 44, 44, 1, 44, 402, 3, 44, 189, -2, 44, 192, -2, 44, 45, 1, 44, 193, -2, 44, 46, 1,
45, 164, 1, 45, 574, 6, 45, 575, 6, 45, 576, 6, 45, 373, -3, 45, 374, -3, 45, 377, -3, 45, 690, -10, 45, 165, 1, 45, 577, 6, 45, 375, -3, 45, 378, -3, 45, 166, 1, 45, 578, 6, 45, 376, -3, 45, 379, -3, 45, 167, 1, 45, 380, -3, 45, 168, 1, 45, 381, -3, 45, 169, 1, 45, 382, -3, 45, 170, 1, 45, 171, 1, 45, 172, 1, 45, 173, 1,
46, 174, 1, 46, 579, 6, 46, 580, 6, 46, 581, 6, 46, 383, -3, 46, 384, -3, 46, 387, -3, 46, 691, -10, 46, 175, 1, 46, 582, 6, 46, 385, -3, 46, 388, -3, 46, 176, 1, 46, 583, 6, 46, 386, -3, 46, 389, -3, 46, 177, 1, 46, 390, -3, 46, 178, 1, 46, 391, -3, 46, 179, 1, 46, 392, -3, 46, 180, 1, 46, 181, 1, 46, 182, 1, 46, 183, 1,
47, 184, 1, 47, 584, 6, 47, 585, 6, 47, 586, 6, 47, 393, -3, 47, 394, -3, 47, 397, -3, 47, 692, -10, 47, 185, 1, 47, 587, 6, 47, 395, -3, 47, 398, -3, 47, 186, 1, 47, 588, 6, 47, 396, -3, 47, 399, -3, 47, 187, 1, 47, 400, -3, 47, 188, 1, 47, 401, -3, 47, 189, 1, 47, 402, -3, 47, 190, 1, 47, 191, 1, 47, 192, 1, 47, 193, 1,
48, 373, 1, 48, 690, 10, 48, 574, -4, 48, 575, -4, 48, 374, 1, 48, 576, -4, 48, 375, 1, 48, 577, -4, 48, 376, 1, 48, 578, -4, 48, 377, 1, 48, 378, 1, 48, 379, 1, 48, 380, 1, 48, 381, 1, 48, 382, 1,
49, 383, 1, 49, 691, 10, 49, 579, -4, 49, 580, -4, 49, 384, 1, 49, 581, -4, 49, 385, 1, 49, 582, -4, 49, 386, 1, 49, 583, -4, 49, 387, 1, 49, 388, 1, 49, 389, 1, 49, 390, 1, 49, 391, 1, 49, 392, 1,
50, 393, 1, 50, 692, 10, 50, 584, -4, 50, 585, -4, 50, 394, 1, 50, 586, -4, 50, 395, 1, 50, 587, -4, 50, 396, 1, 50, 588, -4, 50, 397, 1, 50, 398, 1, 50, 399, 1, 50, 400, 1, 50, 401, 1, 50, 402, 1,
51, 574, 1, 51, 690, -5, 51, 575, 1, 51, 576, 1, 51, 577, 1, 51, 578, 1,
52, 579, 1, 52, 691, -5, 52, 580, 1, 52, 581, 1, 52, 582, 1, 52, 583, 1,
53, 584, 1, 53, 692, -5, 53, 585, 1, 53, 586, 1, 53, 587, 1, 53, 588, 1,
54, 690, 1,
55, 691, 1,
56, 692, 1,
57, 194, 1, 57, 195, 1, 57, 196, 1, 57, 197, 1, 57, 198, 1, 57, 199, 1, 57, 589, 1, 57, 200, 1, 57, 201, 1, 57, 202, 1, 57, 590, 1, 57, 203, 1, 57, 591, 1, 57, 592, 1, 57, 593, 1, 57, 204, 1, 57, 205, 1, 57, 206, 1, 57, 594, 1, 57, 207, 1, 57, 595, 1, 57, 596, 1, 57, 597, 1, 57, 208, 1, 57, 598, 1, 57, 599, 1, 57, 600, 1, 57, 601, 1, 57, 602, 1, 57, 603, 1, 57, 727, 1, 57, 47, -1, 57, 48, -1, 57, 49, -1, 57, 403, -1, 57, 50, -1, 57, 404, -1, 57, 405, -1, 57, 406, -1, 57, 51, -1, 57, 407, -1, 57, 408, -1, 57, 409, -1, 57, 410, -1, 57, 411, -1, 57, 412, -1, 57, 693, -1, 57, 52, -1, 57, 413, -1, 57, 414, -1, 57, 415, -1, 57, 416, -1, 57, 417, -1, 57, 418, -1, 57, 694, -1, 57, 419, -1, 57, 420, -1, 57, 421, -1, 57, 695, -1, 57, 422, -1, 57, 696, -1, 57, 697, -1, 57, 698, -1,
58, 47, 1, 58, 403, 3, 58, 404, 3, 58, 405, 3, 58, 407, 3, 58, 408, 3, 58, 410, 3, 58, 693, 5, 58, 413, 3, 58, 414, 3, 58, 416, 3, 58, 694, 5, 58, 419, 3, 58, 695, 5, 58, 696, 5, 58, 697, 5, 58, 194, -2, 58, 195, -2, 58, 197, -2, 58, 589, -4, 58, 200, -2, 58, 590, -4, 58, 591, -4, 58, 592, -4, 58, 204, -2, 58, 594, -4, 58, 595, -4, 58, 596, -4, 58, 598, -4, 58, 599, -4, 58, 601, -4, 58, 727, -6, 58, 48, 1, 58, 406, 3, 58, 409, 3, 58, 411, 3, 58, 415, 3, 58, 417, 3, 58, 420, 3, 58, 698, 5, 58, 196, -2, 58, 198, -2, 58, 201, -2, 58, 593, -4, 58, 205, -2, 58, 597, -4, 58, 600, -4, 58, 602, -4, 58, 49, 1, 58, 412, 3, 58, 418, 3, 58, 421, 3, 58, 199, -2, 58, 202, -2, 58, 206, -2, 58, 603, -4, 58, 50, 1, 58, 422, 3, 58, 203, -2, 58, 207, -2, 58, 51, 1, 58, 208, -2, 58, 52, 1,
59, 194, 1, 59, 589, 6, 59, 590, 6, 59, 591, 6, 59, 594, 6, 59, 595, 6, 59, 598, 6, 59, 727, 15, 59, 403, -3, 59, 404, -3, 59, 407, -3, 59, 693, -10, 59, 413, -3, 59, 694, -10, 59, 695, -10, 59, 696, -10, 59, 195, 1, 59, 592, 6, 59, 596, 6, 59, 599, 6, 59, 405, -3, 59, 408, -3, 59, 414, -3, 59, 697, -10, 59, 196, 1, 59, 593, 6, 59, 597, 6, 59, 600, 6, 59, 406, -3, 59, 409, -3, 59, 415, -3, 59, 698, -10, 59, 197, 1, 59, 601, 6, 59, 410, -3, 59, 416, -3, 59, 198, 1, 59, 602, 6, 59, 411, -3, 59, 417, -3, 59, 199, 1, 59, 603, 6, 59, 412, -3, 59, 418, -3, 59, 200, 1, 59, 419, -3, 59, 201, 1, 59, 420, -3, 59, 202, 1, 59, 421, -3, 59, 203, 1, 59, 422, -3, 59, 204, 1, 59, 205, 1, 59, 206, 1, 59, 207, 1, 59, 208, 1,
60, 403, 1, 60, 693, 10, 60, 694, 10, 60, 695, 10, 60, 589, -4, 60, 590, -4, 60, 594, -4, 60, 727, -20, 60, 404, 1, 60, 696, 10, 60, 591, -4, 60, 595, -4, 60, 405, 1, 60, 697, 10, 60, 592, -4, 60, 596, -4, 60, 406, 1, 60, 698, 10, 60, 593, -4, 60, 597, -4, 60, 407, 1, 60, 598, -4, 60, 408, 1, 60, 599, -4, 60, 409, 1, 60, 600, -4, 60, 410, 1, 60, 601, -4, 60, 411, 1, 60, 602, -4, 60, 412, 1, 60, 603, -4, 60, 413, 1, 60, 414, 1, 60, 415, 1, 60, 416, 1, 60, 417, 1, 60, 418, 1, 60, 419, 1, 60, 420, 1, 60, 421, 1, 60, 422, 1,
61, 589, 1, 61, 727, 15, 61, 693, -5, 61, 694, -5, 61, 590, 1, 61, 695, -5, 61, 591, 1, 61, 696, -5, 61, 592, 1, 61, 697, -5, 61, 593, 1, 61, 698, -5, 61, 594, 1, 61, 595, 1, 61, 596, 1, 61, 597, 1, 61, 598, 1, 61, 599, 1, 61, 600, 1, 61, 601, 1, 61, 602, 1, 61, 603, 1,
62, 693, 1, 62, 727, -6, 62, 694, 1, 62, 695, 1, 62, 696, 1, 62, 697, 1, 62, 698, 1,
63, 727, 1,
64, 209, 1, 64, 210, 1, 64, 211, 1, 64, 212, 1, 64, 213, 1, 64, 214, 1, 64, 604, 1, 64, 215, 1, 64, 216, 1, 64, 217, 1, 64, 605, 1, 64, 218, 1, 64, 606, 1, 64, 607, 1, 64, 608, 1, 64, 219, 1, 64, 220, 1, 64, 221, 1, 64, 609, 1, 64, 222, 1, 64, 610, 1, 64, 611, 1, 64, 612, 1, 64, 223, 1, 64, 613, 1, 64, 614, 1, 64, 615, 1, 64, 616, 1, 64, 617, 1, 64, 618, 1, 64, 728, 1, 64, 53, -1, 64, 54, -1, 64, 55, -1, 64, 423, -1, 64, 56, -1, 64, 424, -1, 64, 425, -1, 64, 426, -1, 64, 57, -1, 64, 427, -1, 64, 428, -1, 64, 429, -1, 64, 430, -1, 64, 431, -1, 64, 432, -1, 64, 699, -1, 64, 58, -1, 64, 433, -1, 64, 434, -1, 64, 435, -1, 64, 436, -1, 64, 437, -1, 64, 438, -1, 64, 700, -1, 64, 439, -1, 64, 440, -1, 64, 441, -1, 64, 701, -1, 64, 442, -1, 64, 702, -1, 64, 703, -1, 64, 704, -1,
65, 53, 1, 65, 423, 3, 65, 424, 3, 65, 425, 3, 65, 427, 3, 65, 428, 3, 65, 430, 3, 65, 699, 5, 65, 433, 3, 65, 434, 3, 65, 436, 3, 65, 700, 5, 65, 439, 3, 65, 701, 5, 65, 702, 5, 65, 703, 5, 65, 209, -2, 65, 210, -2, 65, 212, -2, 65, 604, -4, 65, 215, -2, 65, 605, -4, 65, 606, -4, 65, 607, -4, 65, 219, -2, 65, 609, -4, 65, 610, -4, 65, 611, -4, 65, 613, -4, 65, 614, -4, 65, 616, -4, 65, 728, -6, 65, 54, 1, 65, 426, 3, 65, 429, 3, 65, 431, 3, 65, 435, 3, 65, 437, 3, 65, 440, 3, 65, 704, 5, 65, 211, -2, 65, 213, -2, 65, 216, -2, 65, 608, -4, 65, 220, -2, 65, 612, -4, 65, 615, -4, 65, 617, -4, 65, 55, 1, 65, 432, 3, 65, 438, 3, 65, 441, 3, 65, 214, -2, 65, 217, -2, 65, 221, -2, 65, 618, -4, 65, 56, 1, 65, 442, 3, 65, 218, -2, 65, 222, -2, 65, 57, 1, 65, 223, -2, 65, 58, 1,
66, 209, 1, 66, 604, 6, 66, 605, 6, 66, 606, 6, 66, 609, 6, 66, 610, 6, 66, 613, 6, 66, 728, 15, 66, 423, -3, 66, 424, -3, 66, 427, -3, 66, 699, -10, 66, 433, -3, 66, 700, -10, 66, 701, -10, 66, 702, -10, 66, 210, 1, 66, 607, 6, 66, 611, 6, 66, 614, 6, 66, 425, -3, 66, 428, -3, 66, 434, -3, 66, 703, -10, 66, 211, 1, 66, 608, 6, 66, 612, 6, 66, 615, 6, 66, 426, -3, 66, 429, -3, 66, 435, -3, 66, 704, -10, 66, 212, 1, 66, 616, 6, 66, 430, -3, 66, 436, -3, 66, 213, 1, 66, 617, 6, 66, 431, -3, 66, 437, -3, 66, 214, 1, 66, 618, 6, 66, 432, -3, 66, 438, -3, 66, 215, 1, 66, 439, -3, 66, 216, 1, 66, 440, -3, 66, 217, 1, 66, 441, -3, 66, 218, 1, 66, 442, -3, 66, 219, 1, 66, 220, 1, 66, 221, 1, 66, 222, 1, 66, 223, 1,
67, 423, 1, 67, 699, 10, 67, 700, 10, 67, 701, 10, 67, 604, -4, 67, 605, -4, 67, 609, -4, 67, 728, -20, 67, 424, 1, 67, 702, 10, 67, 606, -4, 67, 610, -4, 67, 425, 1, 67, 703, 10, 67, 607, -4, 67, 611, -4, 67, 426, 1, 67, 704, 10, 67, 608, -4, 67, 612, -4, 67, 427, 1, 67, 613, -4, 67, 428, 1, 67, 614, -4, 67, 429, 1, 67, 615, -4, 67, 430, 1, 67, 616, -4, 67, 431, 1, 67, 617, -4, 67, 432, 1, 67, 618, -4, 67, 433, 1, 67, 434, 1, 67, 435, 1, 67, 436, 1, 67, 437, 1, 67, 438, 1, 67, 439, 1, 67, 440, 1, 67, 441, 1, 67, 442, 1,
68, 604, 1, 68, 728, 15, 68, 699, -5, 68, 700, -5, 68, 605, 1, 68, 701, -5, 68, 606, 1, 68, 702, -5, 68, 607, 1, 68, 703, -5, 68, 608, 1, 68, 704, -5, 68, 609, 1, 68, 610, 1, 68, 611, 1, 68, 612, 1, 68, 613, 1, 68, 614, 1, 68, 615, 1, 68, 616, 1, 68, 617, 1, 68, 618, 1,
69, 699, 1, 69, 728, -6, 69, 700, 1, 69, 701, 1, 69, 702, 1, 69, 703, 1, 69, 704, 1,
70, 728, 1,
71, 59, 1, 71, 443, 3, 71, 444, 3, 71, 445, 3, 71, 446, 3, 71, 447, 3, 71, 448, 3, 71, 705, 5, 71, 449, 3, 71, 450, 3, 71, 451, 3, 71, 706, 5, 71, 452, 3, 71, 707, 5, 71, 708, 5, 71, 709, 5, 71, 224, -2, 71, 225, -2, 71, 226, -2, 71, 619, -4, 71, 227, -2, 71, 620, -4, 71, 621, -4, 71, 622, -4, 71, 228, -2, 71, 623, -4, 71, 624, -4, 71, 625, -4, 71, 626, -4, 71, 627, -4, 71, 628, -4, 71, 729, -6, 71, 60, 1, 71, 453, 3, 71, 454, 3, 71, 455, 3, 71, 456, 3, 71, 457, 3, 71, 458, 3, 71, 710, 5, 71, 229, -2, 71, 230, -2, 71, 231, -2, 71, 629, -4, 71, 232, -2, 71, 630, -4, 71, 631, -4, 71, 632, -4, 71, 61, 1, 71, 459, 3, 71, 460, 3, 71, 461, 3, 71, 233, -2, 71, 234, -2, 71, 235, -2, 71, 633, -4, 71, 62, 1, 71, 462, 3, 71, 236, -2, 71, 237, -2, 71, 63, 1, 71, 238, -2, 71, 64, 1,
72, 224, 1, 72, 619, 6, 72, 620, 6, 72, 621, 6, 72, 623, 6, 72, 624, 6, 72, 626, 6, 72, 729, 15, 72, 443, -3, 72, 444, -3, 72, 446, -3, 72, 705, -10, 72, 449, -3, 72, 706, -10, 72, 707, -10, 72, 708, -10, 72, 225, 1, 72, 622, 6, 72, 625, 6, 72, 627, 6, 72, 445, -3, 72, 447, -3, 72, 450, -3, 72, 709, -10, 72, 229, 1, 72, 629, 6, 72, 630, 6, 72, 631, 6, 72, 453, -3, 72, 454, -3, 72, 456, -3, 72, 710, -10, 72, 226, 1, 72, 628, 6, 72, 448, -3, 72, 451, -3, 72, 230, 1, 72, 632, 6, 72, 455, -3, 72, 457, -3, 72, 233, 1, 72, 633, 6, 72, 459, -3, 72, 460, -3, 72, 227, 1, 72, 452, -3, 72, 231, 1, 72, 458, -3, 72, 234, 1, 72, 461, -3, 72, 236, 1, 72, 462, -3, 72, 228, 1, 72, 232, 1, 72, 235, 1, 72, 237, 1, 72, 238, 1,
73, 443, 1, 73, 705, 10, 73, 706, 10, 73, 707, 10, 73, 619, -4, 73, 620, -4, 73, 623, -4, 73, 729, -20, 73, 444, 1, 73, 708, 10, 73, 621, -4, 73, 624, -4, 73, 445, 1, 73, 709, 10, 73, 622, -4, 73, 625, -4, 73, 453, 1, 73, 710, 10, 73, 629, -4, 73, 630, -4, 73, 446, 1, 73, 626, -4, 73, 447, 1, 73, 627, -4, 73, 454, 1, 73, 631, -4, 73, 448, 1, 73, 628, -4, 73, 455, 1, 73, 632, -4, 73, 459, 1, 73, 633, -4, 73, 449, 1, 73, 450, 1, 73, 456, 1, 73, 451, 1, 73, 457, 1, 73, 460, 1, 73, 452, 1, 73, 458, 1, 73, 461, 1, 73, 462, 1,
74, 619, 1, 74, 729, 15, 74, 705, -5, 74, 706, -5, 74, 620, 1, 74, 707, -5, 74, 621, 1, 74, 708, -5, 74, 622, 1, 74, 709, -5, 74, 629, 1, 74, 710, -5, 74, 623, 1, 74, 624, 1, 74, 625, 1, 74, 630, 1, 74, 626, 1, 74, 627, 1, 74, 631, 1, 74, 628, 1, 74, 632, 1, 74, 633, 1,
75, 705, 1, 75, 729, -6, 75, 706, 1, 75, 707, 1, 75, 708, 1, 75, 709, 1, 75, 710, 1,
76, 729, 1,

NULL), ncol=3, byrow=TRUE); # close ind_mema creation
measmat[[1]][ind_mema[,1:2,drop=FALSE]]=ind_mema[,3]
memaone[[1]]=c(1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 1, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0)

pwe=ipwe=ip2ipwe=pool_factor=ijpwef=dp_ones=meas2sum=dpw_dpf=ipf_in_ppw=vector("list", nb_exp)
mets_in_res=vector("list", nb_exp)
for (iexp in seq_len(nb_exp)) {
   names(memaone[[iexp]])=nm_measmat[[iexp]]

   # prepare weights of label data for pooled metabs
   # prepare ipwe and ip2ipwe such that pwe[ipwe]=pool[ip2ipwe]
   # gives a good base for weight sum and normalization
   pwe[[iexp]]=double(nb_measmat[[iexp]])+1.
   mets_in_res[[iexp]]=sapply(nm_measmat[[iexp]], function(m) strsplit(m, ":")[[1L]][2L])
   for (po in names(ipooled[[iexp]])) {
      if (po == "ishort") next
      nm_sum=strsplit(po, ":")[[1L]][2L]
      mets=strsplit(nm_sum, "\\+")[[1L]]
      irpo=ipooled[[iexp]][[po]]
      ipwe[[iexp]]=c(ipwe[[iexp]], irpo) # where weighting is
      i=pmatch(mets, names(nm_poolf))
      if (any(!is.na(i))) {
         for (ir in i) {
            if (is.na(ir)) next
            ijpwef[[iexp]]=rbind(ijpwef[[iexp]], cbind(irpo, ir)) # where free pools matter
         }
      }
      ip2ipwe[[iexp]]=c(ip2ipwe[[iexp]], pmatch(mets, names(nm_poolall)))
      mets_in_res[[iexp]][irpo]=mets
   }
   # order ijpwef for sparse matrix ordering
   if (!is.null(ijpwef[[iexp]])) {
      o=order(ijpwef[[iexp]][,2L], ijpwef[[iexp]][,1L])
      ijpwef[[iexp]]=ijpwef[[iexp]][o,,drop=FALSE]
   }
   pool_factor[[iexp]]=as.factor(nm_measmat[[iexp]])
   # free pool in principal pool weight
   ipf_in_ppw[[iexp]]=apply(outer(mets_in_res[[iexp]], names(nm_poolf), "=="), 1, function(v) if(length(w <-which(v))) w else NA)
   ipf_in_ppw[[iexp]][is.na(ipf_in_ppw[[iexp]])]=0L
   dp_ones[[iexp]]=matrix(0., nb_measmat[[iexp]], nb_poolf)
   dp_ones[[iexp]][cbind(ipwe[[iexp]], ipf_in_ppw[[iexp]][ipwe[[iexp]]])]=1.
   
   # matrix for summing weighted measurements
   meas2sum[[iexp]]=simple_triplet_zero_matrix(length(ipooled[[iexp]]$ishort), nb_measmat[[iexp]])
   meas2sum[[iexp]][cbind(pmatch(nm_measmat[[iexp]], nm_measmat[[iexp]][ipooled[[iexp]]$ishort], dup=TRUE),       seq_len(nb_measmat[[iexp]]))]=1.
   dimnames(meas2sum[[iexp]])=list(nm_meas[[iexp]], nm_measmat[[iexp]])
   
   # dpw_dpf - matrix for derivation of pool weights by free pools
   if (nb_poolf > 0L && length(ijpwef[[iexp]]) > 0) {
      # indeed, we'll have to do weight derivation by free pools
      dpw_dpf[[iexp]]=simple_triplet_zero_matrix(nb_measmat[[iexp]], nb_poolf)
      dpw_dpf[[iexp]][ijpwef[[iexp]]]=1.
   }
}


# prepare flux measurements
nm_fmn=nm_net[c("out_Ac")]
nm_list$fmn=nm_fmn
nb_fmn=length(nm_fmn)
nb_f$nb_fmn=nb_fmn

# measured values
fmn=c(0.497)

# SD for flux measurements
fmndev=c(0.04)
if (nb_fmn)
   names(fmndev)=names(fmn)=nm_fmn

# indices for measured fluxes
# fallnx[ifmn]=>fmn, here fallnx is complete net|xch flux vector
# combining unknown (dependent), free, constrainded and groth fluxes
ifmn=match(nm_fmn, nm_fallnx)

if (TIMEIT) {
   cat("ineq    : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
# prepare mi matrix and li vector
# such that mi*fallnx>=li corresponds
# to the inequalities given in ftbl file
nb_ineq=6
mi=matrix(0., nrow=nb_ineq, ncol=nb_fallnx)
li=numeric(nb_ineq)
nm_i=c(c("n:0<=edd", "n:0<=gnd", "n:0<=zwf", "n:0<=ppc", "n:0<=idh", "n:0<=akgdh"), c())
dimnames(mi)=list(nm_i, nm_fallnx)
mi[1, nm_net[c("edd")]]=c(1.0)
li[1]=0
mi[2, nm_net[c("gnd")]]=c(1.0)
li[2]=0
mi[3, nm_net[c("zwf")]]=c(1.0)
li[3]=0
mi[4, nm_net[c("ppc")]]=c(1.0)
li[4]=0
mi[5, nm_net[c("idh")]]=c(1.0)
li[5]=0
mi[6, nm_net[c("akgdh")]]=c(1.0)
li[6]=0

# add standard limits on [df].xch [0;cupx]
nb_tmp=nrow(mi)
nb_fx=nb_flx+nb_ffx
if (nb_fx) {
   mi=rbind(mi, matrix(0, nrow=2*nb_fx, ncol=nb_fallnx))
   if (nb_flx)
      nm_i=c(nm_i, paste(nm_flx, ">=0", sep=""))
   if (nb_ffx)
      nm_i=c(nm_i, paste(nm_ffx, ">=0", sep=""))
   if (nb_flx)
      nm_i=c(nm_i, paste(nm_flx, "<=", cupx, sep=""))
   if (nb_ffx)
      nm_i=c(nm_i, paste(nm_ffx, "<=", cupx, sep=""))
   li=c(li, rep(0, nb_fx), rep(-cupx, nb_fx))
   mi[nb_tmp+(1:nb_fx),c(nm_flx, nm_ffx)]=diag(1., nb_fx)
   mi[nb_tmp+nb_fx+(1:nb_fx),c(nm_flx, nm_ffx)]=diag(-1., nb_fx)
}

nm_inout=grep("^[^c]\\.", nm_net[c("bs_glc6P", "bs_fru6P", "bs_pga", "bs_DHAP", "bs_pyr", "bs_e4p", "bs_rib5P", "bs_pep", "bs_accoa", "bs_akg", "bs_oaa", "out_co2", "out_Ac", "Suc_gr", "Mal_gr", "PEP_gr", "PGA_gr", "Cit_gr", "Gnt6P_gr", "FruBP_gr", "Fru6P_gr", "Glc6P_gr", "Rub5P_gr", "Rib5P_gr", "Xul5P_gr", "Glucupt_1", "Glucupt_U", "CO2upt")], v=TRUE) # strip out constrained fluxes
nb_inout=length(nm_inout)
if (nb_inout > 0) {
   # add cinout low limits on inout net fluxes
   nb_tmp=nrow(mi)
   # explicit inequalities take precedence over generic ones
   # so eliminate inout fluxes which are already in inequalities
   nm_itmp=paste("n:.+<=", substring(nm_inout, 5), sep="")
   i=sapply(1:length(nm_itmp), function(k) {
      j=grep(nm_itmp[k], nm_i)
      #cat(nm_itmp[k], "->", nm_i[j], "\n", file=fclog)
      if (length(j)==0) {
         return(0)
      } else {
         return(k)
      }
   })
   i=i[i!=0]
   if (length(i) > 0) {
      nm_tmp=nm_inout[-i]
   } else {
      nm_tmp=nm_inout
   }
   len_tmp=length(nm_tmp)
   if (len_tmp > 0) {
      mi=rbind(mi, matrix(0, nrow=len_tmp, ncol=nb_fallnx))
      nm_i=c(nm_i, paste("inout ", nm_tmp, ">=", cinout, sep=""))
      mi[nb_tmp+(1:len_tmp), nm_tmp]=diag(1., len_tmp)
      li=c(li, rep(cinout, len_tmp))
   }
}
if (clownr!=0.) {
   # add low limits on net >= clownr for not reversible reactions
   nb_tmp=nrow(mi)
   nm_tmp=nm_net[c("Glucupt_1", "Glucupt_U", "bs_glc6P", "bs_fru6P", "bs_pga", "bs_DHAP", "bs_pyr", "bs_e4p", "bs_rib5P", "bs_pep", "bs_accoa", "bs_akg", "bs_oaa", "out_co2", "out_Ac", "Suc_gr", "Mal_gr", "PEP_gr", "PGA_gr", "Cit_gr", "Gnt6P_gr", "FruBP_gr", "Fru6P_gr", "Glc6P_gr", "Rub5P_gr", "Rib5P_gr", "Xul5P_gr", "CO2upt", "Glucupt", "zwf", "gnd", "edd", "citsynth", "idh", "akgdh")]
   # explicit inequalities take precedence over generic ones
   # so eliminate notrev fluxes which are already in inequalities
   nm_itmp=paste("n:.+<=", substring(nm_tmp, 5), sep="")
   i=sapply(1:length(nm_itmp), function(k) {
      j=grep(nm_itmp[k], nm_i)
      #cat(nm_itmp[k], "->", nm_i[j], "\n", file=fclog)
      if (length(j)==0) {
         return(0)
      } else {
         return(k)
      }
   })
   i=i[i!=0]
   if (length(i) > 0) {
      nm_tmp=nm_tmp[-i]
   }
   # search for inout too
   nm_itmp=paste("inout ", nm_tmp, ">=", sep="")
   i=sapply(1:length(nm_itmp), function(k) {
      j=grep(nm_itmp[k], nm_i, fix=TRUE)
      #cat(nm_itmp[k], "->", nm_i[j], "\n", file=fclog)
      if (length(j)==0) {
         return(0)
      } else {
         return(k)
      }
   })
   i=i[i!=0]
   if (length(i) > 0) {
      nm_tmp=nm_tmp[-i]
   }

   len_tmp=length(nm_tmp)
   if (len_tmp > 0) {
      mi=rbind(mi, matrix(0, nrow=len_tmp, ncol=nb_fallnx))
      nm_i=c(nm_i, paste(nm_tmp, ">=", clownr, sep=""))
      mi[nb_tmp+(1:len_tmp), nm_tmp]=diag(1., len_tmp)
      li=c(li, rep(clownr, len_tmp))
   }
}
nb_fn=nb_fln+nb_ffn
if (cupn != 0 && nb_fn > 0) {
   # add absolute upper limits on -cupn <= [df].net <= cupn for net fluxes
   # explicit inequalities take precedence over generic ones
   # so eliminate net fluxes which are already in inequalities
   ## proceed n:smth>=flux
   nm_tmp=c(nm_ffn, nm_fln) # all not fixed net fluxes
   nm_itmp=paste("n:.+>=", substring(nm_tmp, 5), sep="")
   i=sapply(vgrep(nm_itmp, nm_i), length)
   i=which(i!=0)
   if (length(i) > 0) {
      nm_tmp=nm_tmp[-i]
   }
   len_tmp=length(nm_tmp)
   if (len_tmp > 0) {
      nb_tmp=nrow(mi)
      mi=rbind(mi, matrix(0, nrow=len_tmp, ncol=nb_fallnx))
      nm_i=c(nm_i, paste0(nm_tmp, "<=", cupn))
      li=c(li, rep(-cupn, len_tmp))
      mi[nb_tmp+(1:len_tmp),nm_tmp]=diag(-1., len_tmp)
   }
   ## proceed n:smth<=flux
   nm_tmp=c(nm_ffn, nm_fln) # all not fixed net fluxes
   nm_itmp=paste("n:.+<=", substring(nm_tmp, 5), sep="")
   i=sapply(vgrep(nm_itmp, nm_i), length)
   i=which(i!=0)
   if (length(i) > 0) {
      nm_tmp=nm_tmp[-i]
   }
   len_tmp=length(nm_tmp)
   if (len_tmp > 0) {
      nb_tmp=nrow(mi)
      mi=rbind(mi, matrix(0, nrow=len_tmp, ncol=nb_fallnx))
      nm_i=c(nm_i, paste0(nm_tmp, ">=", -cupn))
      li=c(li, rep(-cupn, len_tmp))
      mi[nb_tmp+(1:len_tmp),nm_tmp]=diag(1., len_tmp)
   }
}
#browser()
nb_ineq=NROW(li);

dimnames(mi)=list(nm_i, nm_fallnx)
names(li)=nm_i
# prepare ui matrix and ci vector for optimisation
# ui%*%param-ci>=0
# it is composed of explicite inequalities from ftbl
# and permanent inequalities 0<=xch<=0.999 and scale>=0

# constraints such that ui%*%param-ci>=0
# first flux part
ui=mi%*%(md%*%invAfl%stm%p2bfl+mf)
mic=(md%*%invAfl%*%(c2bfl%stm%fc+cnst2bfl) + mc%*%fc)
ci=as.numeric(li-mi%*%mic)

# finaly, metab part
uip=matrix(0., 0, ncol=nb_poolf)
colnames(uip)=nm_poolf
cip=c()
# ind: irow, metab, coef, rhs, name
uip_ind=c(

)
if (length(uip_ind) > 0) {
   uip_ind=matrix(uip_ind, byrow=TRUE, ncol=5L)
} else {
   uip_ind=matrix(0, 0L, 5L)
}
colnames(uip_ind)=c("irow", "metab", "coef", "rhs", "name")


if (nrow(uip_ind) > 0) {
   # rhs are summed up for the same irow by aggregate()
   irow=as.integer(uip_ind[,"irow"])
   cip=aggregate(as.double(uip_ind[,"rhs"]), by=list(irow), sum)[,"x"]
   for (i in seq_len(nrow(uip_ind))) {
      row=uip_ind[i,]
      if (nchar(row["metab"])==0) {
         next
      }
      uip[irow[i], nm_poolf[row["metab"]]]=as.double(row["coef"])
   }
   if (nrow(uip) > 0) {
      rownames(uip)=paste("m:", uip_ind[pmatch(seq_len(nrow(uip)), irow),"name"], sep="")
   }
}
names(cip)=rownames(uip)

#browser() # before null inequality removing
# remove all zero rows in ui (constrained fluxes with fixed values)
# find zero indexes
#print(dim(ui))
if (ncol(ui)) {
   zi=apply(ui,1,function(v){return(max(abs(v))<=1.e-14)})
} else {
   # remove all flux inequalities as there is no free fluxe
   zi=rep(TRUE, nrow(ui))
}

if (!all(ci[zi]<=1.e-10)) {
   cat("The following constant inequalities are not satisfied:\n", file=fcerr)
   cat(nm_i[zi][ci[zi]>1.e-10], sep="\n", file=fcerr)
   cat("They are simply ignored.\n", file=fcerr)
   #stop_mes("", file=fcerr)
}
ui=ui[!zi,,drop=FALSE]
ci=ci[!zi]
nm_i=nm_i[!zi]

# complete ui by zero columns corresponding to scale params
if (nb_sc_tot) {
   ui=cBind(as.matrix(ui), matrix(0., NROW(ui), nb_sc_tot))
   # complete ui by scales >=0
   ui=rBind(ui, cBind(matrix(0, nb_sc_tot, nb_ff), diag(1, nb_sc_tot)))
   ci=c(ci,rep(0., nb_sc_tot))
   nm_i=c(nm_i, paste(nm_par[nb_ff+seq_len(nb_sc_tot)], ">=0", sep=""))
   rownames(ui)=nm_i
   names(ci)=nm_i
}

# remove redundant inequalities
#browser()
nb_i=nrow(ui)
ired=c()
if (nb_i > 1L) {
   for (i in 1L:(nb_i-1L)) {
      nmref=nm_i[i]
      for (j in setdiff((i+1L):nb_i, ired)) {
         if (all(ui[j,]==ui[i,]) && ci[i]==ci[j]) {
            # redundancy
            cat("inequality '", nm_i[j], "' redundant with '", nmref, "' is removed.
", sep="", file=fclog)
            ired=c(ired, j)
         }
      }
   }
}
if (!is.null(ired)) {
   # remove all ired inequalities
   ui=ui[-ired,,drop=FALSE]
   ci=ci[-ired]
   nm_i=nm_i[-ired]
}

# metabolite equalities
ep=matrix(0., 0, ncol=nb_poolf)
cp=c()
colnames(ep)=nm_poolf
# ind: irow, metab, coef, rhs, name
ep_ind=c(

)
if (length(ep_ind) > 0) {
   ep_ind=matrix(ep_ind, byrow=TRUE, ncol=5L)
} else {
   ep_ind=matrix(0, 0L, 5L)
}
colnames(ep_ind)=c("irow", "metab", "coef", "rhs", "name")


if (nrow(ep_ind) > 0) {
   # rhs are summed up for the same irow by aggregate
   irow=as.integer(ep_ind[,"irow"])
   cp=aggregate(as.double(ep_ind[,"rhs"]), by=list(irow))[,"x"]
   for (i in seq_len(nrow(ep_ind))) {
      row=ep_ind[i,]
      if (nchar(row["metab"])==0) {
         next
      }
      ep[irow[i], nm_poolf[row["metab"]]]=as.double(row["coef"])
   }
   if (nrow(ep) > 0) {
      rownames(ep)=paste("m:", ep_ind[pmatch(seq_len(nrow(ep)), irow),"name"], sep="")
   }
}
ep=as.matrix(ep)
names(cp)=rownames(ep)

nb_sys=list(
   reactions=list(
      reversible=18,
      non_reversible=35
   ),
   fluxes=list(
      free=15,
      dependent=26,
      constrained=43
   ),
   metabolites=list(
      input=3,
      output=25,
      intra=11
   ),
   measurements=list(
      flux=1,
      mass=60,
      peak=0,
      label=4,
      metab=10
   ),
   equations=list(
      equalities=3,
      inequalities=6
   ),
   label_variables=list(
      full=c(0,0,0,0,0,0,0),
      reduced_cumomers=c(99,192,216,149,61,13,1)
   ),
   parallel_experiments=1
)
if (sum(nb_sys$label_variables$full)==0) {
   nb_sys$label_variables$full=NULL
}
if (emu) {
   x=nb_sys$label_variables$reduced_cumomers
   nb_sys$label_variables$reduced_cumomers=NULL
   nb_sys$label_variables$emu=paste(x, "*", seq_len(length(x)), "=", x*seq_len(length(x)))
}

#browser()

# extend param vector by free pools
if (nb_poolf > 0) {
   param=c(param, poolf)
   nm_par=c(nm_par, nm_poolf)
   nb_param=length(param)
}
nm_list$par=nm_par

#browser()
if (nb_poolf > 0) {
   # extend inequalities ui, ci by uip, cip
   nb_row=nrow(ui)
   nb_col=ncol(ui)
   ui=cbind(ui, matrix (0., nrow=nb_row, ncol=nb_poolf)) # add 0-columns
   ui=rbind(ui, cbind(matrix(0., nrow(uip), ncol=nb_col), uip))
   ci=c(ci, cip)
   
   # extend inequalities ui, ci by cupp>= poolf >= clowp
   # but exclude metabolites that are individually set in the uip (FTBL)
   met_low=met_up=c()
   if (nrow(uip) > 0) {
      # number of non zero entries per row in uip
      i_nz=rowSums(abs(uip) != 0.)
      # number of positive coeffs for alone metabs (i.e. low limit is set)
      i_pos=colSums(uip[i_nz > 0,,drop=FALSE] > 0)
      met_low=nm_poolf[i_pos > 0]
      # number of negative coeffs for alone metabs (i.e. upper limit is set)
      i_neg=colSums(uip[i_nz > 0,,drop=FALSE] < 0)
      met_up=nm_poolf[i_neg > 0]
   }

   # add low limit
   nb_add=nb_poolf-length(met_low)
   if (nb_add > 0) {
      nm_add=nm_poolf[!nm_poolf %in% met_low]
      ui_add=matrix(0., nrow=nb_add, ncol=ncol(ui))
      ui_add[,nb_col+pmatch(nm_add, nm_poolf)]=diag(1., nb_add)
      rownames(ui_add)=paste(nm_add, ">=", clowp, sep="")
      if (nrow(ui)) {
         ui=rbind(ui, ui_add)
      } else {
         ui=ui_add
      }
      ci=c(ci, rep(clowp, nb_add))
   }

   # add upper limit
   nb_add=nb_poolf-length(met_up)
   if (nb_add > 0) {
      nm_add=nm_poolf[!nm_poolf %in% met_up]
      ui_add=matrix(0., nrow=nb_add, ncol=ncol(ui))
      ui_add[,nb_col+pmatch(nm_add, nm_poolf)]=diag(-1., nb_add)
      rownames(ui_add)=paste(nm_add, "<=", cupp, sep="")
      ui=rbind(ui, ui_add)
      ci=c(ci, rep(-cupp, nb_add))
   }

   nm_i=names(ci)=rownames(ui)
   colnames(ui)=nm_par
}
# extend the matrix of metabolite equalities
ep=cbind(matrix(0., nrow(ep), nb_param-nb_poolf), ep)
colnames(ep)=nm_par

# prepare metabolite pools measurements
nb_poolm=10
nb_f$nb_poolm=nb_poolm
nm_poolm=c("pm:Suc", "pm:Mal", "pm:PEP", "pm:PGA", "pm:Cit", "pm:Gnt6P", "pm:FruBP", "pm:Fru6P", "pm:Glc6P", "pm:Rub5P+Rib5P+Xul5P")
nm_list$poolm=nm_poolm

# measured values
vecpoolm=c(0.0014849826568155515, 0.0006054470296805187, 5.501298486110693e-05, 0.0005008619523631337, 0.001630397300073748, 0.00014480899018442714, 0.0004927839907571225, 0.00010006707551232429, 0.0004905098655004916, 0.00015517247228805515)
names(vecpoolm)=nm_poolm

# inverse of variance for pool measurements
poolmdev=c(0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01, 0.01)
names(poolmdev)=nm_poolm

# simulated metabolite measurements are calculated as
# measmatpool*poolall=>poolm
measmatpool=matrix(0., nrow=nb_poolm, ncol=length(poolall))
dimnames(measmatpool)=list(nm_poolm, nm_poolall)
i=matrix(1+c(0, 9, 1, 5, 2, 6, 3, 7, 4, 0, 5, 4, 6, 2, 7, 1, 8, 3, 9, 8, 9, 11, 9, 10), ncol=2, byrow=T)
measmatpool[i]=1.


# gather all measurement information
measurements=list(
   vec=list(labeled=measvec, flux=fmn, pool=vecpoolm, kin=if (case_i) measvecti else NULL),
   dev=list(labeled=measdev, flux=fmndev, pool=poolmdev, kin=if (case_i) rep(measdev, nb_ti-1) else NULL),
   mat=list(labeled=measmat, flux=ifmn, pool=measmatpool),
   one=list(labeled=memaone)
)
nm_resid=c(if (case_i) unlist(lapply(seq_len(nb_exp), function(iexp) paste(iexp, outer(nm_meas[[iexp]], ti[[iexp]][-1L], paste, sep=", t="), sep=":"))) else unlist(lapply(seq_len(nb_exp), function(iexp) paste(iexp, nm_meas[[iexp]], sep=":"))), nm_fmn, nm_poolm)
nm_list$resid=nm_resid

if (TIMEIT) {
   cat("preopt  : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
#browser()
names(param)=nm_par
# prepare series of starting points
if (nchar(fseries) > 0) {
   pstart=as.matrix(read.table(fseries, header=T, row.n=1, sep="\t"))
   # skip parameters (rows) who's name is not in nm_par
   i=rownames(pstart) %in% nm_par
   if (!any(i)) {
      stop_mes("Option --fseries is used but no free parameter with known name is found.\n")
   }
   pstart=pstart[i,,drop=FALSE]
   cat("Using starting values form '", fseries, "' for the following free parameters:\n", paste(rownames(pstart), collapse="\n"), "\n", sep="", file=fclog)
   nseries=ncol(pstart)
   if (initrand) {
      # fill the rest of rows with random values
      i=nm_par %in% rownames(pstart)
      n=sum(!i)
      pstart=rbind(pstart, matrix(runif(n*nseries), n, nseries))
      rownames(pstart)=c(rownames(pstart)[seq_len(nb_param-n)], nm_par[!i])
   }
   if (nchar(iseries) > 0) {
      iseries=unique(as.integer(eval(parse(t="c("%s+%iseries%s+%")"))))
      iseries=iseries[iseries<=nseries]
      # subsample
      pstart=pstart[,iseries, drop=FALSE]
      nseries=ncol(pstart)
   } else {
      iseries=seq_len(nseries)
   }
} else if (nchar(iseries) > 0) {
   # first construct pstart then if needed fill it with random values
   # and only then subsample
   iseries=unique(as.integer(eval(parse(t="c("%s+%iseries%s+%")"))))
   nseries=max(iseries)
   pstart=matrix(rep(param, nseries), nrow=nb_param, ncol=nseries)
   dimnames(pstart)=list(nm_par, paste("V", seq_len(nseries), sep=""))
   if (initrand) {
      # fill pstart with random values
      pstart[]=runif(length(pstart))
   }
   # subsample
   pstart=pstart[,iseries, drop=FALSE]
   nseries=ncol(pstart)
} else {
   iseries=1L
   pstart=as.matrix(param)
   nseries=1L
   if (initrand) {
      # fill pstart with random values
      pstart[]=runif(length(pstart))
   }
}
nm_pseries=rownames(pstart)

if (is.null(nseries) || nseries==0) {
   stop_mes(sprintf("No starting values in the series file '%s' or --iseries is empty.", fseries),  file=fcerr)
}

pres=matrix(NA, nb_param, nseries)
rownames(pres)=nm_par
colnames(pres)=colnames(pstart)
costres=rep.int(NA, nseries)

# prepare flux index conversion
ifwrv=1:nb_fwrv
names(ifwrv)=nm_fwrv
ifl_in_fw=if (nb_fln) ifwrv[paste("fwd", substring(c(nm_fln, nm_flx), 4), sep="")] else integer(0)
iff_in_fw=if (nb_ff > 0) ifwrv[paste("fwd", substring(c(nm_ffn, nm_ffx), 4), sep="")] else integer(0)
ifg_in_fw=if (nb_fgr > 0) ifwrv[paste("fwd", substring(nm_fgr, 4), sep="")] else integer(0)

# index couples for jacobian df_dfl, df_dffd
cfw_fl=crv_fl=cbind(ifl_in_fw, seq_len(nb_fl))
cfw_ff=crv_ff=cbind(iff_in_fw, seq_len(nb_ff))
cfw_fg=crv_fg=cbind(ifg_in_fw, nb_ff+seq_len(nb_fgr))
crv_fl[,1L]=(nb_fwrv/2)+crv_fl[,1L]
crv_ff[,1L]=(nb_fwrv/2)+crv_ff[,1L]
crv_fg[,1L]=(nb_fwrv/2)+crv_fg[,1L]

# store it in nb_f
nb_f=append(nb_f, list(cfw_fl=cfw_fl, crv_fl=crv_fl, cfw_ff=cfw_ff,
   crv_ff=crv_ff, cfw_fg=cfw_fg, crv_fg=crv_fg))
nb_f=as.environment(nb_f)

nbc_x=c(0, cumsum(nb_x))
nb_f$nbc_x=nbc_x

# fixed part of jacobian (unreduced by SD)
# measured fluxes
dufm_dp=cbind(dufm_dff(nb_f, nm_list), matrix(0, nrow=nb_fmn, ncol=nb_sc_tot+nb_poolf))
dimnames(dufm_dp)=list(nm_fmn, nm_par)

# measured pools
dupm_dp=matrix(0., nb_poolm, nb_ff+nb_sc_tot)
if (nb_poolf > 0L) {
   dupm_dp=cbind(dupm_dp, measurements$mat$pool[,nm_list$poolf, drop=FALSE])
}
dimnames(dupm_dp)=list(rownames(measurements$mat$pool), nm_par)

#browser()
# prepare argument list for passing to label simulating functions
nm_labargs=c("jx_f", "nb_f", "nm_list", "nb_x", "invAfl", "p2bfl", "g2bfl", "bp", "fc", "xi", "spa", "emu", "pool", "measurements", "ipooled", "ir2isc",  "nb_w", "nbc_x", "measmat", "memaone", "dufm_dp", "dupm_dp", "pwe", "ipwe", "ip2ipwe", "pool_factor", "ijpwef", "ipf_in_ppw", "meas2sum", "dp_ones", "clen", "dirr", "dirw", "baseshort", "case_i", "nb_exp", "noscale", "dpw_dpf")

if (TIMEIT) {
   cat("labargs : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
labargs=new.env()
tmp=lapply(nm_labargs, function(nm) assign(nm, get(nm), labargs))
#for (nm in nm_labargs) {
#   labargs[[nm]]=get(nm)
#}
labargs[["nm"]]=labargs[["nm_list"]]

# prepare labargs2 if time_order includes 2
if (case_i && (time_order == "2" || time_order == "1,2")) {
   labargs2=as.environment(as.list(labargs))
   labargs2$nb_f=as.environment(as.list(labargs$nb_f))
   labargs2$tifull=tifull2
   labargs2$jx_f=new.env()
   labargs2$nb_f$ipf2ircumo=nb_f$ipf2ircumo2
   labargs2$nb_f$tifu=nb_f$tifu2
   labargs[["labargs2"]]=labargs2
}

# formated output in kvh file
fkvh_saved=file.path(dirw, sprintf("%s_res.kvh", baseshort))
control_ftbl=list(`default`=list(`maxit`=50))
retcode=numeric(nseries)
cl_type="PSOCK"
cl=NULL
if ((case_i && (time_order %in% c("1,2", "2"))) || sensitive == "mc") {
   if (np > 1L) {
      # prepare cluster
      nodes=if (sensitive == "mc") np else 2

      # prepare cluster
      cl=makeCluster(nodes, cl_type) #, outfile="cl.log")
#cat("make cluster=")
#print(cl[[1]])
      labargs[["cl"]]=cl
      nodes=length(cl)
      if (TIMEIT) {
         cat("cl expor: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
      clusterExport(cl, c("lsi_fun", "df_dffp", "lab_sim", "is.diff", "lab_resid", "ui", "ci", "ep", "cp", "control_ftbl", "methods", "sln", "labargs", "dirr", "emu", "%stm%", "case_i", "time_order"))
      if (TIMEIT) {
         cat("cl sourc: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
      clusterEvalQ(cl, {
         #idth=myinfo$id
         suppressPackageStartupMessages(library(nnls))
         suppressPackageStartupMessages(library(slam)) # for quick sparse matrices
         suppressPackageStartupMessages(library(Rcpp))
         suppressPackageStartupMessages(library(RcppArmadillo))
         suppressPackageStartupMessages(library(rmumps))
         suppressPackageStartupMessages(library(arrApply)) # for fast apply() on arrays
         suppressPackageStartupMessages(library(multbxxc))
         compiler::enableJIT(0)
         source(file.path(dirr, "tools_ssg.R"))
         source(file.path(dirr, "nlsic.R"))
         source(file.path(dirr, "opt_cumo_tools.R"))
         source(file.path(dirr, "opt_icumo_tools.R"))
         #loadcmp(file.path(dirr, "tools_ssg.Rc"))
         #loadcmp(file.path(dirr, "nlsic.Rc"))
         #loadcmp(file.path(dirr, "opt_cumo_tools.Rc"))
         #loadcmp(file.path(dirr, "opt_icumo_tools.Rc"))
         labargs$spa=sparse2spa(labargs$spa)
         if (case_i && (time_order == "2" || time_order == "1,2")) {
            labargs$labargs2$spa=labargs$spa
         }
#cat("evalQ idth=", idth, "\n")
#print(labargs)
#print(labargs$labargs2)
#print(labargs$spa)
#print(labargs$labargs2$spa)
         NULL
      })
      clusterSetRNGStream(cl)
      # set worker id
      idw=parLapply(cl, seq_along(cl), function(i) assign("idw", i, envir=.GlobalEnv))
   } else {
      labargs$cl=NULL
   }
}
for (irun in seq_len(nseries)) {
   if (TIMEIT) {
      cat(sprintf("run %4d: %s cpu=%g\n", irun, format(Sys.time()), proc.time()[1], "\n", sep=""), file=fclog)
   }
   param[nm_pseries]=pstart[nm_pseries, irun]
#browser()
   # prepare kvh file name
   if (nseries > 1) {
      runsuf="." %s+% colnames(pstart)[irun]
   } else {
      runsuf=""
   }
   if (length(nseries) > 0) {
      cat("Starting point", runsuf, "\n", sep="", file=fclog)
   }
   fkvh=file(substring(fkvh_saved, 1, nchar(fkvh_saved)-4) %s+% runsuf %s+% ".kvh", "w");

   # remove zc inequalities from previous runs
   izc=grep("^zc ", nm_i)
   if (length(izc)) {
      ui=ui[-izc,,drop=FALSE]
      ci=ci[-izc]
      nm_i=rownames(ui)
   }
   # check if initial approximation is feasible
   ineq=as.numeric(ui%*%param-ci)
   names(ineq)=rownames(ui)
   # set tolerance for inequality
   tol_ineq=if ("BFGS" %in% methods) 0. else 1.e-10
   nbad=sum(ineq <= -tol_ineq)
   if (nbad > 0) {
      cat("The following ", nbad, " inequalities are not respected at starting point", runsuf, ":\n", sep="", file=fclog)
      i=ineq[ineq<= -tol_ineq]
      cat(paste(names(i), i, sep="\t", collapse="\n"), "\n", sep="", file=fclog)
      # put them inside
      capture.output(pinside <- put_inside(param, ui, ci), file=fclog)
      if (any(is.na(pinside))) {
         if (!is.null(attr(pinside, "err")) && attr(pinside, "err")!=0) {
            # fatal error occured
            cat("put_inside", runsuf, ": ", attr(pinside, "mes"), "\n",
               file=fcerr, sep="")
            close(fkvh)
            retcode[irun]=attr(pinside, "err")
            next;
         }
      } else if (!is.null(attr(pinside, "err")) && attr(pinside, "err")==0) {
         # non fatal problem
         cat(paste("put_inside: ", attr(pinside, "mes"), collapse=""), "\n", file=fcerr)
      }
      param[]=pinside
   }

   # prepare zero crossing strategy
   # inequalities to keep sens of net flux on first call to opt_wrapper()
   # if active they are removed on the second call to opt_wrapper()
   # and finaly all zc constraints are relaxed on the last call to opt_wrapper()
   fallnx=param2fl(param, labargs)$fallnx
   mi_zc=NULL
   li_zc=NULL
   if (zerocross && length(grep("^[df]\\.n\\.", nm_fallnx))>0) {
      if (TIMEIT) {
         cat("zc ineq : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
#browser()
      # prepare fluxes that are already in inequalities in alone mode
      ige=names(which(apply(mi, 1L, function(v) diff(range(v))==1 && sum(v)==1) & li>=0))
      ige=nm_dfn[unique(c(
         sub("^n:.+<=(.+)$", "\\1", grep("^n:.+<=.+$", ige, v=T)),
         sub("^[df]\\.n\\.(.+)>=.+$", "\\1", grep("^[df]\\.n\\..+>=.+$", ige, v=T)),
         sub("^inout [df]\\.n\\.(.+)>=.+$", "\\1", grep("^inout [df]\\.n\\..+>=.+$", ige, v=T))
      ))]
      ile=which(apply(mi, 1L, function(v) diff(range(v))==1 && sum(v)==-1)&li>=0)
      ile=nm_dfn[unique(c(
         sub("^n:.+<=(.+)$", "\\1", grep("^n:.+<=.+$", ile, v=T)),
         sub("^[df]\\.n\\.(.+)>=.+$", "\\1", grep("^[df]\\.n\\..+>=.+$", ile, v=T)),
         sub("^inout [df]\\.n\\.(.+)>=.+$", "\\1", grep("^inout [df]\\.n\\..+>=.+$", ile, v=T))
      ))]
      # add lower limits on [df].net >= zc for positive net fluxes
      # and upper limits on [df].net <= -zc for negative net fluxes
      nm_izc=c()
      ipos=setdiff(names(which(fallnx[grep("^[df]\\.n\\.", nm_fallnx)]>=0.)), ige)
      ineg=setdiff(names(which(fallnx[grep("^[df]\\.n\\.", nm_fallnx)]<0.)), ile)
      mi_zc=matrix(0, nrow=length(ipos)+length(ineg), ncol=nb_fallnx)
      colnames(mi_zc)=nm_fallnx
      if (length(ipos)) {
         nm_izc=c(nm_izc, paste("zc ", ipos, ">=", zc, sep=""))
         mi_zc[(1:length(ipos)),ipos]=diag(1., length(ipos))
      }
      if (length(ineg)) {
         nm_izc=c(nm_izc, paste("zc ", ineg, "<=", -zc, sep=""))
         mi_zc[length(ipos)+(1:length(ineg)),ineg]=diag(-1., length(ineg))
      }
      rownames(mi_zc)=nm_izc
      li_zc=rep(zc, length(nm_izc)) # that's ok for both pos and neg constraints
      ui_zc=cbind(mi_zc%*%(md%*%invAfl%stm%p2bfl+mf),
         matrix(0., nrow=nrow(mi_zc), ncol=nb_sc_tot))
      if (nb_fgr > 0) {
         ui_zc=cbind(ui_zc, mi_zc%*%((md%*%invAfl%stm%g2bfl)+mg*nb_f$mu))
      } else if (nb_poolf > 0) {
         ui_zc=cbind(ui_zc, matrix(0., nrow=nrow(mi_zc), ncol=nb_poolf))
      }
      ci_zc=li_zc-mi_zc%*%mic
      # remove constant inequalities
      if (ncol(ui_zc)) {
         zi=apply(ui_zc,1,function(v){return(max(abs(v))<=1.e-14)})
      } else {
         # remove all flux inequalities as there is no free params
         zi=rep(TRUE, nrow(ui_zc))
      }

      inotsat=ci_zc[zi]>tol_ineq
      if (any(inotsat)) {
         cat("Warning: The following constant zc inequalities are not satisfied:\n", file=fcerr)
         cat(nm_izc[zi][inotsat], sep="\n", file=fcerr)
      }
      ui_zc=ui_zc[!zi,,drop=FALSE]
      ci_zc=ci_zc[!zi]
      nm_izc=nm_izc[!zi]
      mi_zc=mi_zc[!zi,,drop=FALSE]

      # remove redundant/contradictory inequalities
      nb_zc=nrow(ui_zc)
      nb_i=nrow(ui)
      ired=c()
      tui=t(ui)
      uzcd=sapply(seq_len(nb_zc), function(i) apply(abs(tui-ui_zc[i,]), 2L, max))
      uzcs=sapply(seq_len(nb_zc), function(i) apply(abs(tui+ui_zc[i,]), 2L, max))
      czcd=abs(outer(abs(ci), abs(ci_zc), "-"))
      ired=which(apply((uzcd < tol_ineq | uzcs < tol_ineq) & czcd <= 1.e-2, 2, any))
      
      if (length(ired) > 0L) {
         # remove all ired inequalities
         cat("The following ", length(ired), " zerocross inequalities are redundant and are removed:\n", paste(nm_izc[ired], collapse="\n"), "\n", sep="", file=fclog)
         ui_zc=ui_zc[-ired,,drop=FALSE]
         ci_zc=ci_zc[-ired]
         nm_izc=nm_izc[-ired]
         mi_zc=mi_zc[-ired,,drop=FALSE]
      }
      if (nrow(ui_zc)) {
         # add zc inequalities
         ui=rbind(ui, ui_zc)
         ci=c(ci, ci_zc)
         nm_i=c(nm_i, nm_izc)
      }
      rm(ui_zc, ci_zc, uzcd, uzcs, czcd)
   }
   rres=NULL

   # set initial scale values to sum(measvec*simlab/dev**2)/sum(simlab**2/dev**2)
   # for corresponding measurements
   if (nb_sc_tot > 0) {
      if (optimize) {
         if (TIMEIT) {
            cat("res esti: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         capture.output(rres <- lab_resid(param, cjac=FALSE, labargs), file=fclog)
         if (!is.null(rres$err) && rres$err) {
            cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
            close(fkvh)
            retcode[irun]=rres$err
            next
         }
         if (sum(is.infinite(rres$res))) {
            cat("Infinite values appeared in residual vector (at init scale values)", file=fcerr)
            retcode[irun]=1
            close(fkvh)
            next
         }
         for (iexp in seq_len(nb_exp)) {
            simlab=jx_f$usimlab[[iexp]]
            measinvvar=1./measurements$dev$labeled[[iexp]]**2
            ms=measvec[[iexp]]*simlab*measinvvar
            ss=simlab*simlab*measinvvar
            # get only valid measurements
            iva=!is.na(ms)
            for (i in nb_ff+nb_sc_base[iexp]+seq_len(nb_sc[[iexp]])) {
               im=(ir2isc[[iexp]]==(i+1)) & iva
               if (sum(im) < 2) {
                  mes=sprintf("scaling: no sufficient valid data for scaling factor '%s'\n", nm_par[i])
                  stop_mes(mes, fcerr)
               }
               param[i]=sum(ms[im])/sum(ss[im])
            }
         }
      } else {
         # if no optimization, set all scaling params to 1.
         param[nb_ff+seq_len(nb_sc_tot)]=1.
      }
   }

#browser()
   # see if there are any active inequalities at starting point
   ineq=as.numeric(ui%*%param-ci)
   names(ineq)=rownames(ui)
   nbad=sum(abs(ineq)<=tol_ineq)
   if (nbad > 0) {
      cat("The following ", nbad, " ineqalitie(s) are active at starting point", runsuf, ":\n",
         paste(names(ineq[abs(ineq)<=tol_ineq]), collapse="\n"), "\n", sep="", file=fclog)
   }

   if (TIMEIT) {
      cat("kvh init: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
   }

   cat("influx\n", file=fkvh)
   cat("\tversion\t", vernum, "\n", file=fkvh, sep="")
   cat("\tlabeling\t", if (case_i) "instationary" else "stationary", "\n", file=fkvh, sep="")
   # save options of command line
   cat("\truntime options\n", file=fkvh)
   cat("\t\tTIMEIT=TRUE\n", file=fkvh)
   
   obj2kvh(R.Version(), "R.Version", fkvh, indent=1)
   cat("\tR command line\n", file=fkvh)
   obj2kvh(opts, "opts", fkvh, indent=2)
   cat("\t\texecution date	", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fkvh)

   # resume system sizes
   obj2kvh(nb_sys, "system sizes", fkvh)

   # save initial param
   cat("starting point\n", file=fkvh)
   names(param)=nm_par
   obj2kvh(param, "starting free parameters", fkvh, indent=1)
#browser()
   if (!length(rres)) {
      capture.output(rres <- lab_resid(param, cjac=FALSE, labargs), file=fclog)
      if (!is.null(rres$err) && rres$err) {
         cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
         close(fkvh)
         retcode[irun]=rres$err
         next
      }
      if (sum(is.infinite(rres$res))) {
         cat("Infinite values appeared in residual vector (at starting point)", file=fcerr)
         retcode[irun]=1
         close(fkvh)
         next
      }
   }
   rcost=if (length(rres$res) && !all(ina <- is.na(rres$res))) sum(crossprod(rres$res[!ina])) else NA
   obj2kvh(rcost, "starting cost value", fkvh, indent=1)

   obj2kvh(Afl, "flux system (Afl)", fkvh, indent=1)
   fg=numeric(nb_f$nb_fgr)
   names(fg)=nm_list$fgr
   if (nb_f$nb_fgr > 0) {
      fg[paste("g.n.", substring(nm_list$poolf, 4), "_gr", sep="")]=nb_f$mu*param[nm_list$poolf]
   }
   btmp=as.numeric(p2bfl%stm%param[seq_len(nb_f$nb_ff)]+bp+g2bfl%stm%fg)
   names(btmp)=dimnames(Afl)[[1]]
   obj2kvh(btmp, "flux system (bfl)", fkvh, indent=1)

   #cat("mass vector:\n", file=fclog)
   #print_mass(x)

   names(param)=nm_par

#browser()
   if (optimize && nb_ff+nb_poolf > 0L) {
      if (!(least_norm || sln || !"nlsic" %in% methods)) {
         # check if at starting position all fluxes can be resolved
         if (TIMEIT) {
            cat("check ja: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         rres=lab_resid(param, cjac=TRUE, labargs)
         if (sum(is.infinite(rres$res))) {
            cat("Infinite values appeared in residual vector (at identifiability check)", file=fcerr)
            retcode[irun]=1
            close(fkvh)
            next
         }
         if (any(is.infinite(rres$jacobian))) {
            cat("Infinite values appeared in Jacobian (at identifiability check)", file=fcerr)
            retcode[irun]=1
            close(fkvh)
            next
         }
         qrj=qr(jx_f$dr_dff, LAPACK=T)
         d=diag(qrj$qr)
         qrj$rank=sum(abs(d)>abs(d[1])*1.e-10)
         if (is.na(qrj$rank)) {
            cat("Rank of starting jacobian could not be estimated.", file=fcerr)
            retcode[irun]=1
            close(fkvh)
            next
         }
         if (qrj$rank) {
            nm_uns=nm_ff[qrj$pivot[-(1:qrj$rank)]]
         } else {
            nm_uns=nm_ff
         }
         if (qrj$rank < nb_ff) {
            # Too bad. The jacobian of free fluxes is not of full rank.
            dimnames(jx_f$dr_dff)[[2]]=c(nm_ffn, nm_ffx)
            fname="dbg_dr_dff_singular" %s+% runsuf %s+% ".csv"
            cat(sprintf("Provided measurements (labeling and fluxes) are not sufficient to resolve all free fluxes.\nUnsolvable fluxes may be:\n%s\nJacobian dr_dff is written in the result kvh file.\n",
               paste(nm_uns, sep=", ", collapse=", ")),
               file=fcerr)
            obj2kvh(jx_f$dr_dff, "Jacobian dr_dff", fkvh, indent=0)
            close(fkvh)
            retcode[irun]=1
            next
         }
      }
      if (TIMEIT) {
         cat("optim   : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
      # pass control to the chosen optimization method
      if (time_order=="1,2")
         labargs$time_order="1" # start with order 1, later continue with 2
      for (method in methods) {
         capture.output(res <- opt_wrapper(param, measurements, jx_f, labargs), file=fclog)
         if ((!is.null(res$err) && res$err) || is.null(res$par)) {
            cat("error in first optimization pass", runsuf, ": ", res$mes, "\n", sep="", file=fcerr)
            res$par=rep(NA, length(param))
            res$cost=NA
         } else if (!is.null(res$mes) && nchar(res$mes)) {
            cat("warning in first optimization pass", runsuf, ": ", res$mes, "\n", sep="", file=fcerr)
         }
         if (any(is.na(res$par))) {
            res$retres$jx_f=NULL # to avoid writing of huge data
            obj2kvh(res, "failed first pass optimization process information", fkvh)
            cat("Optimization failed", runsuf, "\n", file=fcerr, sep="")
            close(fkvh)
            retcode[irun]=max(res$err, 1)
            next
         }
         param=res$par
   #browser()
         if (zerocross && !is.null(mi_zc)) {
            if (TIMEIT) {
               cat("secondzc: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
            }
            # inverse active "zc" inequalities
            nm_inv=names(which((ui%*%res$par-ci)[,1]<=tol_ineq))
            i=grep("^zc ", nm_inv, v=T)
            if (length(i) > 0) {
               i=str2ind(i, nm_i)
               cat("The following inequalities are active after first pass
   of zero crossing strategy and will be inverted", runsuf, ":\n", paste(nm_i[i], collapse="\n"), "\n", sep="", file=fclog)
               ipos=grep(">=", nm_i[i], v=T)
               ineg=grep("<=", nm_i[i], v=T)
               ui[i,]=-ui[i,,drop=FALSE]
               if (length(ipos)) {
                  ipzc=str2ind(ipos, nm_izc)
                  ipos=str2ind(ipos, nm_i)
                  ci[ipos]=as.numeric(zc+mi_zc[ipzc,,drop=FALSE]%*%mic)
                  nm_i[ipos]=sub(">=", "<=-", nm_i[ipos])
               }
               if (length(ineg)) {
                  inzc=str2ind(ineg, nm_izc)
                  ineg=str2ind(ineg, nm_i)
                  ci[ineg]=as.numeric(zc+mi_zc[inzc,,drop=FALSE]%*%mic)
                  nm_i[ineg]=sub("<=-", ">=", nm_i[ineg])
               }
               rownames(ui)=nm_i
               names(ci)=nm_i
               # enforce new inequalities
               reopt=TRUE
               capture.output(pinside <- put_inside(res$par, ui, ci), file=fclog)
               if (any(is.na(pinside))) {
                  if (!is.null(attr(pinside, "err")) && attr(pinside, "err")!=0) {
                     # fatal error occured, don't reoptimize
                     cat(paste("put_inside", runsuf, ": ", attr(pinside, "mes"), "\n", collapse=""), file=fcerr)
                     reopt=FALSE
                  }
               } else if (!is.null(attr(pinside, "err")) && attr(pinside, "err")==0){
                  # non fatal problem
                  cat(paste("put_inside", runsuf, ": ", attr(pinside, "mes"), "\n", collapse=""), file=fcerr)
               }
               # reoptimize
               if (reopt) {
                  cat("Second zero crossing pass", runsuf, "\n", sep="", file=fclog)
                  capture.output(reso <- opt_wrapper(pinside, measurements, new.env(), labargs), file=fclog)
                  if (reso$err || is.null(reso$par)) {
                     cat("second zero crossing pass: ", reso$mes, "\n", sep="", file=fcerr)
                  } else if (!is.null(reso$mes) && nchar(reso$mes)) {
                     cat("second zero crossing pass", runsuf, ": ", reso$mes, "\n", sep="", file=fcerr)
                  }
                  if(!reso$err && !is.null(reso$par) && !any(is.na(reso$par))) {
                     param=reso$par
                     res=reso
                     jx_f=labargs$jx_f
                  }
                  if (any(is.na(reso$par))) {
                     reso$retres$jx_f=NULL # to avoid writing of huge data
                     obj2kvh(reso, "failed second pass optimization process information", fkvh)
                     cat("Second zero crossing pass failed. Keep free parameters from previous pass", runsuf, "\n", file=fcerr, sep="")
                  }
               }
               # last pass, free all zc constraints
               i=grep("^zc ", nm_i)
               if (length(i) > 0) {
                  if (TIMEIT) {
                     cat("last zc : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
                  }
                  ui=ui[-i,,drop=FALSE]
                  ci=ci[-i]
                  nm_i=nm_i[-i]
                  cat("Last zero crossing pass (free of zc constraints)", runsuf, "\n", sep="", file=fclog)
                  capture.output(reso <- opt_wrapper(param, measurements, new.env(), labargs), file=fclog)
                  if (reso$err || is.null(reso$par) || (!is.null(res$mes) && nchar(res$mes))) {
                     cat("last zero crossing (free of zc)", runsuf, ": ", reso$mes, "\n", sep="", file=fcerr)
                  }
                  if(!reso$err && !is.null(reso$par) && !any(is.na(reso$par))) {
                     param=reso$par
                     res=reso
                     jx_f=labargs$jx_f
                  }
                  if (any(is.na(res$par))) {
                     res$retres$jx_f=NULL # to avoid writing of huge data
                     obj2kvh(res, "failed last pass optimization process information", fkvh)
                     cat("Last zero crossing pass failed. Keep free parameters from previous passes", runsuf, "\n", file=fcerr, sep="")
                  }
               }
            } else {
               cat("After the first optimization, no zero crossing inequality was activated. So no reoptimization", runsuf, "\n", sep="", file=fclog)
            }
         } # end if zero crossing
      } # for method
      param=res$par
      names(param)=nm_par
      if (excl_outliers != F) {
         # detect outliers
         if (TIMEIT) {
            cat("outliers: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         iva=!is.na(res$res)
         zpval=rz.pval.bi(res$res)
         iout=which(zpval <= excl_outliers & iva)
         #cat("iout=", iout, "\n", file=fclog)
         if (length(iout)) {
            measurements$outlier=iout
            outtab=cbind(residual=res$res[iout], `p-value`=zpval[iout])
            row.names(outtab)=nm_resid[iout]
            cat("Excluded outliers at p-value ", excl_outliers, ":\n", sep="", file=fclog)
            write.table(outtab, file=fclog, append=TRUE, quote=FALSE, sep="\t", col.names=FALSE)
            
            # optimize with the last method from methods
            capture.output(reso <- opt_wrapper(param, measurements, new.env(), labargs), file=fclog)
            if (reso$err || is.null(reso$par) || (!is.null(reso$mes) && nchar(reso$mes))) {
               cat("wo outliers: ", reso$mes, "\n", sep="", file=fcerr)
            }
            if (any(is.na(reso$par))) {
               cat("Optimization with outliers excluded has failed, run= ", runsuf, "\n", file=fcerr, sep="")
               # continue without outlier exclusion
               measurements$outlier=NULL
            } else {
               res=reso
               param=reso$par
               names(param)=nm_par
               jx_f=labargs$jx_f
               labargs$measurements=measurements # store outliers
               obj2kvh(outtab, "excluded outliers", fkvh)
            }
         } else {
            cat("Outlier exclusion at p-value "%s+%excl_outliers%s+%" has been requested but no outlier was detected at this level.", "\n", sep="", file=fcerr)
         }
      }
      if (case_i && time_order=="1,2") {
         if (TIMEIT) {
            cat("order 2 : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
         }
         labargs$time_order="2" # continue with the 2-nd order
         capture.output(reso <- opt_wrapper(param, measurements, new.env(), labargs), file=fclog)
         if (reso$err || is.null(reso$par) || (!is.null(reso$mes) && nchar(reso$mes))) {
            cat("order2: ", reso$mes, "\n", sep="", file=fcerr)
         }
         if (any(is.na(reso$par))) {
            cat("Optimization time_order 2 (in '1,2' suite) has failed, run=", runsuf, "\n", file=fcerr, sep="")
         } else {
            res=reso
            param=reso$par
            names(param)=nm_par
            jx_f=labargs$jx_f
         }
      }
#browser()
      optinfo=list(
         "fitted parameters"=param,
         "last increment before backtracking"=res$lastp,
         "last increment after backtracking"=res$laststep,
         "iteration number"=res$it,
         "convergence history"=res$hist,
         "exit message"=res$mes
      )
      obj2kvh(optinfo, "optimization process information", fkvh)
      rres=res$retres
   } else {
      rres=lab_resid(param, TRUE, labargs)
   }
   if (TIMEIT) {
      cat("postopt : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
   }
   # active constraints
   ine=as.numeric(abs(ui%*%param-ci))<tol_ineq
   if (any(ine)) {
      obj2kvh(nm_i[ine], "active inequality constraints", fkvh)
   }
   poolall[nm_poolf]=param[nm_poolf]

#browser()
   if (is.null(jx_f$jacobian)) {
      # final jacobian calculation
      capture.output(rres <- lab_resid(param, cjac=TRUE, labargs), file=fclog)
      if (!is.null(rres$err) && rres$err) {
         cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
         close(fkvh)
         retcode[irun]=rres$err
         next
      }
   }
   rcost=cumo_cost(param, labargs, rres)
   pres[,irun]=param
   costres[irun]=rcost
   obj2kvh(rcost, "final cost", fkvh)
#browser()
   # get z p-values on residual vector
   zpval=rz.pval.bi(rres$res)
   resid=list()
   if (sum(nb_meas)) {
      resid[["labeled data"]]=lapply(seq_len(nb_exp), function(iexp) if (is.matrix(jx_f$reslab[[iexp]])) jx_f$reslab[[iexp]] else cbind(residual=jx_f$reslab[[iexp]], `p-value`=zpval[seq_along(jx_f$reslab[[iexp]])]))
      names(resid[["labeled data"]])=nm_exp
   
      if (case_i) {
         resid[["labeled data p-value"]]=vector("list", nb_exp)
         names(resid[["labeled data p-value"]])=nm_exp
         for (iexp in seq_len(nb_exp)) {
            mtmp=zpval[seq_along(jx_f$reslab[[iexp]])]
            dim(mtmp)=dim(jx_f$reslab[[iexp]])
            dimnames(mtmp)=dimnames(jx_f$reslab[[iexp]])
            resid[["labeled data p-value"]][[iexp]]=mtmp
            rm(mtmp)
         }
      }
   }
   nb_reslab_tot=sum(sapply(jx_f$reslab, length))
   if (length(jx_f$resflu))
      resid[["measured fluxes"]]=cbind(residual=jx_f$resflu, `p-value`=zpval[nb_reslab_tot+seq_along(jx_f$resflu)])
   if (length(jx_f$respool))
      resid[["measured pools"]]=cbind(residual=if (is.matrix(jx_f$respool)) jx_f$respool[,1] else jx_f$respool, `p-value`=zpval[nb_reslab_tot+length(jx_f$resflu)+seq_along(jx_f$respool)])
   obj2kvh(resid, "(simulated-measured)/sd_exp", fkvh)
   rm(resid, zpval)

   # simulated measurements -> kvh
   simul=list()
#browser()
   if (case_i) {
      if (sum(nb_meas)) {
         if (addnoise) {
            simul[["labeled data"]]=lapply(seq_len(nb_exp), function(iexp) jx_f$usm[[iexp]]+rnorm(length(jx_f$usm[[iexp]]))*measurements$dev$labeled[[iexp]])
            names(simul[["labeled data"]])=nm_exp
         } else {
            simul[["labeled data"]]=jx_f$usm
         }
      }
   } else {
      if (sum(nb_meas)) {
         if (addnoise) {
            simlab=lapply(seq_len(nb_exp), function(iexp) jx_f$simlab[[iexp]]+rnorm(length(jx_f$simlab[[iexp]]))*measurements$dev$labeled[[iexp]])
            names(simlab)=nm_exp
         } else {
            simlab=jx_f$simlab
         }
         if (nb_sc_tot > 0) {
            simul[["labeled data (unscaled)"]]=jx_f$usimlab
            simul[["labeled data (scaled)"]]=simlab
         } else {
            simul[["labeled data"]]=simlab
         }
      }
   }
   if (nb_fmn) {
      if (addnoise)
         simul[["measured fluxes"]]=jx_f$simfmn+rnorm(length(jx_f$simfm))*measurements$dev$flux
      else
         simul[["measured fluxes"]]=jx_f$simfmn
   }
   if (nb_poolm) {
      if (addnoise)
         simul[["measured pools"]]=jx_f$simpool+rnorm(length(jx_f$simpool))*measurements$dev$pool
      else
         simul[["measured pools"]]=jx_f$simpool
   }
   obj2kvh(simul, "simulated measurements", fkvh)
   
   # SD -> kvh
   # get index of non null components
   iget=sapply(names(measurements$dev), function(nm) !is.null(measurements$dev[[nm]]) & nm %in% c("labeled", "flux", "pool"))
   obj2kvh(measurements$dev[iget], "measurement SD", fkvh)

   # gradient -> kvh
   if (length(jx_f$res) && !all(ina <- is.na(jx_f$res))) {
      if (any(ina)) {
         gr=2*as.numeric(crossprod(jx_f$res[!ina], jx_f$jacobian[!ina,,drop=FALSE]))
      } else {
         gr=2*as.numeric(crossprod(jx_f$res, jx_f$jacobian))
      }
      names(gr)=nm_par
      obj2kvh(gr, "gradient vector", fkvh)
   }
   colnames(jx_f$udr_dp)=nm_par
   obj2kvh(jx_f$udr_dp, "jacobian dr_dp (without 1/sd_exp)", fkvh)
   # generalized inverse of non reduced jacobian
   svj=svd(jx_f$udr_dp)
   invj=svj$v%*%(t(svj$u)/svj$d)
   dimnames(invj)=rev(dimnames(jx_f$udr_dp))
   obj2kvh(invj, "generalized inverse of jacobian dr_dp (without 1/sd_exp)", fkvh)

   labargs$getx=TRUE
   labargs$labargs2getx=TRUE
   if (fullsys) {
      nm_flist=nm_list
      nm_flist$rcumo=nm_cumo
      nm_flist$rcumo_in_cumo=match(nm_rcumo, nm_cumo)
      nb_f$cumos=nb_cumos
      nm_xi_f=c()
      xi_f=matrix(c(), ncol=nb_exp)
      dimnames(xi_f)[[1]]=nm_xi_f
      nm_flist$xi=nm_xi_f
      labargs$emu=F
      v=lab_sim(param, cjac=FALSE, labargs)
      labargs$emu=emu
      x=if (case_i) v$xf else v$x
   } else {
      v=lab_sim(param, cjac=FALSE, labargs)
      x=if (case_i) v$xf else v$x
   }

   # write some info in result kvh
   mid=cumo2mass(x)
   if (case_i) {
      mid=lapply(mid, function(m) m[sort(rownames(m)),,drop=FALSE])
   } else if (length(mid)) {
      mid=mid[sort(rownames(mid)),,drop=FALSE]
   }
   obj2kvh(mid, "MID vector", fkvh)
   
   # constrained fluxes to kvh
   obj2kvh(fallnx[nm_fc], "constrained net-xch01 fluxes", fkvh)

   fwrv=v$lf$fwrv
   fallnx=v$lf$fallnx
   flnx=v$lf$flnx
   fgr=fallnx[nm_fgr]

   # keep last jx_f in jx_f_last
#browser()
   while (sensitive=="mc") {
      if (TIMEIT) {
         cat("monte-ca: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
      }
      if (set_seed) {
         set.seed(seed)
      }
      # reference simulation corresponding to the final param
      refsim=new.env()
      for (nm_it in c("simlab", "simfmn", "simpool", "usm")) {
         assign(nm_it, jx_f[[nm_it]], envir=refsim)
      }
      # Monte-Carlo simulation in parallel way (if asked and possible)
      if (np > 1L) {
         spli=splitIndices(nmc, nodes);
         clusterExport(cl, c("param", "refsim", "runsuf", "spli"))
         #clusterEvalQ(cl, labargs$spa[[1]]$a <- NULL) # to rebuild sparse matrices on cores ## now, they are build once, at the cluster init
         cl_res=clusterEvalQ(cl, {mc_iter=TRUE; labargs$getx=FALSE; mc_res=lapply(spli[[idw]], mc_sim); rm(mc_iter); mc_res})
         mc_res=vector(nmc, mode="list")
         for (i in seq(nodes))
            mc_res[spli[[i]]]=cl_res[[i]]
         #mc_res=parLapplyLB(cl, seq_len(nmc), function(imc) cl_worker(funth=mc_sim, argth=list(imc)))
      } else {
         mc_res=lapply(seq_len(nmc), function(imc) cl_worker(funth=mc_sim, argth=list(imc)))
      }
      free_mc=sapply(mc_res, function(l) {if (class(l)=="character" || is.null(l) || is.na(l$cost) || l$err) { ret=rep(NA, nb_param+3) } else { ret=c(l$cost, l$it, l$normp, l$par) }; ret })
      if (length(free_mc)==0) {
         cat("Parallel exectution of Monte-Carlo simulations has failed.", "\n", sep="", file=fcerr)
         free_mc=matrix(NA, nb_param+2, 0)
      }
      cost_mc=free_mc[1,]
      nmc_real=nmc-sum(is.na(free_mc[4,]))
      cat("monte-carlo\n", file=fkvh)
      indent=1
      obj2kvh(cl_type, "cluster type", fkvh, indent)
      obj2kvh(avaco, "detected cores", fkvh, indent)
      avaco=max(1, avaco, na.rm=T)
      obj2kvh(min(avaco, np, na.rm=T), "used cores", fkvh, indent)
      cat("\tfitting samples\n", file=fkvh)
      indent=2
      obj2kvh(nmc, "requested number", fkvh, indent)
      obj2kvh(nmc_real, "calculated number", fkvh, indent)
      obj2kvh(nmc-nmc_real, "failed to calculate", fkvh, indent)
      # convergence section in kvh
      indent=1
      mout=rbind(round(free_mc[1:2,,drop=FALSE], 2),
         format(free_mc[3,,drop=FALSE], di=2, sci=T))
      dimnames(mout)=list(c("cost", "it.numb", "normp"), seq_len(ncol(free_mc)))
      obj2kvh(mout, "convergence per sample", fkvh, indent)
      # remove failed m-c iterations
      free_mc=free_mc[-(1:3),,drop=FALSE]
      ifa=which(is.na(free_mc[1,]))
      if (length(ifa)) {
         if (ncol(free_mc) > length(ifa)) {
            cat("Some Monte-Carlo iterations failed.", "\n", sep="", file=fcerr)
         }
         free_mc=free_mc[,-ifa,drop=FALSE]
         cost_mc=cost_mc[-ifa]
      }
      if (nmc_real <= 1) {
         cat("No sufficient Monter-Carlo samples were successfully calculated to do any statistics.", "\n", sep="", file=fcerr)
         retcode[irun]=1
         break
      }
#browser()
      rownames(free_mc)=nm_par
      
      # cost section in kvh
      cat("\tcost\n", file=fkvh)
      indent=2
      obj2kvh(mean(cost_mc), "mean", fkvh, indent)
      obj2kvh(median(cost_mc), "median", fkvh, indent)
      obj2kvh(sd(cost_mc), "sd", fkvh, indent)
      obj2kvh(sd(cost_mc)*100/mean(cost_mc), "rsd (%)", fkvh, indent)
      obj2kvh(quantile(cost_mc, c(0.025, 0.95, 0.975)), "ci", fkvh, indent)
      
      # free parameters section in kvh
      cat("\tStatistics\n", file=fkvh)
      mout=c()
      indent=2
      # param stats
      # mean
      parmean=apply(free_mc, 1, mean)
      # median
      parmed=apply(free_mc, 1, median)
#browser()
      # covariance matrix
      covmc=cov(t(free_mc))
      obj2kvh(covmc, "covariance", fkvh, indent)
      # sd
      sdmc=sqrt(diag(covmc))
      # confidence intervals
      ci_mc=t(apply(free_mc, 1, quantile, probs=c(0.025, 0.975)))
      ci_mc=cbind(ci_mc, t(diff(t(ci_mc))))
      colnames(ci_mc)=c("CI 2.5%", "CI 97.5%", "CI length")
      mout=cbind(mout, mean=parmean, median=parmed, sd=sdmc,
         "rsd (%)"=sdmc*100/abs(parmean), ci_mc)
      obj2kvh(mout, "free parameters", fkvh, indent)

      # net-xch01 stats
      fallnx_mc=apply(free_mc, 2, function(p)param2fl(p, labargs)$fallnx)
      fallnx=param2fl(param, labargs)$fallnx
      if (length(fallnx_mc)) {
         dimnames(fallnx_mc)[[1]]=nm_fallnx
         # form a matrix output
         fallout=matrix(0, nrow=nrow(fallnx_mc), ncol=0)
         # mean
#browser()
         parmean=apply(fallnx_mc, 1, mean)
         # median
         parmed=apply(fallnx_mc, 1, median)
         # covariance matrix
         covmc=cov(t(fallnx_mc))
         dimnames(covmc)=list(nm_fallnx, nm_fallnx)
         # sd
         sdmc=sqrt(diag(covmc))
         # confidence intervals
         ci_mc=t(apply(fallnx_mc, 1, quantile, probs=c(0.025, 0.975)))
         ci_mc=cbind(ci_mc, t(diff(t(ci_mc))))
         ci_mc=cbind(ci_mc, ci_mc[,3]*100/abs(parmean))
         colnames(ci_mc)=c("CI 2.5%", "CI 97.5%", "CI 95% length", "relative CI (%)")
         fallout=cbind(fallout, mean=parmean, median=parmed, sd=sdmc,
            "rsd (%)"=sdmc*100/abs(fallnx), ci_mc)
         o=order(nm_fallnx)
         obj2kvh(fallout[o,,drop=FALSE], "all net-xch01 fluxes", fkvh, indent)
         obj2kvh(covmc[o,o], "covariance of all net-xch01 fluxes", fkvh, indent)

         # fwd-rev stats
         fwrv_mc=apply(free_mc, 2, function(p)param2fl(p, labargs)$fwrv)
         dimnames(fwrv_mc)[[1]]=nm_fwrv
         fallout=matrix(0, nrow=nrow(fwrv_mc), ncol=0)
         # mean
         parmean=apply(fwrv_mc, 1, mean)
         # median
         parmed=apply(fwrv_mc, 1, median)
         # covariance matrix
         covmc=cov(t(fwrv_mc))
         dimnames(covmc)=list(nm_fwrv, nm_fwrv)
         # sd
         sdmc=sqrt(diag(covmc))
         # confidence intervals
         ci_mc=t(apply(fwrv_mc, 1, quantile, probs=c(0.025, 0.975)))
         ci_mc=cbind(ci_mc, t(diff(t(ci_mc))))
         ci_mc=cbind(ci_mc, ci_mc[,3]*100/abs(fwrv))
         dimnames(ci_mc)[[2]]=c("CI 2.5%", "CI 97.5%", "CI 95% length", "relative CI (%)")
         fallout=cbind(fallout, mean=parmean, median=parmed, sd=sdmc,
            "rsd (%)"=sdmc*100/abs(parmean), ci_mc)
         o=order(nm_fwrv)
         obj2kvh(fallout[o,,drop=FALSE], "forward-reverse fluxes", fkvh, indent)
         obj2kvh(covmc[o,o], "covariance of forward-reverse fluxes", fkvh, indent)
      }
      break
   }
#browser()
   if (length(sensitive) && nchar(sensitive) && sensitive != "mc") {
      cat(paste("Unknown sensitivity '", sensitive, "' method chosen.", sep=""), "\n", sep="", file=fcerr)
      retcode[irun]=1
   }

   if (TIMEIT) {
      cat("linstats: ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
   }
   # Linear method based on jacobian x_f
   # reset fluxes and jacobians according to param
   if (is.null(jx_f$jacobian)) {
      capture.output(rres <- lab_resid(param, cjac=TRUE, labargs), file=fclog)
      if (!is.null(rres$err) && rres$err) {
         cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
         close(fkvh)
         retcode[irun]=rres$err
         next
      }
   } # else use the last calculated jacobian

   # covariance matrix of free fluxes
   svj=svd(jx_f$jacobian)
   if (svj$d[1] == 0.) {
      i=rep(TRUE, length(svj$d))
   } else {
      i=svj$d/svj$d[1]<1.e-10
      if (all(!i) && svj$d[1]<1.e-10) {
         # we could not find very small d, take just the last
         i[length(i)]=TRUE
      }
   }
   ibad=apply(svj$v[, i, drop=FALSE], 2, which.contrib)
   ibad=unique(unlist(ibad))
   if (length(ibad) > 0) {
      cat(paste(if (nchar(runsuf)) runsuf%s+%": " else "", "Inverse of covariance matrix is numerically singular.\nStatistically undefined parameter(s) seems to be:\n",
         paste(sort(nm_par[ibad]), collapse="\n"), "\nFor more complete list, see sd columns in '/linear stats'\nin the result file.", sep=""), "\n", sep="", file=fcerr)
   }
   # "square root" of covariance matrix (to preserve numerical positive definitness)
   rtcov=(svj$u)%*%(t(svj$v)/svj$d)
   # standart deviations of free fluxes
   cat("linear stats\n", file=fkvh)

   # sd free+dependent+growth net-xch01 fluxes
   nm_flfd=c(nm_ff, nm_fgr, nm_fl)
   if (nb_ff > 0 || nb_fgr > 0) {
      i=1:nb_param
      i=c(head(i, nb_ff), tail(i, nb_fgr))
      covfl=crossprod(rtcov[, i, drop=FALSE]%mmt%(rbind(diag(nb_ff+nb_fgr), dfl_dffg)%mrv%c(rep.int(1., nb_ff), fgr)))
      dimnames(covfl)=list(nm_flfd, nm_flfd)
      sdfl=sqrt(diag(covfl))
   } else {
      sdfl=rep(0., nb_fl)
      covfl=matrix(0., nb_fl, nb_fl)
   }
   fl=c(head(param, nb_ff), fgr, flnx)
   stats_nx=cbind("value"=fl, "sd"=sdfl, "rsd"=sdfl/abs(fl))
   rownames(stats_nx)=nm_flfd
   o=order(nm_flfd)
   obj2kvh(stats_nx[o,,drop=FALSE], "net-xch01 fluxes (sorted by name)", fkvh, indent=1)
   obj2kvh(covfl[o, o], "covariance net-xch01 fluxes", fkvh, indent=1)

   # sd of all fwd-rev
   if (nb_ff > 0 || nb_fgr > 0) {
      i=1:nb_param
      i=c(head(i, nb_ff), tail(i, nb_fgr))
      covf=crossprod(tcrossprod_simple_triplet_matrix(rtcov[,i, drop=FALSE], jx_f$df_dffp%mrv%c(rep.int(1., nb_ff), head(poolall[nm_poolf], nb_fgr))))
      dimnames(covf)=list(nm_fwrv, nm_fwrv)
      sdf=sqrt(diag(covf))
   } else {
      sdf=rep(0., length(fwrv))
   }
   mtmp=cbind(fwrv, sdf, sdf/abs(fwrv))
   dimnames(mtmp)[[2]]=c("value", "sd", "rsd")
   o=order(nm_fwrv)
   obj2kvh(mtmp[o,], "fwd-rev fluxes (sorted by name)", fkvh, indent=1)
   if (nb_ff > 0 || nb_fgr > 0) {
      obj2kvh(covf, "covariance fwd-rev fluxes", fkvh, indent=1)
   }
   # pool -> kvh
   sdpf=poolall
   sdpf[]=0.

   if (nb_poolf > 0) {
      # covariance matrix of free pools
      # "square root" of covariance matrix (to preserve numerical positive definitness)
      poolall[nm_poolf]=param[nm_poolf]
      # cov poolf
      covpf=crossprod(rtcov[,nb_ff+nb_sc_tot+seq_len(nb_poolf), drop=FALSE])
      dimnames(covpf)=list(nm_poolf, nm_poolf)
      sdpf[nm_poolf]=sqrt(diag(covpf))
   }
   if (length(poolall) > 0) {
      mtmp=cbind("value"=poolall, "sd"=sdpf, "rsd"=sdpf/poolall)
      rownames(mtmp)=nm_poolall
      o=order(nm_poolall)
      obj2kvh(mtmp[o,,drop=FALSE], "metabolite pools (sorted by name)", fkvh, indent=1)
      if (nb_poolf > 0) {
         o=order(nm_poolf)
         obj2kvh(covpf[o, o], "covariance free pools", fkvh, indent=1)
      }
   }

   # khi2 test for goodness of fit
   # goodness of fit (khi2 test)
   if (length(jx_f$res)) {
      nvres=sum(!is.na(jx_f$res))
      if (nvres >= nb_param) {
         khi2test=list("khi2 value"=rcost, "data points"=nvres,
            "fitted parameters"=nb_param, "degrees of freedom"=nvres-nb_param)
         khi2test$`khi2 reduced value`=khi2test$`khi2 value`/khi2test$`degrees of freedom`
         khi2test$`p-value, i.e. P(X^2<=value)`=pchisq(khi2test$`khi2 value`, df=khi2test$`degrees of freedom`)
         khi2test$conclusion=if (khi2test$`p-value, i.e. P(X^2<=value)` > 0.95) "At level of 95% confidence, the model does not fit the data good enough with respect to the provided measurement SD" else "At level of 95% confidence, the model fits the data good enough with respect to the provided measurement SD"
         obj2kvh(khi2test, "goodness of fit (khi2 test)", fkvh, indent=1)
      } else {
         cat(sprintf("khi2: Measurement number %d is lower than parameter number %d. Khi2 test cannot be done.\n", nvres, nb_param), sep="", file=fcerr)
      }
   }
   if (prof) {
      Rprof(NULL)
   }
   close(fkvh)
   # write edge.netflux property
   fedge=file(file.path(dirw, sprintf("edge.netflux.%s%s.attrs", baseshort,  runsuf)), "w")
   cat("netflux (class=Double)\n", sep="", file=fedge)
   nm_edge=names(edge2fl)
   cat(paste(nm_edge, fallnx[edge2fl], sep=" = "), sep="\n" , file=fedge)
   close(fedge)

   # write edge.xchflux property
   fedge=file(file.path(dirw, sprintf("edge.xchflux.%s%s.attrs", baseshort,  runsuf)), "w")
   flxch=paste(".x", substring(edge2fl, 4), sep="")
   ifl=charmatch(flxch, substring(names(fallnx), 2))
   cat("xchflux (class=Double)\n", sep="", file=fedge)
   cat(paste(nm_edge, fallnx[ifl], sep=" = "), sep="\n" , file=fedge)
   close(fedge)

   # write node.log2pool property
   if (length(poolall)> 0) {
      fnode=file(file.path(dirw, sprintf("node.log2pool.%s%s.attrs", baseshort,  runsuf)), "w")
      cat("log2pool (class=Double)\n", sep="", file=fnode)
      nm_node=substring(names(poolall), 4)
      cat(paste(nm_node, log2(poolall), sep=" = "), sep="\n" , file=fnode)
      close(fnode)
   }
}
if (!is.null(cl)) {
   stopCluster(cl)
   labargs$cl=cl=NULL
}

pres=rbind(cost=costres, pres)
fco=file(file.path(dirw, sprintf("%s.pres.csv", baseshort)), open="w")
cat("row_col	", file=fco)
write.table(file=fco, pres, row.n=T, quot=F, sep="\t")
close(fco)
if (TIMEIT) {
   cat("rend    : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}

# source files from FTBL/posttreat_R
postlist=strsplit("plot_smeas.R", " *; *")[[1]]
for (post in postlist) {
   fpostR=file.path(dirw, post)
   if (file.exists(fpostR) && !isTRUE(file.info(fpostR)$isdir)) {
      source(fpostR)
   } else {
      # not found in 'dirw', try 'dirr'
      fpostR=file.path(dirr, post)
      if (file.exists(fpostR) && !isTRUE(file.info(fpostR)$isdir)) {
         source(fpostR)
      } else {
         cat(sprintf("Posttreatment R file '%s' does not exist in ftbl directory neither in influx_si one. Ignored.\n", post), file=fcerr)
      }
   }
}
xgc=gc(verbose=FALSE) # to avoid the message "Error in (function (x)  : tentative d'appliquer un objet qui n'est pas une fonction"
close(fclog)
close(fcerr)
retcode=max(retcode)
if (format(parent.frame()) == format(.GlobalEnv)) {
   q("no", status=retcode)
}
